/*
 *  routinesHSMultiResol.h
 *
 *
 *  Created by Patrick Heas on 02/12/12.
 *  Copyright 2012 INRIA. All rights reserved.
 *
 */
#include "routinesHSMultiResol.h"

#define notdef -1E30 
#define AD(n,m)  ((n < 0) ? (0) : ((n > m-1) ? (m-1) : (n)))
#define PERIOD(n,m)  ((n < 0) ? (m-1) : ((n > m-1) ? (0) : (n)))    
  	/*************************************************************************************************************/
 
	/*************************************************************************************************************/
	/**********************************      Various functions   *************************************************/
	/*************************************************************************************************************/

	/*************************************************************************************************************/
void writeLine(const CImg<double> &save,char * filename){

  ofstream ifp(filename, ios::out|ios::app);
  for (int l=0;l<save.width()-1;l++){
    ifp<<save(l)<<"\t";
  } 
  ifp<<save(save.width()-1)<<endl;;
  ifp.close();
}
CImg<double> treshold_minmax(const CImg<double> &in, double treshmin, double treshmax, double flag){

	short int nb_col=in.width();
	short int nb_lig=in.height();
	CImg<double> out(nb_col,nb_lig);
	out=in;
	for (int i=0;i<nb_lig;i++){
	  for (int j=0;j<nb_col;j++){
	    if (out(j,i)<=treshmin||out(j,i)>=treshmax){
				out(j,i)=flag;
	    }
	  }
	}
	return out;	
	
}

CImg<double> binarize(const CImg<double> &in, double tresh){

	short int nb_col=in.width();
	short int nb_lig=in.height();
	CImg<double> out(nb_col,nb_lig);
	out=in;
	for (int i=0;i<nb_lig;i++){
	  for (int j=0;j<nb_col;j++){
	    if (out(j,i)>tresh){out(j,i)=1;}
	    else{out(j,i)=0;}
	  }
	}
	return out;	
	
}
CImg<float> read_aUVFile(char * filename,int dx,int dy,int Dx,int Dy, int ofx, int ofy){
 
	int ii,jj;
	float u,v;
	FILE * file=NULL;
	char * readLine =new char[200]; 
	 
	CImg<float> im(dx,dy,2);
	CImg<float> aux(Dx,Dy, 2);
	CImg<float> aux2(Dx,Dy, 2);

	
	assert (file=fopen(filename,"r"));
	cout<<filename<<endl; 
	//fgets(readLine,100,file);
	
	for (int j=0;j<Dx;j++){
	  for (int i=0;i<Dy;i++){ 
	    fscanf(file,"%d %d %f %f\n",&jj,&ii,&u,&v);
	    aux(j,i,0)=u;
	    aux(j,i,1)=-v;
	  } 
	}
    	fclose(file);
	for (int i=0;i<Dy;i++){
	  for (int j=0;j<Dx;j++){
	    aux2(j,Dy-1-i,0)= aux(j,i,0);
	    aux2(j,Dy-1-i,1)= aux(j,i,1);
	  }
	}
	for (int i=0;i<dy;i++){
	        for (int j=0;j<dx;j++){
		  im(j,i,0)=aux2(j+ofx,i+ofy,0);
		  im(j,i,1)=aux2(j+ofx,i+ofy,1);
		}
	}

	
	delete [] readLine;

	return 	im;
}
char ** alloc_seqPath(int nbIm){
	
	char **filePaths=new char*[nbIm];
	for(int i=0;i<nbIm;i++)
		filePaths[i] =new char[500];
	return filePaths;	
}
void read_path(string ifn1, int nbIm, char ** fileIm){
	
	string line;
	ifstream inIm;
	inIm.open(ifn1.c_str(),ifstream::in);

	for (int t=0;t<nbIm;t++){
		getline(inIm,line);
		strcpy(fileIm[t],(char *)line.c_str());
		
	}
}
void maj_vecteurs(CImg<double> &X,const CImg<double> & Xin,bool divNul) {
   int nbc,nbl;
   nbl=(int)Xin.height();
   nbc=(int)Xin.width();
   
   CImgList<double> Fdiv(2,nbc,nbl,1,1);
   CImgList<double> Fcurl(2,nbc,nbl,1,1);     
   CImgList<double> Fu(2,nbc,nbl,1,1);
   CImgList<double> Fv(2,nbc,nbl,1,1);     
   CImgList<double> fx(2,nbc,nbl,1,1);  
   CImgList<double> fy(2,nbc,nbl,1,1);  
   CImgList<double> u_fft(2,nbc,nbl,1,1);  
   CImgList<double> v_fft(2,nbc,nbl,1,1);     
   CImg<double> ak(nbc,1,1,1);
   CImg<double> ak2(nbc,1,1,1);  
   CImg<double> bk(nbl,1,1,1);
   CImg<double> bk2(nbl,1,1,1);   
   Fu=Xin.get_slice(0).get_FFT(false); 
   Fv=Xin.get_slice(1).get_FFT(false); 

   
 for (int j=0;j<nbc/2+1;j++)
         {
         ak(j)  = j;
         ak2(j) = j*j;
	 }

     
 for (int j=nbc/2+1;j<nbc;j++)
         {
         int jj = nbc-j;
         ak(j)  = -ak(jj);
         ak2(j) = ak2(jj);
         }
	 
	 
 for (int j=0;j<nbl/2+1;j++)
         {
         bk(j)  = j;
         bk2(j) = j*j;
	 }

     
 for (int j=nbl/2+1;j<nbl;j++)
         {
         int jj = nbl-j;
         bk(j)  = -bk(jj);
         bk2(j) = bk2(jj);
         }	 

   for (int j=0;j<nbl;j++)
        for (int k=0;k<nbc;k++)
	    {
	  	 if (!divNul){
           	 	Fdiv[1](k,j) = (Fu[0](k,j)* ak(k) *2*M_PI/nbc +Fv[0](k,j)* bk(j) *2*M_PI/nbl );
            		Fdiv[0](k,j) = -(Fu[1](k,j)* ak(k) *2*M_PI/nbc +Fv[1](k,j)* bk(j)  *2*M_PI/nbl);
	  	 }
		else{ Fdiv[1](k,j)=0.;Fdiv[0](k,j)=0.;}
            Fcurl[1](k,j) = (Fv[0](k,j)* ak(k) *2*M_PI/nbc -Fu[0](k,j)* bk(j) *2*M_PI/nbl );
            Fcurl[0](k,j) = -(Fv[1](k,j)* ak(k) *2*M_PI/nbc -Fu[1](k,j)* bk(j) *2*M_PI/nbl );
	   }

      for (int j=1;j<nbl;j++)
        for (int k=1;k<nbc;k++)
	    {
            fx[0](k,j) = (Fdiv[1](k,j)* ak(k) -Fcurl[1](k,j)* bk(j) )/ (ak2(k)+bk2(j));
	    fx[1](k,j) = (Fcurl[0](k,j)* bk(j)- Fdiv[0](k,j)* ak(k) )/ (ak2(k)+bk2(j));
	    
	    
            fy[0](k,j) =  (Fcurl[1](k,j)* ak(k)+Fdiv[1](k,j)* bk(j)) / (ak2(k)+bk2(j));
	    fy[1](k,j) =  (0.0-Fdiv[0](k,j)* bk(j)-Fcurl[0](k,j)* ak(k)) / (ak2(k)+bk2(j));
             }
	     
      for (int j=1;j<nbl;j++)
         {
         fx[0](0,j) = 0.0-bk(j)*Fcurl[1](0,j) / bk2(j);
	 fx[1](0,j) = bk(j)*Fcurl[0](0,j) / bk2(j);
	 fy[0](0,j) =  bk(j)*Fdiv[1](0,j) / bk2(j); 
	 fy[1](0,j) = 0.0-  bk(j)*Fdiv[0](0,j) / bk2(j);         
         }
	 
      for (int j=1;j<nbc;j++)
         {	 
         fy[0](j,0) = ak(j)*Fcurl[1](j,0) / ak2(j);   
         fy[1](j,0) = 0.0-ak(j)*Fcurl[0](j,0) / ak2(j); 
	 
	 fx[0](j,0) =  ak(j)*Fdiv[1](j,0) / ak2(j);   
         fx[1](j,0) =  0.0- ak(j)*Fdiv[0](j,0) / ak2(j);   	 
	 }  
fx[0](0,0)=0.0;
fy[0](0,0)=0.0;      
fx[1](0,0)=0.0;
fy[1](0,0)=0.0;
  
   u_fft=fx.get_FFT(true);
   v_fft=fy.get_FFT(true);    
 
   FillChannel(X ,u_fft[0]*sqrt(nbl*nbc)/(2*M_PI),0);
   FillChannel(X ,v_fft[0]*sqrt(nbl*nbc)/(2*M_PI),1);

   
}
CImg<double> divImOrder2(const CImg<double> &im){
        float pixelScale=1;
	int dx=im.width();
	int dy=im.height();
	
	CImg<double> divIm(dx,dy);
	CImg<float> Ux(dx,dy);CImg<float> Vy(dx,dy);
	CImg<float> u(dx,dy);
	CImg<float> v(dx,dy);	

	/*-- filtre gradiant --*/
	CImg<float> filtre_GX2(3,1);
		
		filtre_GX2(0,0)=1.0;
		filtre_GX2(1,0)=0.0;
		filtre_GX2(2,0)=-1.0;
		
	 
  	CImg<float> filtre_GY2(1,3);
		filtre_GY2=filtre_GX2.get_transpose();
		
	float normCst=0.5/pixelScale;
	
			
	u=im.get_slice(0);
	v=im.get_slice(1);
	Ux=u.get_convolve(filtre_GX2,1,false);		
	Ux*=normCst;
	Vy=v.get_convolve(filtre_GY2,1,false);
	Vy*=normCst;
	for (int i=0;i<dx;i++){
	   for (int j=0;j<dy;j++){	
	   	divIm(i,j)=Vy(i,j)+Ux(i,j);
	   }
	}	
	
	return divIm;
}
void expand_dim(int nb_col,int nb_lig,int resol,int *nouv_nb_col,int *nouv_nb_lig)
{
  int partie_entiere,reste,test=1,i,lim;
  lim = resol ;
  for(i=0;i<lim;i++){
    test = test * 2;
  }
  /*printf("lim = %d\tdivision=%d\n",lim,test);*/
  reste = nb_col % test;
  if(reste !=0){
    partie_entiere = (short) (nb_col / test);
    *(nouv_nb_col) = test * (partie_entiere +1);
  }
  else{*(nouv_nb_col) = nb_col;}

  reste = nb_lig % test;
  if(reste !=0){
    partie_entiere = (short) (nb_lig / test);
    *(nouv_nb_lig) = test * (partie_entiere +1);
  }
  else{*(nouv_nb_lig) = nb_lig;}

}

CImg<double> expand(const CImg<double> &imOrig,int nbResol){
  
  int dx,dy;
  int dxOrig=imOrig.width();
  int dyOrig=imOrig.height();
  int dz=imOrig.depth();
  expand_dim(dxOrig,dyOrig,nbResol,&dx,&dy);  
  CImg<double> im(dx,dy,dz);
  im.fill(0.);
  for (int k=0;k<dz;k++){
    for (int i=0;i<dyOrig;i++){
      for (int j=0;j<dxOrig;j++){
	im(j,i,k)=imOrig(j,i,k);
      }
    }
  }
  return im;
}
CImg<short> read_pgm(char *nom,int dx,int dy,int ofx,int ofy){

  FILE *im;
  im=fopen(nom,"rb");
  char comm;
  char t1[1000];
  int def;
  long int position;
  short *nb_col=new short[1];
  short *nb_lig=new short[1];
  
  /*header*/ 
  fgets(t1,1000,im); 
  fscanf(im,"%c",&comm);
  while(comm == '#'){
    fgets(t1,1000,im);
    fscanf(im,"%c",&comm);
  }
  position=(long int)(ftell(im)-1);
  fseek(im,position,0);  
  fscanf(im,"%hd %hd\n%d\n",nb_col,nb_lig,&def);
  
  int Dx=*nb_col;
  CImg<short> image(dx,dy);
  /*body*/ 
  if(def==255){
  	char *imInt;
  	imInt=(char*)calloc(*nb_col*(*nb_lig),sizeof(char));
   	fread(imInt,sizeof(char),*nb_col*(*nb_lig),im);
	for (int i=0;i<dx;i++){
	  for (int j=0;j<dy;j++){
		image(i,j)=(short)(unsigned char)imInt[i+ofx+(j+ofy)*Dx];
	  }
	}
	free(imInt);
  }
  else{
    if (def == 1023){
         fseek(im,position,0);  
	 fgets(t1,1000,im);
 	 fgets(t1,1000,im);
	unsigned short *imInt;
	imInt=(unsigned short*)calloc(*nb_col*(*nb_lig),sizeof(unsigned short));
      	fread (imInt, sizeof(unsigned short), *nb_col*(*nb_lig), im );
	for (int i=0;i<dx;i++){
	  for (int j=0;j<dy;j++){
		image(i,j)=imInt[i+ofx+(j+ofy)*Dx];
	  }
	}
	free(imInt);    
    }
    else{ 
    	printf("Can't read images %s UVolution problem def=%d (255 ou 1023)!",nom,def);
    	exit(1);
    }
  }
  fclose(im);
  delete [] nb_col; delete [] nb_lig;
  return image;  
}
 void write_pgm255(const CImg<double> &in,char * filename, float min, float max){
	
	int dx=in.width(); 
	int dy=in.height();
	CImg <double> im(dx,dy);
	im=in;
	FILE * pgmfile=NULL;
	assert (pgmfile=fopen(filename,"wb"));
	fprintf (pgmfile,"P5\n");	
	fprintf (pgmfile,"%d %d\n255\n",dx,dy);		
	unsigned char *aux=new unsigned char[dx*dy];
        

	for (int i=0;i<dx;i++){
		for (int j=0;j<dy;j++){
			if(im(i,j)>max){im(i,j)=max;}
			if(im(i,j)<min){im(i,j)=min;}
		}
	}

	for (int i=0;i<dx;i++){
		for (int j=0;j<dy;j++){
			aux[j*dx+i]=(unsigned char)((int)((im(i,j)-min)*(double)255./(max-min)+0.5));
		}		
	}
	
	fwrite ((char *)aux,sizeof(unsigned char) , dx*dy, pgmfile);
     	fclose (pgmfile);
	delete [] aux;

}
CImgList<double> alloc_pyramid (int nc, int coarse){
    CImgList<double> pyramid(8);
    for(int level=coarse;level>=0;level--){pyramid[level]=CImg<double>(max((int)(nc>>level)+1,2));  }
    return pyramid;
}
CImgList<double> alloc_pyramid (int nc, int nl, int nslice, int coarse){
    
    CImgList<double> pyramid(8);
    int nb_c,nb_l;
    /*-- nb_c=nb_col/2^level --*/
    nb_c=(int)nc>>coarse;
    nb_l=(int)nl>>coarse;
    for(int level=coarse;level>=0;level--){
		pyramid[level]=CImg<double>(nb_c,nb_l,nslice);
		nb_c=nb_c<<1;
		nb_l=nb_l<<1;
    }
    return pyramid;
}
 void FillChannel(CImg<double> &out , const  CImg<double> & im, int band){
	int dx=im.width();
	int dy=im.height();	
	for (int i=0;i<dy;i++){
		for (int j=0;j<dx;j++){
			out(j,i,band)=im(j,i);
		}
	}
}
float * CImg2float( const CImg<double> &in){
    int dx=in.width();
    int dy=in.height();
    int dz=in.depth();
   float *out=new float[dx*dy*dz];
    for (int k=0;k<dz;k++) {
      for (int i=0;i<dy;i++) {
   	for (int j=0;j<dx;j++){
	  out[k*dx*dy+i*dx+j]= (float) in(j,i,k);
	}
      }
    }
    return out;
}
CImg<double> float2CImg(int dx, int dy, float *in){
    CImg<double> out(dx,dy);
    for (int i=0;i<dy;i++) {
    	for (int j=0;j<dx;j++){
		out(j,i)=(double) in[i*dx+j];
	}
    }
    return out;
}
CImg<double> float2CImg(int dx, int dy, int dz,float *in){
  CImg<double> out(dx,dy,dz);
    for (int k=0;k<dz;k++) {
      for (int i=0;i<dy;i++) {
    	for (int j=0;j<dx;j++){
	  out(j,i,k)=(double) in[k*dx*dy+i*dx+j];
	}
      }
    }
    return out;
}
void Copy_f(float *im1, float *im2, int nb_col, int nb_line){
    long k;
    register int i;

    k=(nb_line*nb_col);
    for (i=0;i<k;i++,im1++,im2++)
    {
	*im1= *im2;
    }
}
CImg<double> fill(const CImg<double> &a,const CImg<double> &b){
	
	int nc=a.width();
	int nl=a.height();
	CImg <double> X(nc,nl,2);

	for (int i=0; i<nl; i++){
	   for (int j=0; j<nc; j++){
		X(j,i,0)=a(j,i);X(j,i,1)=b(j,i);
	   }
	}
	return X;
}
 	/*************************************************************************************************************/

	/*************************************************************************************************************/
	/**********************************      Border conditions  *************************************************/
	/*************************************************************************************************************/

	/*************************************************************************************************************/

void setZeroBorder(CImg<double> &a,int ofx, int ofy){
	int nc=a.width();
	int nl=a.height();
	for (int i=0;i<nl;i++){
	  for (int j=0;j<nc;j++){
		if (j<ofx || j > nc-ofx -1){a(j,i)=0;}
		if (i<ofy || i > nl-ofy -1){a(j,i)=0;}
	  }
	}
		
}
void setZeroBorderOnExpandedRegion(CImg<double> &a,int dxOrig, int dyOrig){
	int nc=a.width();
	int nl=a.height();
	for (int i=0;i<nl;i++){
	  for (int j=0;j<nc;j++){
		if (j>=dxOrig||i>= dyOrig){a(j,i)=0;}
	  }
	}
		
}
/*************************************************************************************************************/
void fixPeriodConditions(int nc,int nl,CImg<double> &A1_i_1j,CImg<double> &A1_i1j,CImg<double> &A1_ij_1,CImg<double> &A1_ij1,
			CImg<double> &A1_ijnc,CImg<double> &A1_ij0,CImg<double> &A1_inlj,CImg<double> &A1_i0j){

   /*Period condition */
   for (int i=0;i<nl;i++){
	for (int j=0;j<nc;j++){
	       /* nearest-left neighbor  */
	       if (j-1<0){
			A1_ijnc(j,i)=A1_ij_1(j,i);A1_ij_1(j,i)=notdef;
	       }
	       /* nearest-right neighbor  */
	       if (j+1>=nc){ 	       		    
			A1_ij0(j,i)=A1_ij1(j,i);A1_ij1(j,i)=notdef;
	       }
	       /* nearest-up neighbor  */
	       if (i-1<0){   
			A1_inlj(j,i)=A1_i_1j(j,i);A1_i_1j(j,i)=notdef;
	       }
	       /* nearest-down neighbor  */
	       if (i+1>=nl){
			A1_i0j(j,i)=A1_i1j(j,i);A1_i1j(j,i)=notdef;
	       }
	}
   }
	       
}
/*************************************************************************************************************/
void fixNeumannConditions(int nc,int nl,CImg<double> &A1_i_1j,CImg<double> &A1_ij,CImg<double> &A1_i1j,CImg<double> &A1_ij_1,CImg<double> &A1_ij1){

   /*Neumman condition with zero derivative*/
   for (int i=0;i<nl;i++){
	for (int j=0;j<nc;j++){
	       /* nearest-left neighbor  */
	       if (j-1<0){
			A1_ij(j,i)+=A1_ij_1(j,i);A1_ij_1(j,i)=notdef;
	       }
	       /* nearest-right neighbor  */
	       if (j+1>=nc){ 	       		    
			A1_ij(j,i)+=A1_ij1(j,i);A1_ij1(j,i)=notdef;
	       }
	       /* nearest-up neighbor  */
	       if (i-1<0){   
			A1_ij(j,i)+=A1_i_1j(j,i);A1_i_1j(j,i)=notdef;
	       }
	       /* nearest-down neighbor  */
	       if (i+1>=nl){
			A1_ij(j,i)+=A1_i1j(j,i);A1_i1j(j,i)=notdef;
	       }
	}
   } 
}
/*************************************************************************************************************/
void fixDirichletConditions(int nc,int nl,CImgList<double> &A_i_lj,CImgList<double> &A_ij_l,CImgList<double> &A_ijl,CImgList<double> &A_ilj,int neta,int lo){
	
	/*Deterministe condition on boundaries*/
	for (int i=0;i<nl;i++){
		for (int l=lo;l>=neta;l--){	
			if(A_ijl[l-neta](0,i)!=notdef){A_ijl[l-neta](0,i)=0.;} 
			if(A_ij_l[l-neta](l,i)!=notdef){A_ij_l[l-neta](l,i)=0.;}
			
			if(A_ij_l[l-neta](nc-1,i)!=notdef){A_ij_l[l-neta](nc-1,i)=0.;} 
			if(A_ijl[l-neta](nc-1-l,i)!=notdef){A_ijl[l-neta](nc-1-l,i)=0.;}
			
			if(A_ilj[l-neta](0,i)!=notdef){A_ilj[l-neta](0,i)=0.;} 
			if (i+l<nl){if(A_i_lj[l-neta](0,i+l)!=notdef){A_i_lj[l-neta](0,i+l)=0.;}}
			
			if(A_i_lj[l-neta](nc-1,i)!=notdef){A_i_lj[l-neta](nc-1,i)=0.;}   
			if (i-l>=0){if(A_ilj[l-neta](nc-1,i-l)!=notdef){A_ilj[l-neta](nc-1,i-l)=0.;}}
		}
	}
	
	for (int j=0;j<nc;j++){
		for (int l=lo;l>=neta;l--){	
			if(A_ijl[l-neta](j,0)!=notdef){A_ijl[l-neta](j,0)=0.;} 
			if(j+l<nc){if(A_ij_l[l-neta](j+l,0)!=notdef){A_ij_l[l-neta](j+l,0)=0.;}}
			
			if(A_ij_l[l-neta](j,nl-1)!=notdef){A_ij_l[l-neta](j,nl-1)=0.;} 
			if(A_ijl[l-neta](j-l,nl-1)!=notdef && j-l>=0){A_ijl[l-neta](j-l,nl-1)=0.;}
			
			if(A_ilj[l-neta](j,0)!=notdef){A_ilj[l-neta](j,0)=0.;} 
			if(A_i_lj[l-neta](j,l)!=notdef){A_i_lj[l-neta](j,l)=0.;}
			
			if(A_i_lj[l-neta](j,nl-1)!=notdef){A_i_lj[l-neta](j,nl-1)=0.;} 
			if(A_ilj[l-neta](j,nl-1-l)!=notdef){A_ilj[l-neta](j,nl-1-l)=0.;}
		}
	}
	
}
	
void fixDirichletConditions(int nc,int nl,CImg<double> &A_i_1j,CImg<double> &A_ij,CImg<double> &A_i1j,CImg<double> &A_ij_1,CImg<double> &A_ij1){
	
	
	/*Deterministe condition on boundaries*/
	
	for (int j=0;j<nc;j++){
		A_ij(j,0)=1;
		A_ij1(j,0)=0;A_ij_1(j,0)=0;A_i_1j(j,0)=0;A_i1j(j,0)=0;
		A_i_1j(j,0+1)=0;
		A_ij(j,nl-1)=1;       		    
		A_ij1(j,nl-1)=0;A_ij_1(j,nl-1)=0;A_i_1j(j,nl-1)=0;A_i1j(j,nl-1)=0;
		A_i1j(j,nl-1-1)=0;
	}
	for (int i=0;i<nl;i++){
		A_ij(0,i)=1;
		A_ij1(0,i)=0;A_ij_1(0,i)=0;A_i_1j(0,i)=0;A_i1j(0,i)=0;
		A_ij_1(0+1,i)=0;
		A_ij(nc-1,i)=1;
		A_ij1(nc-1,i)=0;A_ij_1(nc-1,i)=0;A_i_1j(nc-1,i)=0;A_i1j(nc-1,i)=0;
		A_ij1(nc-1-1,i)=0;
	}
	for (int j=0;j<nc;j++){
 		for (int i=0;i<nl;i++){
 			A_i_1j(j,0)=notdef;
			A_i1j(j,nl-1)=notdef;
 			A_ij_1(0,i)=notdef;
			A_ij1(nc-1,i)=notdef;
		}
	}
	
}	
void fixDirichletConditions_cross(int nc,int nl,CImgList<double> &A_i_lj_l,CImgList<double> &A_i_ljl,CImgList<double> &A_ilj_l,CImgList<double> &A_iljl,int neta,int lo){

	/*Deterministe condition on boundaries*/
	for (int i=0;i<nl;i++){
		for (int l=lo;l>=neta;l--){	
			if(A_iljl[l-neta](0,i)!=notdef){A_iljl[l-neta](0,i)=0.;} 
			if(i+l<nl){if(A_i_lj_l[l-neta](l,i+l)!=notdef){A_i_lj_l[l-neta](l,i+l)=0.;}}
			
			if(A_i_lj_l[l-neta](nc-1,i)!=notdef){A_i_lj_l[l-neta](nc-1,i)=0.;} 
			if(i-l>=0){if(A_iljl[l-neta](nc-1-l,i-l)!=notdef){A_iljl[l-neta](nc-1-l,i-l)=0.;}}			
		}
	}
	
	for (int j=0;j<1;j++){
		for (int l=lo;l>=neta;l--){	
			if(A_iljl[l-neta](j,0)!=notdef){A_iljl[l-neta](j,0)=0.;} 
			if(j+l<nc){if(A_i_lj_l[l-neta](j+l,l)!=notdef){A_i_lj_l[l-neta](j+l,l)=0.;}}
			
			if(A_i_lj_l[l-neta](j,nl-1)!=notdef){A_i_lj_l[l-neta](j,nl-1)=0.;} 
			if(j-l >= 0){if(A_iljl[l-neta](j-l,nl-1-l)!=notdef){A_iljl[l-neta](j-l,nl-1-l)=0.;}}			
			
		}
	}
	
	for (int i=0;i<nl;i++){
		for (int l=lo;l>=neta;l--){	
			if(A_i_ljl[l-neta](0,i)!=notdef){A_i_ljl[l-neta](0,i)=0.;} 
			if(i-l >=0){if(A_ilj_l[l-neta](l,i-l)!=notdef){A_ilj_l[l-neta](l,i-l)=0.;}}
			
			if(A_ilj_l[l-neta](nc-1,i)!=notdef){A_ilj_l[l-neta](nc-1,i)=0.;} 
			if(i+l < nl){if(A_i_ljl[l-neta](nc-1-l,i+l)!=notdef){A_i_ljl[l-neta](nc-1-l,i+l)=0.;}}			
		}
	}
	for (int j=0;j<nc;j++){
		for (int l=lo;l>=neta;l--){	
			if(A_ilj_l[l-neta](j,0)!=notdef){A_ilj_l[l-neta](j,0)=0.;} 
			if(j-l >=0){if(A_i_ljl[l-neta](j-l,l)!=notdef){A_i_ljl[l-neta](j-l,l)=0.;}}
			
			if(A_i_ljl[l-neta](j,nl-1)!=notdef){A_i_ljl[l-neta](j,nl-1)=0.;} 
			if(j+l < nc){if(A_ilj_l[l-neta](j+l,nl-1-l)!=notdef){A_ilj_l[l-neta](j+l,nl-1-l)=0.;}}			
		}
	}
	
	
}
void fixDirichletConditions_cross(int nc,int nl,CImg<double> &A_ij,CImgList<double> &A_i_lj_l,CImgList<double> &A_i_ljl,CImgList<double> &A_ilj_l,CImgList<double> &A_iljl,int neta,int lo){
 	fixDirichletConditions_cross(nc,nl,A_i_lj_l,A_i_ljl,A_ilj_l,A_iljl,neta,lo);
	for (int i=0;i<nl;i++){ for (int j=0;j<nc;j++){if (j==0||i==0||j==nc-1||i==nl-1){A_ij(j,i)=0;}}}
}
/*************************************************************************************************************/
void excludeWhite(int neta,int lo,CImgList<double> &A_iljl,CImgList<double> &A_i_lj_l,CImgList<double> &A_i_ljl,CImgList<double> &A_ilj_l){
   
   int nc=A_iljl[0].width();
   int nl=A_iljl[0].height();
   /* exculsion of border elements in S2(l) calculus*/
	for (int i=0;i<nl;i++){
	  for (int j=0;j<nc;j++){
	       for (int l=neta;l<=lo;l++){
			   if (A_iljl[l-neta](j,i)==0){A_iljl[l-neta](j,i)=notdef;}
			   if (A_i_lj_l[l-neta](j,i)==0){A_i_lj_l[l-neta](j,i)=notdef;}
			   if (A_i_ljl[l-neta](j,i)==0){A_i_ljl[l-neta](j,i)=notdef;}
			   if (A_ilj_l[l-neta](j,i)==0){A_ilj_l[l-neta](j,i)=notdef;}
	       }
	  }
   }	
}	

        /*************************************************************************************************************/

	/*************************************************************************************************************/
	/*****************************************Robust  Functions***************************************************/
	/*************************************************************************************************************/

	/*************************************************************************************************************/

void Data_Out_Gen_f_QuasiTV(const CImg<double>&u,const CImg<double>&v,const CImg<double>&fx,const CImg<double>&fy,const CImg<double>&ft,float s,int nb_col,int nb_line,CImg<double> &Data_out){

  double Ecm_2=0.;
  double s_2=s*s;
  for(int i=0;i<nb_line;i++){
  	for(int j=0;j<nb_col;j++){
    		Ecm_2=(fx(j,i)*u(j,i)+fy(j,i)*v(j,i)+ft(j,i)); 
    		Ecm_2=Ecm_2*Ecm_2;
      		/*-- Estimateur 1/(2s)*sqrt(s^2+x^2) --*/
		Data_out(j,i)=1./(2.*sqrt(s_2+Ecm_2))*2.*s;
   	 }
  } 
}
/*************************************************************************************************************/
CImg <double> RobustDataCoef_QuasiTV(const CImg<double> &UV,const CImg<double> &im_x,const CImg<double> &im_y,const CImg<double> &im_t,double sigma){

	int nc=im_x.width();
	int nl=im_x.height();		
		
	/*estimateur robuste sur les donnes*/
	CImg <double> data_out(nc,nl);	
	Data_Out_Gen_f_QuasiTV(UV.get_slice(0),UV.get_slice(1),im_x,im_y,im_t,sigma,nc,nl,data_out);

return data_out;

}
/*************************************************************************************************************/

void Data_Out_Gen_f(const CImg<double>&u,const CImg<double>&v,const CImg<double>&fx,const CImg<double>&fy,const CImg<double>&ft,float sigma,int nb_col,int nb_line,CImg<double> &Data_out){

  double Ecm=0.;
  double var=sigma*sigma;
  for(int i=0;i<nb_line;i++){
  	for(int j=0;j<nb_col;j++){
    		Ecm=(fx(j,i)*u(j,i)+fy(j,i)*v(j,i)+ft(j,i)); 
    		Ecm=Ecm*Ecm;
      		/*-- Estimateur de Leclerc --*/
    		if (var!=0){Data_out(j,i)=exp(-(Ecm)/var);} 
    		else{ Data_out(j,i)=0;} /* cas du sigma nul  */
   	 }
  } 
}
/*************************************************************************************************************/
CImg <double> RobustDataCoef(const CImg<double> &UV,const CImg<double> &im_x,const CImg<double> &im_y,const CImg<double> &im_t,double sigma){

	int nc=im_x.width();
	int nl=im_x.height();		
		
	/*estimateur robuste sur les donnes*/
	CImg <double> data_out(nc,nl);	
	CImg <double> U(nc,nl); CImg <double> V(nc,nl); 
	Data_Out_Gen_f(UV.get_slice(0),UV.get_slice(1),im_x,im_y,im_t,sigma,nc,nl,data_out);

return data_out;

}
/*************************************************************************************************************/

void UpdateRobustWeight_Leclerc(const CImg<double> &UV, CImgList <double> &z, double tau,bool periodic){

  int nc=UV.width();
  int nl=UV.height();
  double x_st_U,x_st_V;
  if (!periodic){
    for (int i=0;i<nl;i++){
      for (int j=0;j<nc;j++){ 
	x_st_U=(UV(j,i,0)-UV(AD(j+1,nc),i,0));
	x_st_V=(UV(j,i,1)-UV(AD(j+1,nc),i,1));
	z[0](j,i)=(exp(-1*tau*x_st_U*x_st_U)+exp(-1*tau*x_st_V*x_st_V))/2.;
	x_st_U=(UV(j,i,0)-UV(j,AD(i+1,nl),0));
	x_st_V=(UV(j,i,1)-UV(j,AD(i+1,nl),1));
	z[1](j,i)=(exp(-1*tau*x_st_U*x_st_U)+exp(-1*tau*x_st_V*x_st_V))/2.;    
      }
    }
  }
  else{
   for (int i=0;i<nl;i++){
      for (int j=0;j<nc;j++){ 
	x_st_U=(UV(j,i,0)-UV(PERIOD(j+1,nc),i,0));
	x_st_V=(UV(j,i,1)-UV(PERIOD(j+1,nc),i,1));
	z[0](j,i)=(exp(-1*tau*x_st_U*x_st_U)+exp(-1*tau*x_st_V*x_st_V))/2.;
	x_st_U=(UV(j,i,0)-UV(j,PERIOD(i+1,nl),0));
	x_st_V=(UV(j,i,1)-UV(j,PERIOD(i+1,nl),1));
	z[1](j,i)=(exp(-1*tau*x_st_U*x_st_U)+exp(-1*tau*x_st_V*x_st_V))/2.;    
      }
    }
  }
}

/*************************************************************************************************************/

void UpdateRobustWeight_QuasiTV(const CImg<double> &UV, CImgList <double> &z, double tau,bool periodic){

  int nc=UV.width();
  int nl=UV.height();
  double x_st_U,x_st_V;
  double s=1./(2*tau);
  double s_2=s*s;
  if (!periodic){
    for (int i=0;i<nl;i++){
      for (int j=0;j<nc;j++){ 
	x_st_U=(UV(j,i,0)-UV(AD(j+1,nc),i,0));
	x_st_V=(UV(j,i,1)-UV(AD(j+1,nc),i,1));
	z[0](j,i)=( 1./(2.*sqrt(s_2+x_st_U*x_st_U))*2.*s + 1./(2.*sqrt(s_2+x_st_V*x_st_V))*2.*s )/2.;
	x_st_U=(UV(j,i,0)-UV(j,AD(i+1,nl),0));
	x_st_V=(UV(j,i,1)-UV(j,AD(i+1,nl),1));
	z[1](j,i)=( 1./(2.*sqrt(s_2+x_st_U*x_st_U))*2.*s + 1./(2.*sqrt(s_2+x_st_V*x_st_V))*2.*s )/2.;
      }
    }
  }
  else{
   for (int i=0;i<nl;i++){
      for (int j=0;j<nc;j++){ 
	x_st_U=(UV(j,i,0)-UV(PERIOD(j+1,nc),i,0));
	x_st_V=(UV(j,i,1)-UV(PERIOD(j+1,nc),i,1));
	z[0](j,i)=( 1./(2.*sqrt(s_2+x_st_U*x_st_U))*2.*s + 1./(2.*sqrt(s_2+x_st_V*x_st_V))*2.*s )/2.;
	x_st_U=(UV(j,i,0)-UV(j,PERIOD(i+1,nl),0));
	x_st_V=(UV(j,i,1)-UV(j,PERIOD(i+1,nl),1));
	z[1](j,i)=( 1./(2.*sqrt(s_2+x_st_U*x_st_U))*2.*s + 1./(2.*sqrt(s_2+x_st_V*x_st_V))*2.*s )/2.;
      }
    }
  }
}
 

void UpdateRobustWeight_QuasiTV(const CImg<double> &UV, CImgList <double> &z_right,  CImgList <double> &z_down,  CImgList <double> &z_rightDown,  CImgList <double> &z_rightUp, CImgList <double> &z_t_right,  CImgList <double> &z_t_down,  CImgList <double> &z_t_rightDown,  CImgList <double> &z_t_rightUp,int neta, int lo, double s, double zeta){ 
 		 
  /*sqrt(s^2+x^2) M-Estimator (normalized weights)*/
  int nc=UV.width();
  int nl=UV.height();
  double nx,ny,nx_t,ny_t;
  double s_2;
  double factor,factor_2;
  for (int l=neta;l<=lo;l++){
    factor=pow((double)l,zeta);
    factor_2=factor*factor;
    s_2=s*s;
    z_right[l-neta].fill(1.);
    z_down[l-neta].fill(1.);
    z_rightDown[l-neta].fill(1.);
    z_rightUp[l-neta].fill(1.);
    z_t_right[l-neta].fill(1.);
    z_t_down[l-neta].fill(1.);
    z_t_rightDown[l-neta].fill(1.);
    z_t_rightUp[l-neta].fill(1.);
    if (s<1000){
     for (int i=0;i<nl;i++){
      for (int j=0;j<nc;j++){ 
	if (j+l<nc){ 
	  nx=1;ny=0;
	  z_right[l-neta](j,i)=(UV(j,i,0)-UV(j+l,i,0))*(UV(j,i,0)-UV(j+l,i,0))+s_2*factor_2;
	  z_right[l-neta](j,i)=1./(2.*sqrt(z_right[l-neta](j,i)))*2.*s*factor;
	  z_t_right[l-neta](j,i)=(UV(j,i,1)-UV(j+l,i,1))*(UV(j,i,1)-UV(j+l,i,1))+s_2*factor_2;
	  z_t_right[l-neta](j,i)=1./(2.*sqrt(z_t_right[l-neta](j,i)))*2.*s*factor;
	}
	if (i+l<nl){
	  nx=0;ny=1;
	  z_down[l-neta](j,i)=(UV(j,i,1)-UV(j,i+l,1))*(UV(j,i,1)-UV(j,i+l,1))+s_2*factor_2;
	  z_down[l-neta](j,i)=1./(2.*sqrt(z_down[l-neta](j,i)))*2.*s*factor;
	  z_t_down[l-neta](j,i)=(UV(j,i,0)-UV(j,i+l,0))*(UV(j,i,0)-UV(j,i+l,0))+s_2*factor_2;
	  z_t_down[l-neta](j,i)=1./(2.*sqrt(z_t_down[l-neta](j,i)))*2.*s*factor;
	}
 	if (j+l<nc&&i+l<nl){
	  nx=1./sqrt(2);ny=1./sqrt(2.);
	  z_rightDown[l-neta](j,i)=(UV(j,i,0)-UV(j+l,i+l,0))*nx+(UV(j,i,1)-UV(j+l,i+l,1))*ny;
	  z_rightDown[l-neta](j,i)*=z_rightDown[l-neta](j,i);
	  z_rightDown[l-neta](j,i)+=s_2*factor_2;
	  z_rightDown[l-neta](j,i)=1./(2.*sqrt(z_rightDown[l-neta](j,i)))*2.*s*factor;
	  nx_t=1./sqrt(2);ny_t=-1./sqrt(2.);
	  z_t_rightDown[l-neta](j,i)=(UV(j,i,0)-UV(j+l,i+l,0))*nx_t+(UV(j,i,1)-UV(j+l,i+l,1))*ny_t;
	  z_t_rightDown[l-neta](j,i)*=z_t_rightDown[l-neta](j,i);
	  z_t_rightDown[l-neta](j,i)+=s_2*factor_2;
	  z_t_rightDown[l-neta](j,i)=1./(2.*sqrt(z_t_rightDown[l-neta](j,i)))*2.*s*factor;
	}
	if (j+l<nc&&i-l>=0){
	  nx=1./sqrt(2);ny=-1./sqrt(2.);
	  z_rightUp[l-neta](j,i)=(UV(j,i,0)-UV(j+l,i-l,0))*nx+(UV(j,i,1)-UV(j+l,i-l,1))*ny;
	  z_rightUp[l-neta](j,i)*=z_rightUp[l-neta](j,i);
	  z_rightUp[l-neta](j,i)+=s_2*factor_2;
	  z_rightUp[l-neta](j,i)=1./(2.*sqrt(z_rightUp[l-neta](j,i)))*2.*s*factor;
	  nx_t=-1./sqrt(2);ny_t=-1./sqrt(2.);
	  z_t_rightUp[l-neta](j,i)=(UV(j,i,0)-UV(j+l,i-l,0))*nx_t+(UV(j,i,1)-UV(j+l,i-l,1))*ny_t;
	  z_t_rightUp[l-neta](j,i)*=z_t_rightUp[l-neta](j,i);
	  z_t_rightUp[l-neta](j,i)+=s_2*factor_2;
	  z_t_rightUp[l-neta](j,i)=1./(2.*sqrt(z_t_rightUp[l-neta](j,i)))*2.*s*factor;
	  }
	
      } 
     } 
     }
   }  
	
}

	/*************************************************************************************************************/

	/*************************************************************************************************************/
	/**********************************                  Filters *************************************************/
	/*************************************************************************************************************/

	/*************************************************************************************************************/
CImg<double>  Filtre_2D(const CImg<double>& b, const CImg<double>& filtre){
    
    /*Filter with neumann boundary condition*/
    int nb_ligF=filtre.height(), nb_colF=filtre.width();
    int nb_line=b.height(), nb_col=b.width();
    int n= nb_colF/2; if (nb_colF==1){n=0;}
    int m= nb_ligF/2; if (nb_ligF==1){m=0;}
    CImg<double> a(nb_col,nb_line);
    for (int i=0;i<nb_line;i++)
    {
	for (int j=0;j<nb_col;j++)
	{
	    a(j,i)=0.0;

	    for (int k=-m;k<m+1;k++)
	    for (int l=-n;l<n+1;l++)
	    {
		a(j,i)+= b[AD(j+l,nb_col)+AD(i+k,nb_line)*nb_col] * filtre[(k+m)*nb_colF+(l+n)];

	    }
	}
    }
    return a;
}
CImg<double>  Filtre_2D(const CImg<double>& b, const CImg<double>& filtre, bool periodic){
    
    if (periodic){
      /*Filter with periodic boundary condition*/
      int nb_ligF=filtre.height(), nb_colF=filtre.width();
      int nb_line=b.height(), nb_col=b.width();
      int n= nb_colF/2; if (nb_colF==1){n=0;}
      int m= nb_ligF/2; if (nb_ligF==1){m=0;}
      CImg<double> a(nb_col,nb_line);
    
       for (int i=0;i<nb_line;i++){
	for (int j=0;j<nb_col;j++){
	    a(j,i)=0.0;

	    for (int k=-m;k<m+1;k++)
	    for (int l=-n;l<n+1;l++)
	    {
		a(j,i)+= b[PERIOD(j+l,nb_col)+PERIOD(i+k,nb_line)*nb_col] * filtre[(k+m)*nb_colF+(l+n)];

	    }
	 }
       }
       return a;
    }
    else{return Filtre_2D(b,filtre);}
}
CImg<double>  Filtre_2D_sparse(const CImg<double>& b, const CImg<double>& filtre){
    
    /*Filter with neumann boundary condition*/
    int nb_ligF=filtre.height(), nb_colF=filtre.width();
    int nb_line=b.height(), nb_col=b.width();
    int n= nb_colF/2; if (nb_colF==1){n=0;}
    int m= nb_ligF/2; if (nb_ligF==1){m=0;}
    CImg<double> a(nb_col,nb_line);
    double aux;
    double sum=filtre.sum();
    bool negatif=false;
    for (int i=0;i<nb_line;i++)
    {
	for (int j=0;j<nb_col;j++)
	{
	    a(j,i)=0.0;
	    aux=0.;
	    for (int k=-m;k<m+1;k++)
	    for (int l=-n;l<n+1;l++)
	    {
		if (b[AD(j+l,nb_col)+AD(i+k,nb_line)*nb_col]<=-1022){negatif=true;}
		if (abs(b[AD(j+l,nb_col)+AD(i+k,nb_line)*nb_col])>=1022){aux+=filtre[(k+m)*nb_colF+(l+n)];}
		else{a(j,i)+= b[AD(j+l,nb_col)+AD(i+k,nb_line)*nb_col] * filtre[(k+m)*nb_colF+(l+n)];}

	    }
	    if (aux>0.){a(j,i)/=(sum-aux);}
	    if (aux>sum*0.){if (negatif){a(j,i)=-1023;}else{a(j,i)=1023;}}
	}
    }
    return a;
}
CImg<double>  Filtre_2D_sparse(const CImg<double>& b, const CImg<double>& filtre, bool periodic){
    
    if (periodic){
      /*Filter with periodic boundary condition*/
      int nb_ligF=filtre.height(), nb_colF=filtre.width();
      int nb_line=b.height(), nb_col=b.width();
      int n= nb_colF/2; if (nb_colF==1){n=0;}
      int m= nb_ligF/2; if (nb_ligF==1){m=0;}
      CImg<double> a(nb_col,nb_line);
      double aux;
      double sum=filtre.sum();
    
       for (int i=0;i<nb_line;i++){
	for (int j=0;j<nb_col;j++){
	    a(j,i)=0.0;
	    aux=0.;
	    for (int k=-m;k<m+1;k++)
	    for (int l=-n;l<n+1;l++)
	    {
		if (b[PERIOD(j+l,nb_col)+PERIOD(i+k,nb_line)*nb_col]>=1022){aux+=filtre[(k+m)*nb_colF+(l+n)];}
		else{a(j,i)+= b[PERIOD(j+l,nb_col)+PERIOD(i+k,nb_line)*nb_col] * filtre[(k+m)*nb_colF+(l+n)];}

	    }
	    if (aux>0.){a(j,i)/=(sum-aux);}
	    if (aux>sum*0.){a(j,i)=1023;}
	 }
       }
       return a;
    }
    else{return Filtre_2D_sparse(b,filtre);}
}

CImg<double> GradRobY_powK(const CImg<double> &im ,const CImg<double> &z,double power,bool periodic){
 
  int nb_line=im.height(), nb_col=im.width();
  CImg<double> a(nb_col,nb_line);
  if (!periodic){
    for (int i=0;i<nb_line;i++)  {
	for (int j=0;j<nb_col;j++){
	  a(j,i)= 0.5*( pow((im(j,AD(i+1,nb_line))-im(j,i)),power)*z(j,i) + pow((im(j,i)-im(j,AD(i-1,nb_line))),power)*z(j,AD(i-1,nb_line)) );
	}
    }
  }
  else{
    for (int i=0;i<nb_line;i++)  {
	for (int j=0;j<nb_col;j++){
	  a(j,i)= 0.5*( pow((im(j,PERIOD(i+1,nb_line))-im(j,i)),power)*z(j,i) + pow((im(j,i)-im(j,PERIOD(i-1,nb_line))),power)*z(j,PERIOD(i-1,nb_line)) );
	}
    }
  }
  return a;
}
CImg<double> GradRobX_powK(const CImg<double> &im ,const CImg<double> &z,double power,bool periodic){
 
  int nb_line=im.height(), nb_col=im.width();
  CImg<double> a(nb_col,nb_line);
  if (!periodic){
    for (int i=0;i<nb_line;i++)  {
	for (int j=0;j<nb_col;j++){
	  a(j,i)= 0.5*( pow((im(AD(j+1,nb_line),i)-im(j,i)),power)*z(j,i) + pow((im(j,i)-im(AD(j-1,nb_line),i)),power)*z(AD(j-1,nb_line),i) );
	}
    }
  }
  else{
    for (int i=0;i<nb_line;i++)  {
	for (int j=0;j<nb_col;j++){
	  a(j,i)= 0.5*( pow((im(PERIOD(j+1,nb_line),i)-im(j,i)),power)*z(j,i) + pow((im(j,i)-im(PERIOD(j-1,nb_line),i)),power)*z(PERIOD(j-1,nb_line),i) );
	}
    }
  }
  return a;
}
CImg<double> laplacian(const CImg<double> &im, bool periodic){

	CImg<double> mask(3,3);
		mask(0,0)=0.;mask(1,0)=1.; mask(2,0)=0.;
		mask(0,1)=1.;mask(1,1)=-4.; mask(2,1)=1.;
		mask(0,2)=0.;mask(1,2)=1.; mask(2,2)=0.;
		
	return Filtre_2D(im,mask,periodic);	
	
}	
CImg<double> laplacian(const CImg<double> &im,const CImgList<double> &z, bool periodic){

  int nb_line=im.height(), nb_col=im.width();
  CImg<double> a(nb_col,nb_line);
  a.fill(0.);
  if (!periodic){
    for (int i=0;i<nb_line;i++)  {
	for (int j=0;j<nb_col;j++){
	    a(j,i)+= (im(j,AD(i+1,nb_line)) - im (j,i) )* z[1](j,i);
	    a(j,i)+= (im(j,AD(i-1,nb_line)) - im (j,i) )* z[1](j,AD(i-1,nb_line));
	    a(j,i)+= (im(AD(j+1,nb_col),i) - im (j,i) )* z[0](j,i);
	    a(j,i)+= (im(AD(j-1,nb_col),i) - im (j,i) )* z[0](AD(j-1,nb_col),i);
	}
    }
  }
  else{
    for (int i=0;i<nb_line;i++)  {
	for (int j=0;j<nb_col;j++){
	    a(j,i)+= (im(j,PERIOD(i+1,nb_line)) - im (j,i) )* z[1](j,i);
	    a(j,i)+= (im(j,PERIOD(i-1,nb_line)) - im (j,i) )* z[1](j,PERIOD(i-1,nb_line));
	    a(j,i)+= (im(PERIOD(j+1,nb_line),i) - im (j,i) )* z[0](j,i);
	    a(j,i)+= (im(PERIOD(j-1,nb_col),i) - im (j,i) )* z[0](PERIOD(j-1,nb_col),i);
	}
    }
  }
  return a;
	
}
CImg<double> laplacianPiemeDerivRobustWeight(const CImg<double> &im,const CImgList<double> &z,const CImg<double> &U,double power, bool periodic){

  int nb_line=im.height(), nb_col=im.width();
  CImg<double> a(nb_col,nb_line);
  a.fill(0.);
  if (!periodic){
    for (int i=0;i<nb_line;i++)  {
	for (int j=0;j<nb_col;j++){
	  a(j,i)+= (im(j,AD(i+1,nb_line)) - im (j,i) )  * pow((U(j,AD(i+1,nb_line)) - U(j,i)),power)* z[1](j,i);
	    a(j,i)+= (im(j,AD(i-1,nb_line)) - im (j,i) )* pow((U(j,i) - U(j,AD(i-1,nb_line))),power)* z[1](j,AD(i-1,nb_line));
	    a(j,i)+= (im(AD(j+1,nb_col),i) - im (j,i) ) * pow((U(AD(j+1,nb_col),i) - U(j,i)  ),power)* z[0](j,i);
	    a(j,i)+= (im(AD(j-1,nb_col),i) - im (j,i) ) * pow((U(j,i) - U(AD(j-1,nb_col),i)  ),power)* z[0](AD(j-1,nb_col),i);
	}
    }
  }
  else{
    for (int i=0;i<nb_line;i++)  {
	for (int j=0;j<nb_col;j++){
	    a(j,i)+= (im(j,PERIOD(i+1,nb_line)) - im (j,i) )*pow((U(j,PERIOD(i+1,nb_line)) - U(j,i) ),power)* z[1](j,i);
	    a(j,i)+= (im(j,PERIOD(i-1,nb_line)) - im (j,i) )*pow((U(j,i) - U(j,PERIOD(i-1,nb_line)) ),power)* z[1](j,PERIOD(i-1,nb_line));
	    a(j,i)+= (im(PERIOD(j+1,nb_line),i) - im (j,i) )*pow((U(PERIOD(j+1,nb_line),i) - U(j,i) ),power)* z[0](j,i);
	    a(j,i)+= (im(PERIOD(j-1,nb_col),i) - im (j,i) ) *pow((U(j,i) - U(PERIOD(j-1,nb_col),i) ),power)* z[0](PERIOD(j-1,nb_col),i);
	}
    }
  }
  return a;
	
}	


	/*************************************************************************************************************/

	/*************************************************************************************************************/
	/*****************************CGS Inversion, log det and trace -1*********************************************/
	/*************************************************************************************************************/

	/*************************************************************************************************************/


int standard_CGS_inversion(int taille, int nombre, double *val,int *row_ptr,int *col_ind, VECTOR_double B, CImg<double> &res,double tol){	


	int errcount=0, max_iter=500;
	int nc=res.width();
	int nl=res.height(); 
	int sizeX=res.depth();
	int ncnl=nc*nl;
	VECTOR_double  X(taille,0.0); 

	CompRow_Mat_double Ar(taille,taille,nombre,val,row_ptr,col_ind);
	CompRow_ILUPreconditioner_double A(Ar);
	//cout<<"occam factor: "<<A.part_occamFactor()<<endl;
	   		
	errcount= CGS(Ar,X,B,A,max_iter,tol);
	if (errcount!=0){cout<<"no convergence (output CGS "<<errcount<<")";}
  	for (int i=0 ; i<nl ; i++){
    	   for (int j=0 ; j<nc ; j++){
	      for (int l=0 ; l<sizeX ; l++){
		  res(j,i,l)=X(l*ncnl+i*nc+j);
	      }
      	   }
    	}	
	return errcount;
}
int standard_CGS_inversion(int taille, int nombre, double *val,int *row_ptr,int *col_ind, VECTOR_double B, CImg<double> &res){
  double tol=0.000001;  
  return standard_CGS_inversion(taille,nombre,val,row_ptr,col_ind,B,res,tol);
}	

/*************************************************************************************************************/
double ILU_logDetA(int taille, int nombre, double *val,int *row_ptr,int *col_ind){	


	double logdetA; 

	CompRow_Mat_double Ar(taille,taille,nombre,val,row_ptr,col_ind);
	CompRow_ILUPreconditioner_double A(Ar); 
	logdetA=A.logDetLP();
	//cout<<"log det A (ILU)  "<<logdetA<<endl;
	   		
	return logdetA;
}	
/*************************************************************************************************************/
/*************************************************************************************************************/
double * CGS_randomB_traceInvAA0Fx(int taille, int nombre, double *val,int *row_ptr,int *col_ind,const CImg<double> &IxIx,const CImg<double> &IxIy,const CImg<double> &IyIy,const CImg<double> &data_out,const CImgList<double> &reg_out,const CImg<double> &x2, int nbIt, double tol, bool periodic){	

        double *trace=new double[4];
	trace[0]=0.; trace[1]=0.;trace[2]=0.;trace[3]=0.;
	int nc=IxIx.width();
	int nl=IxIx.height();
	int ncnl=nc*nl;
	CImg<double> X(nc,nl,2);
	CImg<double> B_u(nc,nl);
	CImg<double> B_v(nc,nl);
	VECTOR_double B(taille,0.0);
	VECTOR_double A_1B(taille,0.0);
	VECTOR_double A0B(taille,0.0);
	VECTOR_double ArB(taille,0.0);
	VECTOR_double A0FxB(taille,0.0);
	VECTOR_double A0dFxB(taille,0.0);

	srand((unsigned)time(NULL));  	
        float gasdev(long *idum); 
        long int *auxNoise=new long int[1];
        auxNoise[0]=-(int)(((float)rand())/RAND_MAX*10000);
	double * sampleTraceInv=new double[nbIt];
	double * sampleTrace=new double[nbIt];
	double * sampleTraceFx=new double[nbIt];
	double * sampleTracedFx=new double[nbIt];
	int errorType;
	
	for (int ii=0;ii<nbIt;ii++){
	  /***************************************** Sampling ~ N(0,1) for vector B *************************************/
	  int k;
	  for (int i=0 ; i<nl ; i++){
	    for (int j=0 ; j<nc ; j++){
	      k = i*nc+j;		
	      B(k)=gasdev(auxNoise);B_u(j,i)=B(k);
	      B(ncnl+k)=gasdev(auxNoise);B_v(j,i)=B(ncnl+k);
	    }		   	
	  }
	  B_u=-1*laplacian(B_u,reg_out,periodic);
	  B_v=-1*laplacian(B_v,reg_out,periodic);


	  /***************************************** Inversion and calculus of trace sample   ************************/
	  errorType=standard_CGS_inversion(taille,nombre,val,row_ptr,col_ind,B,X,tol);
	  if (errorType!=0){cout<<"Error CGS convergence "<<errorType<<" (in trace randomization)"<<endl;}
	  for (int i=0 ; i<nl ; i++){
	    for (int j=0 ; j<nc ; j++){
	      k = i*nc+j;
	      A_1B(k)=X(j,i,0);
	      A_1B(ncnl+k)=X(j,i,1);
	      A0B(k)=(B(k)*IxIx(j,i)+B(ncnl+k)*IxIy(j,i))*data_out(j,i);
	      A0B(ncnl+k)=(B(k)*IxIy(j,i)+B(ncnl+k)*IyIy(j,i))*data_out(j,i);
	      ArB(k)=B_u(j,i);
	      ArB(ncnl+k)=B_v(j,i);
	      A0FxB(k)=(B(k)*IxIx(j,i)+B(ncnl+k)*IxIy(j,i))*data_out(j,i)*x2(j,i);
	      A0FxB(ncnl+k)=(B(k)*IxIy(j,i)+B(ncnl+k)*IyIy(j,i))*data_out(j,i)*x2(j,i);
	      A0dFxB(k)=(B(k)*IxIx(j,i)+B(ncnl+k)*IxIy(j,i))*data_out(j,i)*x2(j,i)*x2(j,i);
	      A0dFxB(ncnl+k)=(B(k)*IxIy(j,i)+B(ncnl+k)*IyIy(j,i))*data_out(j,i)*x2(j,i)*x2(j,i);
	    }		   	
	  }
	  sampleTraceInv[ii]=0;
	  sampleTrace[ii]=0;
	  sampleTraceFx[ii]=0;
	  sampleTracedFx[ii]=0;
	  for (int k=0; k<taille; k++){
	    sampleTraceInv[ii]+=A_1B(k)*ArB(k);
	    sampleTrace[ii]+=A_1B(k)*A0B(k);
	    sampleTraceFx[ii]+=A_1B(k)*A0FxB(k);
	    sampleTracedFx[ii]+=A_1B(k)*A0dFxB(k);
	  }
	  /*************************************************************************************************************/
	  trace[0]+=sampleTraceInv[ii];
	  trace[1]+=sampleTrace[ii];
	  trace[2]+=sampleTraceFx[ii];
	  trace[3]+=sampleTracedFx[ii];
	}
	trace[0]/=nbIt;
	trace[1]/=nbIt;
	trace[2]/=nbIt;
	trace[3]/=nbIt;
	delete [] sampleTraceInv;
	delete [] sampleTrace;
	delete [] sampleTraceFx;
	delete [] sampleTracedFx;
	//cout<<"trace(A^{-1}A_0) =  "<<trace<<endl;	   		
	return trace;
}
/*************************************************************************************************************/
double * CGS_randomB_traceInvAA0ArFx(int taille, int nombre, double *val,int *row_ptr,int *col_ind,const CImg<double> &IxIx,const CImg<double> &IxIy,const CImg<double> &IyIy,const CImg<double> &data_out,const CImgList<double> &reg_out,const CImg<double> &x2,const CImg<double> &UV, int nbIt, double tol, bool periodic){	

        double *trace=new double[6];
	trace[0]=0.; trace[1]=0.;trace[2]=0.;trace[3]=0.;trace[4]=0.;trace[5]=0.;
	int nc=IxIx.width();
	int nl=IxIx.height();
	int ncnl=nc*nl;
	CImg<double> X(nc,nl,2);
	CImg<double> B_u(nc,nl);
	CImg<double> B_v(nc,nl);
	CImg<double> B0_u(nc,nl);
	CImg<double> B0_v(nc,nl);
	CImg<double> B2_u(nc,nl);
	CImg<double> B2_v(nc,nl);
	CImg<double> B4_u(nc,nl);
	CImg<double> B4_v(nc,nl);
	VECTOR_double B(taille,0.0);
	VECTOR_double A_1B(taille,0.0);
	VECTOR_double A0B(taille,0.0);
	VECTOR_double ArB(taille,0.0);
	VECTOR_double ArFxB(taille,0.0);
	VECTOR_double ArdFxB(taille,0.0);
	VECTOR_double A0FxB(taille,0.0);
	VECTOR_double A0dFxB(taille,0.0);

	srand((unsigned)time(NULL));  	
        float gasdev(long *idum); 
        long int *auxNoise=new long int[1];
        auxNoise[0]=-(int)(((float)rand())/RAND_MAX*10000);
	double * sampleTraceInv=new double[nbIt];
	double * sampleTrace=new double[nbIt];
	double * sampleTraceFx=new double[nbIt];
	double * sampleTracedFx=new double[nbIt];
	double * sampleTraceArFx=new double[nbIt];
	double * sampleTraceArdFx=new double[nbIt];
	int errorType;
	
	for (int ii=0;ii<nbIt;ii++){
	  /***************************************** Sampling ~ N(0,1) for vector B *************************************/
	  int k;
	  for (int i=0 ; i<nl ; i++){
	    for (int j=0 ; j<nc ; j++){
	      k = i*nc+j;		
	      B(k)=gasdev(auxNoise);B_u(j,i)=B(k);
	      B(ncnl+k)=gasdev(auxNoise);B_v(j,i)=B(ncnl+k);
	    }		   	
	  }
	  B0_u=-1*laplacian(B_u,reg_out,periodic);
	  B0_v=-1*laplacian(B_v,reg_out,periodic);
	  B2_u=-1*laplacianPiemeDerivRobustWeight(B_u,reg_out,UV.get_slice(0),2.,periodic);
	  B2_v=-1*laplacianPiemeDerivRobustWeight(B_v,reg_out,UV.get_slice(1),2.,periodic);
	  B4_u=-1*laplacianPiemeDerivRobustWeight(B_u,reg_out,UV.get_slice(0),4.,periodic);
	  B4_v=-1*laplacianPiemeDerivRobustWeight(B_v,reg_out,UV.get_slice(1),4.,periodic);

	  /***************************************** Inversion and calculus of trace sample   ************************/
	  errorType=standard_CGS_inversion(taille,nombre,val,row_ptr,col_ind,B,X,tol);
	  if (errorType!=0){cout<<"Error CGS convergence "<<errorType<<" (in trace randomization)"<<endl;}
	  for (int i=0 ; i<nl ; i++){
	    for (int j=0 ; j<nc ; j++){
	      k = i*nc+j;
	      A_1B(k)=X(j,i,0);
	      A_1B(ncnl+k)=X(j,i,1);
	      A0B(k)=(B(k)*IxIx(j,i)+B(ncnl+k)*IxIy(j,i))*data_out(j,i);
	      A0B(ncnl+k)=(B(k)*IxIy(j,i)+B(ncnl+k)*IyIy(j,i))*data_out(j,i);
	      ArB(k)=B0_u(j,i);
	      ArB(ncnl+k)=B0_v(j,i);
	      A0FxB(k)=(B(k)*IxIx(j,i)+B(ncnl+k)*IxIy(j,i))*data_out(j,i)*x2(j,i);
	      A0FxB(ncnl+k)=(B(k)*IxIy(j,i)+B(ncnl+k)*IyIy(j,i))*data_out(j,i)*x2(j,i);
	      A0dFxB(k)=(B(k)*IxIx(j,i)+B(ncnl+k)*IxIy(j,i))*data_out(j,i)*x2(j,i)*x2(j,i);
	      A0dFxB(ncnl+k)=(B(k)*IxIy(j,i)+B(ncnl+k)*IyIy(j,i))*data_out(j,i)*x2(j,i)*x2(j,i);
	      ArFxB(k)=B2_u(j,i);
	      ArFxB(ncnl+k)=B2_v(j,i);
	      ArdFxB(k)=B4_u(j,i);
	      ArdFxB(ncnl+k)=B4_v(j,i);
	    }		   	
	  }
	  sampleTraceInv[ii]=0;
	  sampleTrace[ii]=0;
	  sampleTraceFx[ii]=0;
	  sampleTracedFx[ii]=0;
	  sampleTraceArFx[ii]=0;
	  sampleTraceArdFx[ii]=0;
	  for (int k=0; k<taille; k++){
	    sampleTraceInv[ii]+=A_1B(k)*ArB(k);
	    sampleTrace[ii]+=A_1B(k)*A0B(k);
	    sampleTraceFx[ii]+=A_1B(k)*A0FxB(k);
	    sampleTracedFx[ii]+=A_1B(k)*A0dFxB(k);
	    sampleTraceArFx[ii]+=A_1B(k)*ArFxB(k);
	    sampleTraceArdFx[ii]+=A_1B(k)*ArdFxB(k);
	  }
	  /*************************************************************************************************************/
	  trace[0]+=sampleTraceInv[ii];
	  trace[1]+=sampleTrace[ii];
	  trace[2]+=sampleTraceFx[ii];
	  trace[3]+=sampleTracedFx[ii];
	  trace[4]+=sampleTraceArFx[ii];
	  trace[5]+=sampleTraceArdFx[ii];
	}
	trace[0]/=nbIt;
	trace[1]/=nbIt;
	trace[2]/=nbIt;
	trace[3]/=nbIt;
	trace[4]/=nbIt;
	trace[5]/=nbIt;
	delete [] sampleTraceInv;
	delete [] sampleTrace;
	delete [] sampleTraceFx;
	delete [] sampleTracedFx;
	delete [] sampleTraceArFx;
	delete [] sampleTraceArdFx;
	//cout<<"trace(A^{-1}A_0) =  "<<trace<<endl;	   		
	return trace;
}
/*************************************************************************************************************/
double * CGS_randomB_traceInvAA0Fx_QuasiTV(int taille, int nombre, double *val,int *row_ptr,int *col_ind,const CImg<double> &IxIx,const CImg<double> &IxIy,const CImg<double> &IyIy,const CImg<double> &data_out,const CImgList<double> &reg_out,const CImg<double> &x2, double tau, int nbIt, double tol, bool periodic){	

        double *trace=new double[4];
	trace[0]=0.; trace[1]=0.;trace[2]=0.;trace[3]=0.;
	int nc=IxIx.width();
	int nl=IxIx.height();
	int ncnl=nc*nl;
	CImg<double> X(nc,nl,2);
	CImg<double> B_u(nc,nl);
	CImg<double> B_v(nc,nl);
	VECTOR_double B(taille,0.0);
	VECTOR_double A_1B(taille,0.0);
	VECTOR_double A0B(taille,0.0);
	VECTOR_double ArB(taille,0.0);
	VECTOR_double A0FxB(taille,0.0);
	VECTOR_double A0dFxB(taille,0.0);

	srand((unsigned)time(NULL));  	
        float gasdev(long *idum); 
        long int *auxNoise=new long int[1];
        auxNoise[0]=-(int)(((float)rand())/RAND_MAX*10000);
	double * sampleTraceInv=new double[nbIt];
	double * sampleTrace=new double[nbIt];
	double * sampleTraceFx=new double[nbIt];
	double * sampleTracedFx=new double[nbIt];
	int errorType;
	
	for (int ii=0;ii<nbIt;ii++){
	  /***************************************** Sampling ~ N(0,1) for vector B *************************************/
	  int k;
	  for (int i=0 ; i<nl ; i++){
	    for (int j=0 ; j<nc ; j++){
	      k = i*nc+j;		
	      B(k)=gasdev(auxNoise);B_u(j,i)=B(k);
	      B(ncnl+k)=gasdev(auxNoise);B_v(j,i)=B(ncnl+k);
	    }		   	
	  }
	  B_u=-1*laplacian(B_u,reg_out,periodic);
	  B_v=-1*laplacian(B_v,reg_out,periodic);


	  /***************************************** Inversion and calculus of trace sample   ************************/
	  errorType=standard_CGS_inversion(taille,nombre,val,row_ptr,col_ind,B,X,tol);
	  double a,b;
	  if (errorType!=0){cout<<"Error CGS convergence "<<errorType<<" (in trace randomization)"<<endl;}
	  for (int i=0 ; i<nl ; i++){
	    for (int j=0 ; j<nc ; j++){
	      a=(-4.*x2(j,i)*tau)/(1.+4.*tau*tau*x2(j,i));
	      b=(4.*x2(j,i)*(4.*x2(j,i)*tau*tau-1.))/(pow((double)(1.+4.*tau*tau*x2(j,i)),(double)1.5));
	      k = i*nc+j;
	      A_1B(k)=X(j,i,0);
	      A_1B(ncnl+k)=X(j,i,1);
	      A0B(k)=(B(k)*IxIx(j,i)+B(ncnl+k)*IxIy(j,i))*data_out(j,i);
	      A0B(ncnl+k)=(B(k)*IxIy(j,i)+B(ncnl+k)*IyIy(j,i))*data_out(j,i);
	      ArB(k)=B_u(j,i);
	      ArB(ncnl+k)=B_v(j,i);
	      A0FxB(k)=(B(k)*IxIx(j,i)+B(ncnl+k)*IxIy(j,i))*data_out(j,i)*a;
	      A0FxB(ncnl+k)=(B(k)*IxIy(j,i)+B(ncnl+k)*IyIy(j,i))*data_out(j,i)*a;
	      A0dFxB(k)=(B(k)*IxIx(j,i)+B(ncnl+k)*IxIy(j,i))*data_out(j,i)*(b*data_out(j,i)+a*a);
	      A0dFxB(ncnl+k)=(B(k)*IxIy(j,i)+B(ncnl+k)*IyIy(j,i))*data_out(j,i)*(b*data_out(j,i)+a*a);
	    }		   	
	  }
	  sampleTraceInv[ii]=0;
	  sampleTrace[ii]=0;
	  sampleTraceFx[ii]=0;
	  sampleTracedFx[ii]=0;
	  for (int k=0; k<taille; k++){
	    sampleTraceInv[ii]+=A_1B(k)*ArB(k);
	    sampleTrace[ii]+=A_1B(k)*A0B(k);
	    sampleTraceFx[ii]+=A_1B(k)*A0FxB(k);
	    sampleTracedFx[ii]+=A_1B(k)*A0dFxB(k);
	  }
	  /*************************************************************************************************************/
	  trace[0]+=sampleTraceInv[ii];
	  trace[1]+=sampleTrace[ii];
	  trace[2]+=sampleTraceFx[ii];
	  trace[3]+=sampleTracedFx[ii];
	}
	trace[0]/=nbIt;
	trace[1]/=nbIt;
	trace[2]/=nbIt;
	trace[3]/=nbIt;
	delete [] sampleTraceInv;
	delete [] sampleTrace;
	delete [] sampleTraceFx;
	delete [] sampleTracedFx;
	//cout<<"trace(A^{-1}A_0) =  "<<trace<<endl;	   		
	return trace;
}	
/*************************************************************************************************************/
double CGS_randomB_traceInvAAr(int taille, int nombre,int nc, int nl, double *val,int *row_ptr,int *col_ind, const CImgList<double> &reg_out, int nbIt, double tol, bool periodic){	

 	double trace=0.; 
	int ncnl=nc*nl;
	CImg<double> X(nc,nl,2);
	CImg<double> B_u(nc,nl);
	CImg<double> B_v(nc,nl);
	VECTOR_double B(taille,0.0);
	VECTOR_double A_1B(taille,0.0);
	VECTOR_double ArB(taille,0.0);

	srand((unsigned)time(NULL));  	
        float gasdev(long *idum); 
        long int *auxNoise=new long int[1];
        auxNoise[0]=-(int)(((float)rand())/RAND_MAX*10000);
	double * sampleTrace=new double[nbIt];
	int errorType;
	
	for (int ii=0;ii<nbIt;ii++){
	  /***************************************** Sampling ~ N(0,1) for vector B *************************************/
	  int k;
	  for (int i=0 ; i<nl ; i++){
	    for (int j=0 ; j<nc ; j++){
	      k = i*nc+j;		
	      B(k)=gasdev(auxNoise);B_u(j,i)=B(k);
	      B(ncnl+k)=gasdev(auxNoise);B_v(j,i)=B(ncnl+k);
	    }		   	
	  }
	  B_u=-1*laplacian(B_u,reg_out,periodic);
	  B_v=-1*laplacian(B_v,reg_out,periodic);
	  /***************************************** Inversion and calculus of trace sample   ************************/
	  errorType=standard_CGS_inversion(taille,nombre,val,row_ptr,col_ind,B,X,tol);
	  if (errorType!=0){cout<<"Error CGS convergence "<<errorType<<" (in trace randomization)"<<endl;}
	  for (int i=0 ; i<nl ; i++){
	    for (int j=0 ; j<nc ; j++){
	      k = i*nc+j;
	      A_1B(k)=X(j,i,0);
	      A_1B(ncnl+k)=X(j,i,1);
	      ArB(k)=B_u(j,i);
	      ArB(ncnl+k)=B_v(j,i);
	    }		   	
	  }
	  sampleTrace[ii]=0;
	  for (int k=0; k<taille; k++){
	    sampleTrace[ii]+=A_1B(k)*ArB(k);
	  }
	  /*************************************************************************************************************/
	  trace+=sampleTrace[ii];
	}
	trace/=nbIt;
	delete [] sampleTrace;
	//cout<<"trace(A^{-1}Ar) =  "<<trace<<endl;	   		
	return trace;
}
/*************************************************************************************************************/
double CGS_randomB_traceInvAAr(int taille, int nombre,int nc, int nl, double *val,int *row_ptr,int *col_ind, int nbIt, double tol, bool periodic){
  CImgList<double> reg_out(2,nc,nl);
  reg_out[0].fill(1.);reg_out[1].fill(1.);
  return CGS_randomB_traceInvAAr(taille,nombre,nc,nl, val,row_ptr,col_ind,reg_out,nbIt,tol,periodic);
}

/*************************************************************************************************************/
double CGS_randomB_traceInvAA0(int taille, int nombre, double *val,int *row_ptr,int *col_ind,const CImg<double> &IxIx,const CImg<double> &IxIy,const CImg<double> &IyIy,const CImg<double> &data_out, int nbIt, double tol){	

 	double trace=0.; 
	int nc=IxIx.width();
	int nl=IxIx.height();
	int ncnl=nc*nl;
	CImg<double> X(nc,nl,2);
	VECTOR_double B(taille,0.0);
	VECTOR_double A_1B(taille,0.0);
	VECTOR_double A0B(taille,0.0);

	srand((unsigned)time(NULL));  	
        float gasdev(long *idum); 
        long int *auxNoise=new long int[1];
        auxNoise[0]=-(int)(((float)rand())/RAND_MAX*10000);
	double * sampleTrace=new double[nbIt];
	int errorType;
	
	for (int ii=0;ii<nbIt;ii++){
	  /***************************************** Sampling ~ N(0,1) for vector B *************************************/
	  int k;
	  for (int i=0 ; i<nl ; i++){
	    for (int j=0 ; j<nc ; j++){
	      k = i*nc+j;		
	      B(k)=gasdev(auxNoise);
	      B(ncnl+k)=gasdev(auxNoise);
	    }		   	
	  }
	  /***************************************** Inversion and calculus of trace sample   ************************/
	  errorType=standard_CGS_inversion(taille,nombre,val,row_ptr,col_ind,B,X,tol);
	  if (errorType!=0){cout<<"Error CGS convergence "<<errorType<<" (in trace randomization)"<<endl;}
	  for (int i=0 ; i<nl ; i++){
	    for (int j=0 ; j<nc ; j++){
	      k = i*nc+j;
	      A_1B(k)=X(j,i,0);
	      A_1B(ncnl+k)=X(j,i,1);
	      A0B(k)=(B(k)*IxIx(j,i)+B(ncnl+k)*IxIy(j,i))*data_out(j,i);
	      A0B(ncnl+k)=(B(k)*IxIy(j,i)+B(ncnl+k)*IyIy(j,i))*data_out(j,i);
	    }		   	
	  }
	  sampleTrace[ii]=0;
	  for (int k=0; k<taille; k++){
	    sampleTrace[ii]+=A_1B(k)*A0B(k);
	  }
	  /*************************************************************************************************************/
	  trace+=sampleTrace[ii];
	}
	trace/=nbIt;
	delete [] sampleTrace;
	//cout<<"trace(A^{-1}A_0) =  "<<trace<<endl;	   		
	return trace;
}
/*************************************************************************************************************/
double CGS_randomB_traceInvA(int taille, int nombre,int nc, int nl, double *val,int *row_ptr,int *col_ind, int nbIt, double tol){	

 	double trace=0.; 
	int ncnl=nc*nl;
	CImg<double> X(nc,nl,2);
	VECTOR_double B(taille,0.0);
	VECTOR_double A_1B(taille,0.0);

	srand((unsigned)time(NULL));  	
        float gasdev(long *idum); 
        long int *auxNoise=new long int[1];
        auxNoise[0]=-(int)(((float)rand())/RAND_MAX*10000);
	double * sampleTrace=new double[nbIt];
	int errorType;
	
	for (int ii=0;ii<nbIt;ii++){
	  /***************************************** Sampling ~ N(0,1) for vector B *************************************/
	  int k;
	  for (int i=0 ; i<nl ; i++){
	    for (int j=0 ; j<nc ; j++){
	      k = i*nc+j;		
	      B(k)=gasdev(auxNoise);
	      B(ncnl+k)=gasdev(auxNoise);
	    }		   	
	  }
	  /***************************************** Inversion and calculus of trace sample   ************************/
	  errorType=standard_CGS_inversion(taille,nombre,val,row_ptr,col_ind,B,X,tol);
	  if (errorType!=0){cout<<"Error CGS convergence "<<errorType<<" (in trace randomization)"<<endl;}
	  for (int i=0 ; i<nl ; i++){
	    for (int j=0 ; j<nc ; j++){
	      k = i*nc+j;
	      A_1B(k)=X(j,i,0);
	      A_1B(ncnl+k)=X(j,i,1);
	    }		   	
	  }
	  sampleTrace[ii]=0;
	  for (int k=0; k<taille; k++){
	    sampleTrace[ii]+=A_1B(k)*B(k);
	  }
	  /*************************************************************************************************************/
	  trace+=sampleTrace[ii];
	}
	trace/=nbIt;
	delete [] sampleTrace;
	//cout<<"trace(A^{-1}) =  "<<trace<<endl;	   		
	return trace;
}


	/*************************************************************************************************************/

	/*************************************************************************************************************/
	/*********************************************Horn and Schunck      ******************************************/
	/*************************************************************************************************************/

	/*************************************************************************************************************/
double PriorEnergyHS_2nd(const CImg<double> &U,const CImg<double> &V, bool periodic){
	int nc=U.width();
	int nl=V.height();		
	CImg <double> grad_Ux(nc,nl);
	CImg <double> grad_Uy(nc,nl);
	CImg <double> grad_Vx(nc,nl);
	CImg <double> grad_Vy(nc,nl);
	CImg<double> mask_x(1,3);CImg<double> mask_y(3,1);
	mask_x(0,0)=-0.5;mask_x(0,1)=0.;mask_x(0,2)=0.5;	
	mask_y(0,0)=-0.5;mask_y(1,0)=0.;mask_y(2,0)=0.5;	
	grad_Ux=Filtre_2D(U,mask_x,periodic);
	grad_Uy=Filtre_2D(U,mask_y,periodic);
	grad_Vx=Filtre_2D(V,mask_x,periodic);
	grad_Vy=Filtre_2D(V,mask_y,periodic);
	return (0.5*(grad_Ux.get_mul(grad_Ux)+grad_Uy.get_mul(grad_Uy)+grad_Vx.get_mul(grad_Vx)+grad_Vy.get_mul(grad_Vy))).sum();
}

double PriorEnergyHS_2nd(const CImg<double> &U,const CImg<double> &V,const CImgList<double> &reg_out, bool periodic){
	int nc=U.width();
	int nl=V.height();		
	CImg <double> grad_Ux(nc,nl);
	CImg <double> grad_Uy(nc,nl);
	CImg <double> grad_Vx(nc,nl);
	CImg <double> grad_Vy(nc,nl);
	CImg<double> mask_x(1,3);CImg<double> mask_y(3,1);
	mask_x(0,0)=-0.5;mask_x(0,1)=0.;mask_x(0,2)=0.5;	
	mask_y(0,0)=-0.5;mask_y(1,0)=0.;mask_y(2,0)=0.5;	
	grad_Ux=Filtre_2D(U,mask_x,periodic);
	grad_Uy=Filtre_2D(U,mask_y,periodic);
	grad_Vx=Filtre_2D(V,mask_x,periodic);
	grad_Vy=Filtre_2D(V,mask_y,periodic);
	return (0.5*(grad_Ux.get_mul(grad_Ux).get_mul(reg_out[0])+grad_Uy.get_mul(grad_Uy).get_mul(reg_out[1])
		     +grad_Vx.get_mul(grad_Vx).get_mul(reg_out[0])+grad_Vy.get_mul(grad_Vy).get_mul(reg_out[1]))).sum();
}

double PriorEnergyHS_powK_2nd(const CImg<double> &U,const CImg<double> &V,const CImgList<double> &reg_out, double power, bool periodic){
	int nc=U.width();
	int nl=V.height();		
	CImg <double> gradP_Ux(nc,nl);
	CImg <double> gradP_Uy(nc,nl);
	CImg <double> gradP_Vx(nc,nl);
	CImg <double> gradP_Vy(nc,nl);
	CImg<double> mask_x(1,3);CImg<double> mask_y(3,1);
	mask_x(0,0)=-0.5;mask_x(0,1)=0.;mask_x(0,2)=0.5;	
	mask_y(0,0)=-0.5;mask_y(1,0)=0.;mask_y(2,0)=0.5;	
	gradP_Ux=Filtre_2D(U,mask_x,periodic).get_pow(power);
	gradP_Uy=Filtre_2D(U,mask_y,periodic).get_pow(power);
	gradP_Vx=Filtre_2D(V,mask_x,periodic).get_pow(power);
	gradP_Vy=Filtre_2D(V,mask_y,periodic).get_pow(power);
	return (0.5*(gradP_Ux.get_mul(reg_out[0])+gradP_Uy.get_mul(reg_out[1])
		     +gradP_Vx.get_mul(reg_out[0])+gradP_Vy.get_mul(reg_out[1]))).sum();
}
double PriorEnergyHS_powK_1st(const CImg<double> &U,const CImg<double> &V,double power, bool periodic){
	int nc=U.width();
	int nl=V.height();		
	CImg <double> gradP_Ux(nc,nl);
	CImg <double> gradP_Uy(nc,nl);
	CImg <double> gradP_Vx(nc,nl);
	CImg <double> gradP_Vy(nc,nl);
	gradP_Ux=GradRobX_powK(U,U.get_fill(1.),power,periodic);
	gradP_Uy=GradRobY_powK(U,U.get_fill(1.),power,periodic);
	gradP_Vx=GradRobX_powK(V,V.get_fill(1.),power,periodic);
	gradP_Vy=GradRobY_powK(V,V.get_fill(1.),power,periodic);
	return (0.5*(gradP_Ux+gradP_Uy+gradP_Vx+gradP_Vy)).sum();
}
double PriorEnergyHS_powK_1st(const CImg<double> &U,const CImg<double> &V,const CImgList<double> &reg_out,double power, bool periodic){
	int nc=U.width();
	int nl=V.height();		
	CImg <double> gradP_Ux(nc,nl);
	CImg <double> gradP_Uy(nc,nl);
	CImg <double> gradP_Vx(nc,nl);
	CImg <double> gradP_Vy(nc,nl);
	gradP_Ux=GradRobX_powK(U,reg_out[0],power,periodic);
	gradP_Uy=GradRobY_powK(U,reg_out[1],power,periodic);
	gradP_Vx=GradRobX_powK(V,reg_out[0],power,periodic);
	gradP_Vy=GradRobY_powK(V,reg_out[1],power,periodic);
	return (0.5*(gradP_Ux+gradP_Uy+gradP_Vx+gradP_Vy)).sum();
}

void fillingSparseHessian_A_HS(double *val,int *col_ind,int *row_ptr,const CImg<double> &im_x,const CImg<double> &im_y,const CImg<double> &data_out,float alpha,int nombre, bool periodic){
	int nc=im_x.width();
	int nl=im_x.height();		
	int ncnl=nc*nl;
	CImg <double> A1_ij(nc,nl); CImg <double> A2_ij(nc,nl);
	CImg <double> A1_i1j(nc,nl); CImg <double> A2_ij1(nc,nl);
	CImg <double> A1_i_1j(nc,nl); CImg <double> A2_ij_1(nc,nl);  
	CImg <double> A1_ij_1(nc,nl);	CImg <double> A2_i_1j(nc,nl);	
	CImg <double> A1_ij1(nc,nl);	CImg <double> A2_i1j(nc,nl);
	CImg <double> A1_ijnc(nc,nl);CImg <double> A1_ij0(nc,nl);CImg <double> A1_inlj(nc,nl);CImg <double> A1_i0j(nc,nl);
	CImg <double> A2_ijnc(nc,nl);CImg <double> A2_ij0(nc,nl);CImg <double> A2_inlj(nc,nl);CImg <double> A2_i0j(nc,nl);


	A1_ij=im_x.get_mul(im_x).get_mul(data_out)+4.*alpha;A1_i1j=-1.*alpha;A1_i_1j=-1.*alpha;A1_ij1=-1.*alpha;A1_ij_1=-1.*alpha;
	A2_ij=im_x.get_mul(im_y).get_mul(data_out);
	A1_ijnc.fill(notdef);A1_ij0.fill(notdef);A1_inlj.fill(notdef);A1_i0j.fill(notdef);
	if (!periodic){fixNeumannConditions(nc,nl,A1_i_1j,A1_ij,A1_i1j,A1_ij_1,A1_ij1);}
	else{fixPeriodConditions(nc,nl,A1_i_1j,A1_i1j,A1_ij_1,A1_ij1,A1_ijnc,A1_ij0,A1_inlj,A1_i0j);}
	row_ptr[0]=0;
	int ll=1;
	int k=0;
	for (int i=0; i<nl; i++){
	  for (int j=0; j<nc; j++){
	       
	    if (A1_i0j(j,i)!=notdef)        {val[k]=A1_i0j(j,i);	col_ind[k]=j;	              k++;}
	    if (A1_i_1j(j,i)!=notdef)       {val[k]=A1_i_1j(j,i);	col_ind[k]=(i-1)*nc+j;        k++;}
	    if (A1_ij0(j,i)!=notdef)        {val[k]=A1_ij0(j,i);	col_ind[k]=i*nc;	      k++;}
	    if (A1_ij_1(j,i)!=notdef)       {val[k]=A1_ij_1(j,i);	col_ind[k]=i*nc+(j-1);        k++;}
	                                     val[k]=A1_ij(j,i);      	col_ind[k]=i*nc+j;	      k++;
	    if (A1_ij1(j,i)!=notdef)        {val[k]=A1_ij1(j,i);	col_ind[k]=i*nc+(j+1);        k++;}
	    if (A1_ijnc(j,i)!=notdef)       {val[k]=A1_ijnc(j,i);	col_ind[k]=i*nc+nc-1;	      k++;}
	    if (A1_i1j(j,i)!=notdef)        {val[k]=A1_i1j(j,i);	col_ind[k]=(i+1)*nc+j;        k++;}	
	    if (A1_inlj(j,i)!=notdef)       {val[k]=A1_inlj(j,i);	col_ind[k]=(nl-1)*nc+j;	      k++;}
	                                     val[k]=A2_ij(j,i);      	col_ind[k]=ncnl+i*nc+j;	      k++;
	    row_ptr[ll]=k;
	    ll++;
	  }	   
	}
	A1_ij=im_x.get_mul(im_y).get_mul(data_out);
	A2_ij=im_y.get_mul(im_y).get_mul(data_out)+4.*alpha;A2_ij1=-1.*alpha;A2_ij_1=-1.*alpha;A2_i1j=-1.*alpha;A2_i_1j=-1.*alpha;
	A2_ijnc.fill(notdef);A2_ij0.fill(notdef);A2_inlj.fill(notdef);A2_i0j.fill(notdef);
	if (!periodic){fixNeumannConditions(nc,nl,A2_i_1j,A2_ij,A2_i1j,A2_ij_1,A2_ij1);}
	else{fixPeriodConditions(nc,nl,A2_i_1j,A2_i1j,A2_ij_1,A2_ij1,A2_ijnc,A2_ij0,A2_inlj,A2_i0j);}
	for (int i=0; i<nl; i++){
	  for (int j=0; j<nc; j++){
	                                    val[k]=A1_ij(j,i);      	col_ind[k]=i*nc+j;		k++;
	    if (A2_i0j(j,i)!=notdef)       {val[k]=A2_i0j(j,i);		col_ind[k]=ncnl+j;	        k++;}
	    if (A2_i_1j(j,i)!=notdef)       {val[k]=A2_i_1j(j,i);	col_ind[k]=ncnl+(i-1)*nc+j;   	k++;}
	    if (A2_ij0(j,i)!=notdef)        {val[k]=A2_ij0(j,i);	col_ind[k]=ncnl+i*nc;	      	k++;}
	    if (A2_ij_1(j,i)!=notdef)       {val[k]=A2_ij_1(j,i);	col_ind[k]=ncnl+i*nc+j-1;   	k++;}
	                                     val[k]=A2_ij(j,i);      	col_ind[k]=ncnl+i*nc+j;	    	k++;
	    if (A2_ij1(j,i)!=notdef)        {val[k]=A2_ij1(j,i);	col_ind[k]=ncnl+i*nc+j+1;   	k++;}	
	    if (A2_ijnc(j,i)!=notdef)       {val[k]=A2_ijnc(j,i);	col_ind[k]=ncnl+i*nc+nc-1;	k++;}
	    if (A2_i1j(j,i)!=notdef)       {val[k]=A2_i1j(j,i);		col_ind[k]=ncnl+(i+1)*nc+j;   	k++;}
	    if (A2_inlj(j,i)!=notdef)       {val[k]=A2_inlj(j,i);	col_ind[k]=ncnl+(nl-1)*nc+j;	k++;}
	    row_ptr[ll]=k; 
	    ll++;
	  }
	}


}
void fillingSparseHessian_A_HS(double *val,int *col_ind,int *row_ptr,const CImg<double> &im_x,const CImg<double> &im_y,const CImg<double> &data_out,const CImgList<double> &reg_out,float alpha,int nombre, bool periodic){
	int nc=im_x.width();
	int nl=im_x.height();		
	int ncnl=nc*nl;
	CImg <double> A1_ij(nc,nl); CImg <double> A2_ij(nc,nl);
	CImg <double> A1_i1j(nc,nl); CImg <double> A2_ij1(nc,nl);
	CImg <double> A1_i_1j(nc,nl); CImg <double> A2_ij_1(nc,nl);  
	CImg <double> A1_ij_1(nc,nl);	CImg <double> A2_i_1j(nc,nl);	
	CImg <double> A1_ij1(nc,nl);	CImg <double> A2_i1j(nc,nl);
	CImg <double> A1_ijnc(nc,nl);CImg <double> A1_ij0(nc,nl);CImg <double> A1_inlj(nc,nl);CImg <double> A1_i0j(nc,nl);
	CImg <double> A2_ijnc(nc,nl);CImg <double> A2_ij0(nc,nl);CImg <double> A2_inlj(nc,nl);CImg <double> A2_i0j(nc,nl);


	A1_ij=im_x.get_mul(im_x).get_mul(data_out);
	A1_ij+=alpha*(reg_out[1]+reg_out[1].get_shift(0,-1,0,0,2)+reg_out[0]+reg_out[0].get_shift(-1,0,0,0,2));
	A1_i1j=-1.*alpha*reg_out[1];
	A1_i_1j=-1.*alpha*reg_out[1].get_shift(0,-1,0,0,2);
	A1_ij1=-1.*alpha*reg_out[0];
	A1_ij_1=-1.*alpha*reg_out[0].get_shift(-1,0,0,0,2);
	A2_ij=im_x.get_mul(im_y).get_mul(data_out);
	A1_ijnc.fill(notdef);A1_ij0.fill(notdef);A1_inlj.fill(notdef);A1_i0j.fill(notdef);
	if (!periodic){fixNeumannConditions(nc,nl,A1_i_1j,A1_ij,A1_i1j,A1_ij_1,A1_ij1);}
	else{fixPeriodConditions(nc,nl,A1_i_1j,A1_i1j,A1_ij_1,A1_ij1,A1_ijnc,A1_ij0,A1_inlj,A1_i0j);}
	row_ptr[0]=0;
	int ll=1;
	int k=0;
	for (int i=0; i<nl; i++){
	  for (int j=0; j<nc; j++){
	       
	    if (A1_i0j(j,i)!=notdef)        {val[k]=A1_i0j(j,i);	col_ind[k]=j;	              k++;}
	    if (A1_i_1j(j,i)!=notdef)       {val[k]=A1_i_1j(j,i);	col_ind[k]=(i-1)*nc+j;        k++;}
	    if (A1_ij0(j,i)!=notdef)        {val[k]=A1_ij0(j,i);	col_ind[k]=i*nc;	      k++;}
	    if (A1_ij_1(j,i)!=notdef)       {val[k]=A1_ij_1(j,i);	col_ind[k]=i*nc+(j-1);        k++;}
	                                     val[k]=A1_ij(j,i);      	col_ind[k]=i*nc+j;	      k++;
	    if (A1_ij1(j,i)!=notdef)        {val[k]=A1_ij1(j,i);	col_ind[k]=i*nc+(j+1);        k++;}
	    if (A1_ijnc(j,i)!=notdef)       {val[k]=A1_ijnc(j,i);	col_ind[k]=i*nc+nc-1;	      k++;}
	    if (A1_i1j(j,i)!=notdef)        {val[k]=A1_i1j(j,i);	col_ind[k]=(i+1)*nc+j;        k++;}	
	    if (A1_inlj(j,i)!=notdef)       {val[k]=A1_inlj(j,i);	col_ind[k]=(nl-1)*nc+j;	      k++;}
	                                     val[k]=A2_ij(j,i);      	col_ind[k]=ncnl+i*nc+j;	      k++;
	    row_ptr[ll]=k;
	    ll++;
	  }	   
	}
	A1_ij=im_x.get_mul(im_y).get_mul(data_out);
	A2_ij=im_y.get_mul(im_y).get_mul(data_out);
	A2_ij+=alpha*(reg_out[1]+reg_out[1].get_shift(0,-1,0,0,2)+reg_out[0]+reg_out[0].get_shift(-1,0,0,0,2));
	A2_ij1=-1.*alpha*reg_out[0];
	A2_ij_1=-1.*alpha*reg_out[0].get_shift(-1,0,0,0,2);
	A2_i1j=-1.*alpha*reg_out[1];
	A2_i_1j=-1.*alpha*reg_out[1].get_shift(0,-1,0,0,2);
	A2_ijnc.fill(notdef);A2_ij0.fill(notdef);A2_inlj.fill(notdef);A2_i0j.fill(notdef);
	if (!periodic){fixNeumannConditions(nc,nl,A2_i_1j,A2_ij,A2_i1j,A2_ij_1,A2_ij1);}
	else{fixPeriodConditions(nc,nl,A2_i_1j,A2_i1j,A2_ij_1,A2_ij1,A2_ijnc,A2_ij0,A2_inlj,A2_i0j);}
	for (int i=0; i<nl; i++){
	  for (int j=0; j<nc; j++){
	                                    val[k]=A1_ij(j,i);      	col_ind[k]=i*nc+j;		k++;
	    if (A2_i0j(j,i)!=notdef)       {val[k]=A2_i0j(j,i);		col_ind[k]=ncnl+j;	        k++;}
	    if (A2_i_1j(j,i)!=notdef)       {val[k]=A2_i_1j(j,i);	col_ind[k]=ncnl+(i-1)*nc+j;   	k++;}
	    if (A2_ij0(j,i)!=notdef)        {val[k]=A2_ij0(j,i);	col_ind[k]=ncnl+i*nc;	      	k++;}
	    if (A2_ij_1(j,i)!=notdef)       {val[k]=A2_ij_1(j,i);	col_ind[k]=ncnl+i*nc+j-1;   	k++;}
	                                     val[k]=A2_ij(j,i);      	col_ind[k]=ncnl+i*nc+j;	    	k++;
	    if (A2_ij1(j,i)!=notdef)        {val[k]=A2_ij1(j,i);	col_ind[k]=ncnl+i*nc+j+1;   	k++;}	
	    if (A2_ijnc(j,i)!=notdef)       {val[k]=A2_ijnc(j,i);	col_ind[k]=ncnl+i*nc+nc-1;	k++;}
	    if (A2_i1j(j,i)!=notdef)       {val[k]=A2_i1j(j,i);		col_ind[k]=ncnl+(i+1)*nc+j;   	k++;}
	    if (A2_inlj(j,i)!=notdef)       {val[k]=A2_inlj(j,i);	col_ind[k]=ncnl+(nl-1)*nc+j;	k++;}
	    row_ptr[ll]=k; 
	    ll++;
	  }
	}


}

bool HornAndSchunck(CImg<double> &UV,const CImg<double> &UVtil,const CImg<double> &im_x,const CImg<double> &im_y,const CImg<double> &im_t,float alpha,const CImg<double> &data_out, bool periodic){


	bool error=false;
	int nc=im_x.width();
	int nl=im_x.height();		
	int ncnl=nc*nl;
	int nombre_cst;	
	int nombre_lap;
	nombre_cst=nc*nl;
	if (!periodic){nombre_lap=(int) (5*(nl-2)*(nc-2)+8*(nc-2)+8*(nl-2)+12);}
	else{nombre_lap=(int) 5*nl*nc;}
	int nombre=(int)(2*nombre_lap+2*nombre_cst);
	int taille=ncnl*2;
	double *val=new double[nombre];
	int *col_ind=new int[nombre];
	int *row_ptr=new int[taille+1];
	CImg<double> X(nc,nl,2);
	VECTOR_double B(taille,0.0);

	CImg <double> Delta_Util(nc,nl);
	CImg <double> Delta_Vtil(nc,nl);
	Delta_Util=laplacian(UVtil.get_slice(0),periodic);
	Delta_Vtil=laplacian(UVtil.get_slice(1),periodic);

	CImg <double> U(nc,nl); CImg <double> V(nc,nl); 
	CImg <double> Util(nc,nl); CImg <double> Vtil(nc,nl); 
	U=UV.get_slice(0);V=UV.get_slice(1);
	Util=UVtil.get_slice(0);Vtil=UVtil.get_slice(1);
	
	fillingSparseHessian_A_HS(val,col_ind,row_ptr,im_x,im_y,data_out,alpha,nombre,periodic);
	
	int k;
	for (int i=0 ; i<nl ; i++){
    	    for (int j=0 ; j<nc ; j++){
      		k = i*nc+j;		
		B(k)=-1.*im_t(j,i)*im_x(j,i)*data_out(j,i)+alpha*Delta_Util(j,i);
		B(ncnl+k)=-1.*im_t(j,i)*im_y(j,i)*data_out(j,i)+alpha*Delta_Vtil(j,i);
	    }		   	
	}

	if (standard_CGS_inversion(taille,nombre,val,row_ptr,col_ind,B,X)==0){;
	  for (int i=0; i<nl; i++){
  	   for (int j=0; j<nc; j++){ 
			UV(j,i,0)=X(j,i,0);
			UV(j,i,1)=X(j,i,1);
	   }
	  }
	}
	else{error=true;}

	delete [] val;delete [] col_ind;delete [] row_ptr;
	return error;

}
bool HornAndSchunck(CImg<double> &UV,const CImg<double> &UVtil,const CImg<double> &im_x,const CImg<double> &im_y,const CImg<double> &im_t,float alpha,const CImg<double> &data_out, const CImgList<double> &reg_out,bool periodic){


	bool error=false;
	int nc=im_x.width();
	int nl=im_x.height();		
	int ncnl=nc*nl;
	int nombre_cst;	
	int nombre_lap;
	nombre_cst=nc*nl;
	if (!periodic){nombre_lap=(int) (5*(nl-2)*(nc-2)+8*(nc-2)+8*(nl-2)+12);}
	else{nombre_lap=(int) 5*nl*nc;}
	int nombre=(int)(2*nombre_lap+2*nombre_cst);
	int taille=ncnl*2;
	double *val=new double[nombre];
	int *col_ind=new int[nombre];
	int *row_ptr=new int[taille+1];
	CImg<double> X(nc,nl,2);
	VECTOR_double B(taille,0.0);

	CImg <double> Delta_Util(nc,nl);
	CImg <double> Delta_Vtil(nc,nl);
	Delta_Util=laplacian(UVtil.get_slice(0),reg_out,periodic); 
	Delta_Vtil=laplacian(UVtil.get_slice(1),reg_out,periodic);

	CImg <double> U(nc,nl); CImg <double> V(nc,nl); 
	CImg <double> Util(nc,nl); CImg <double> Vtil(nc,nl); 
	U=UV.get_slice(0);V=UV.get_slice(1);
	Util=UVtil.get_slice(0);Vtil=UVtil.get_slice(1);
	
	fillingSparseHessian_A_HS(val,col_ind,row_ptr,im_x,im_y,data_out,reg_out,alpha,nombre,periodic);

	int k;
	for (int i=0 ; i<nl ; i++){
    	    for (int j=0 ; j<nc ; j++){
      		k = i*nc+j;		
		B(k)=-1.*im_t(j,i)*im_x(j,i)*data_out(j,i)+alpha*Delta_Util(j,i);
		B(ncnl+k)=-1.*im_t(j,i)*im_y(j,i)*data_out(j,i)+alpha*Delta_Vtil(j,i);
	    }		   	
	}

	if (standard_CGS_inversion(taille,nombre,val,row_ptr,col_ind,B,X)==0){;
	  for (int i=0; i<nl; i++){
  	   for (int j=0; j<nc; j++){ 
			UV(j,i,0)=X(j,i,0);
			UV(j,i,1)=X(j,i,1);
	   }
	  }
	}
	else{error=true;}

	delete [] val;delete [] col_ind;delete [] row_ptr;
	return error;

}
double DataEnergy(const CImg<double> &U, const CImg<double> &V,const CImg<double> &IxIx,const CImg<double> &IyIy,const CImg<double> &IxIy,const CImg<double> &ItIx,const CImg<double> &ItIy,const CImg<double> &ItIt,const CImg<double> data_out){

	double dataterm=0.5*(IxIx.get_mul(U).get_mul(U)+2*IxIy.get_mul(U).get_mul(V)+IyIy.get_mul(V).get_mul(V)).get_mul(data_out).sum()
	  +(ItIx.get_mul(U)+ItIy.get_mul(V)+0.5*ItIt).get_mul(data_out).sum();
	return dataterm;

}


	/*************************************************************************************************************/

	/*************************************************************************************************************/
	/********************************Number element in sparse Hessian Matrix**************************************/
	/*************************************************************************************************************/

	/*************************************************************************************************************/

int NumberNonZeroElementInHessian(const CImg<double> &im_x,const CImg<double> &im_y,const CImg<double> &data_out, const CImg<double> &lambda_S2,const CImg<double> &lambda_S2_cross, const CImgList <double> &z_right, const CImgList <double> &z_down, const CImgList <double> &z_rightDown, const CImgList <double> &z_rightUp, const CImgList <double> &z_t_right, const CImgList <double> &z_t_down, const CImgList <double> &z_t_rightDown, const CImgList <double> &z_t_rightUp,int scale,int neta, int lo){  	
	
	int nc=im_x.width();
	int nl=im_x.height();
	double nx,ny,nx_t,ny_t;
	if (lo > (nc/2.)-1 ||lo > (nl/2.)-1){  
		cout<<"Error : lo must respect lo <= nc/2 - 1 and lo <= nl/2 - 1"<<endl;
	}
	/***************************************** Bruhn data term ************************************/
	CImg<double> IxIx(nc,nl);	
	CImg<double> IyIy(nc,nl);	
	CImg<double> IxIy(nc,nl);
	CImg<double> ItIx(nc,nl);
	CImg<double> ItIy(nc,nl);
	IxIx=(im_x.get_mul(im_x));
	IyIy=(im_y.get_mul(im_y));
	IxIy=(im_x.get_mul(im_y));
	if (scale!=1){
	  IxIx=IxIx.get_blur(scale-1,true);
	  IyIy=IyIy.get_blur(scale-1,true);
	  IxIy=IxIy.get_blur(scale-1,true);
	}
	/*images intermediaires */
	CImg <double> A1_ij(nc,nl); CImg <double> A2_ij(nc,nl);
	/*HV long directions*/
	CImgList <double> A1_ijl(lo-neta+1,nc,nl);
	CImgList <double> A1_ij_l(lo-neta+1,nc,nl);	
	CImgList <double> A1_ilj(lo-neta+1,nc,nl);
	CImgList <double> A1_i_lj(lo-neta+1,nc,nl);
	CImgList <double> A2_ilj(lo-neta+1,nc,nl);	
	CImgList <double> A2_i_lj(lo-neta+1,nc,nl);	
	CImgList <double> A2_ijl(lo-neta+1,nc,nl);
	CImgList <double> A2_ij_l(lo-neta+1,nc,nl);
	/*cross long directions*/
	CImgList <double> A1_iljl(lo-neta+1,nc,nl); 
	CImgList <double> A1_i_lj_l(lo-neta+1,nc,nl);
	CImgList <double> A1_ilj_l(lo-neta+1,nc,nl); 
	CImgList <double> A1_i_ljl(lo-neta+1,nc,nl);
	CImgList <double> A2_iljl(lo-neta+1,nc,nl); 
	CImgList <double> A2_i_lj_l(lo-neta+1,nc,nl);
	CImgList <double> A2_ilj_l(lo-neta+1,nc,nl);
	CImgList <double> A2_i_ljl(lo-neta+1,nc,nl);
	/* Fonctions indicatrices */
	CImg <double> colOfOne(1,nl);colOfOne.fill(1.);
	CImg <double> lineOfOne(nc,1);lineOfOne.fill(1.);
	CImgList <double> IndLine1(lo+1,nc,1);CImgList <double> IndCol1(lo+1,1,nl);
	CImgList <double> IndLine2(lo+1,nc,1);CImgList <double> IndCol2(lo+1,1,nl);
	CImgList <double> IndLine3(lo+1,nc,1);CImgList <double> IndCol3(lo+1,1,nl);
	CImg <double> Ind1_long(nc,nl);CImg <double> Ind1_trans(nc,nl);
	CImg <double> Ind2_long(nc,nl);CImg <double> Ind2_trans(nc,nl);
	CImg <double> Ind3_long(nc,nl);CImg <double> Ind3_trans(nc,nl);
	
	for (int l=0;l<neta;l++){ 
		IndLine1[l].fill(0.);IndCol1[l].fill(0.);
		IndLine2[l].fill(0.);IndCol2[l].fill(0.);
		IndLine3[l].fill(0.);IndCol3[l].fill(0.);
	}
	for (int l=neta;l<=lo;l++){
		for (int j=0;j<nc;j++){
			if (j>=l && j<(nc-l)){ IndLine1[l](j,0)=1;}else{ IndLine1[l](j,0)=0;}
			if (j>=2*l){ IndLine2[l](j,0)=1; }else{ IndLine2[l](j,0)=0; }
			if (j<nc-2*l){ IndLine3[l](j,0)=1;}else{ IndLine3[l](j,0)=0;}
		}
		for (int i=0;i<nl;i++){
			if (i>=l && i<(nl-l)){ IndCol1[l](0,i)=1;}else{ IndCol1[l](0,i)=0;}
			if (i>=2*l){ IndCol2[l](0,i)=1;}else{ IndCol2[l](0,i)=0;}
			if (i<nl-2*l){ IndCol3[l](0,i)=1;}else{ IndCol3[l](0,i)=0;}
		}
	}
	/***************************************** Filling of matrix A to invert  ************************************/
	int gamma_HV=0,gamma_Cross=0;
	bool transverse=true;if (z_t_down[0].sum()==0){transverse=false;}
	int k;
	/**** first line of matrix A *****/			
	/* coefficient for the  left block of matrix A*/
	A1_ij=IxIx.get_mul(data_out);
	for (int l=neta;l<=lo;l++){  
	        A1_ijl[l-neta].fill(0.); A1_ij_l[l-neta].fill(0.);
	        A1_ilj[l-neta].fill(0.);A1_i_lj[l-neta].fill(0.);
		A1_iljl[l-neta].fill(0.); A1_i_lj_l[l-neta].fill(0.);
		A1_i_ljl[l-neta].fill(0.); A1_ilj_l[l-neta].fill(0.);
		Ind1_long=colOfOne*IndLine1[l];
		Ind2_long=colOfOne*IndLine2[l];
		Ind3_long=colOfOne*IndLine3[l];
		Ind1_trans=IndCol1[l]*lineOfOne;
		Ind2_trans=IndCol2[l]*lineOfOne;
		Ind3_trans=IndCol3[l]*lineOfOne;
		bool lcross=(l>=max((int)(neta/sqrt(2)),1))&&(l<=(int)(lo/sqrt(2))+1);
		gamma_HV =2*((nl-2*l)*nc+(nc-2*l)*nl);if (transverse){gamma_HV*=2.;}
		/*2 horizontal directions*/
		/*n(1,0)*/
		A1_ij+=lambda_S2(l)/gamma_HV*(+1*z_right[l-neta].get_mul(Ind1_long)+1*z_right[l-neta].get_shift(-l,0).get_mul(Ind2_long));
		A1_ijl[l-neta]+=lambda_S2(l)/gamma_HV*(-1*z_right[l-neta].get_mul(Ind1_long));
		A1_ij_l[l-neta]+=lambda_S2(l)/gamma_HV*(-1*z_right[l-neta].get_shift(-l,0).get_mul(Ind2_long));
		/* n(-1,0)*/
		A1_ij+=lambda_S2(l)/gamma_HV*(+1*z_right[l-neta].get_shift(-l,0).get_mul(Ind1_long)+1*z_right[l-neta].get_mul(Ind3_long));
		A1_ij_l[l-neta]+=lambda_S2(l)/gamma_HV*(-1*z_right[l-neta].get_shift(-l,0).get_mul(Ind1_long));
		A1_ijl[l-neta]+=lambda_S2(l)/gamma_HV*(-1*z_right[l-neta].get_mul(Ind3_long));
		/*2 vertical directions*/
		/*n(0,1)*/
		A1_ij+=lambda_S2(l)/gamma_HV*(+1*z_t_down[l-neta].get_mul(Ind1_trans)+1*z_t_down[l-neta].get_shift(0,-l).get_mul(Ind2_trans));
		A1_ilj[l-neta]+=lambda_S2(l)/gamma_HV*(-1*z_t_down[l-neta].get_mul(Ind1_trans));
		A1_i_lj[l-neta]+=lambda_S2(l)/gamma_HV*(-1*z_t_down[l-neta].get_shift(0,-l).get_mul(Ind2_trans));
		/* n(0,-1)*/
		A1_ij+=lambda_S2(l)/gamma_HV*(+1*z_t_down[l-neta].get_shift(0,-l).get_mul(Ind1_trans)+1*z_t_down[l-neta].get_mul(Ind3_trans));
		A1_i_lj[l-neta]+=lambda_S2(l)/gamma_HV*(-1*z_t_down[l-neta].get_shift(0,-l).get_mul(Ind1_trans));
		A1_ilj[l-neta]+=lambda_S2(l)/gamma_HV*(-1*z_t_down[l-neta].get_mul(Ind3_trans));
		/*4 cross directions */
		if (lcross){
		  gamma_Cross =4*(nl-2*l)*(nc-2*l);
		  if (transverse){gamma_Cross*=2.;}
		  /*n(+1,+1) n_t=(1,-1)*/
		  nx=+1/sqrt(2);ny=+1/sqrt(2);
		  A1_ij+=lambda_S2_cross(l)/gamma_Cross*(+1*nx*nx*z_rightDown[l-neta].get_mul(IndCol1[l]*IndLine1[l])
							 +1*nx*nx*z_rightDown[l-neta].get_shift(-l,-l).get_mul(IndCol2[l]*IndLine2[l]));
		  A1_iljl[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*nx*nx*z_rightDown[l-neta].get_mul(IndCol1[l]*IndLine1[l]));
		  A1_i_lj_l[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*nx*nx*z_rightDown[l-neta].get_shift(-l,-l).get_mul(IndCol2[l]*IndLine2[l]));
		  nx_t=1/sqrt(2);ny_t=-1/sqrt(2);
		  A1_ij+=lambda_S2_cross(l)/gamma_Cross*(+1*nx_t*nx_t*z_t_rightDown[l-neta].get_mul(IndCol1[l]*IndLine1[l])
							 +1*nx_t*nx_t*z_t_rightDown[l-neta].get_shift(-l,-l).get_mul(IndCol2[l]*IndLine2[l]));
		  A1_iljl[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*nx_t*nx_t*z_t_rightDown[l-neta].get_mul(IndCol1[l]*IndLine1[l]));
		  A1_i_lj_l[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*nx_t*nx_t*z_t_rightDown[l-neta].get_shift(-l,-l).get_mul(IndCol2[l]*IndLine2[l]));
		  /* n(-1,-1) n_t=(-1,1)*/
		  nx=-1/sqrt(2);ny=-1/sqrt(2);
		  A1_ij+=lambda_S2_cross(l)/gamma_Cross*(+1*nx*nx*z_rightDown[l-neta].get_shift(-l,-l).get_mul(IndCol1[l]*IndLine1[l])
							 +1*nx*nx*z_rightDown[l-neta].get_mul(IndCol3[l]*IndLine3[l]));
		  A1_i_lj_l[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*nx*nx*z_rightDown[l-neta].get_shift(-l,-l).get_mul(IndCol1[l]*IndLine1[l]));
		  A1_iljl[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*nx*nx*z_rightDown[l-neta].get_mul(IndCol3[l]*IndLine3[l]));
		  nx_t=-1/sqrt(2);ny_t=1/sqrt(2);
		  A1_ij+=lambda_S2_cross(l)/gamma_Cross*(+1*nx_t*nx_t*z_t_rightDown[l-neta].get_shift(-l,-l).get_mul(IndCol1[l]*IndLine1[l])
							 +1*nx_t*nx_t*z_t_rightDown[l-neta].get_mul(IndCol3[l]*IndLine3[l]));
		  A1_i_lj_l[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*nx_t*nx_t*z_t_rightDown[l-neta].get_shift(-l,-l).get_mul(IndCol1[l]*IndLine1[l]));
		  A1_iljl[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*nx_t*nx_t*z_t_rightDown[l-neta].get_mul(IndCol3[l]*IndLine3[l]));
		  /*n(1,-1) n_t=(-1,-1)*/
		  nx=1/sqrt(2);ny=-1/sqrt(2);
		  A1_ij+=lambda_S2_cross(l)/gamma_Cross*(+1*nx*nx*z_rightUp[l-neta].get_mul(IndCol1[l]*IndLine1[l])
							 +1*nx*nx*z_rightUp[l-neta].get_shift(-l,l).get_mul(IndCol3[l]*IndLine2[l]));
		  A1_i_ljl[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*nx*nx*z_rightUp[l-neta].get_mul(IndCol1[l]*IndLine1[l]));
		  A1_ilj_l[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*nx*nx*z_rightUp[l-neta].get_shift(-l,l).get_mul(IndCol3[l]*IndLine2[l]));
		  nx_t=-1/sqrt(2);ny_t=-1/sqrt(2);
		  A1_ij+=lambda_S2_cross(l)/gamma_Cross*(+1*nx_t*nx_t*z_t_rightUp[l-neta].get_mul(IndCol1[l]*IndLine1[l])
							 +1*nx_t*nx_t*z_t_rightUp[l-neta].get_shift(-l,l).get_mul(IndCol3[l]*IndLine2[l]));
		  A1_i_ljl[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*nx_t*nx_t*z_t_rightUp[l-neta].get_mul(IndCol1[l]*IndLine1[l]));
		  A1_ilj_l[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*nx_t*nx_t*z_t_rightUp[l-neta].get_shift(-l,l).get_mul(IndCol3[l]*IndLine2[l]));
		  /*n(-1,1) n_t=(1,1)*/
		  nx=-1/sqrt(2);ny=1/sqrt(2);
		  A1_ij+=lambda_S2_cross(l)/gamma_Cross*(+1*nx*nx*z_rightUp[l-neta].get_shift(-l,l).get_mul(IndCol1[l]*IndLine1[l])
							 +1*nx*nx*z_rightUp[l-neta].get_mul(IndCol2[l]*IndLine3[l]));
		  A1_ilj_l[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*nx*nx*z_rightUp[l-neta].get_shift(-l,l).get_mul(IndCol1[l]*IndLine1[l]));
		  A1_i_ljl[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*nx*nx*z_rightUp[l-neta].get_mul(IndCol2[l]*IndLine3[l]));
		  nx_t=1/sqrt(2);ny_t=1/sqrt(2);
		  A1_ij+=lambda_S2_cross(l)/gamma_Cross*(+1*nx_t*nx_t*z_t_rightUp[l-neta].get_shift(-l,l).get_mul(IndCol1[l]*IndLine1[l])
							 +1*nx_t*nx_t*z_t_rightUp[l-neta].get_mul(IndCol2[l]*IndLine3[l]));
		  A1_ilj_l[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*nx_t*nx_t*z_t_rightUp[l-neta].get_shift(-l,l).get_mul(IndCol1[l]*IndLine1[l]));
		  A1_i_ljl[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*nx_t*nx_t*z_t_rightUp[l-neta].get_mul(IndCol2[l]*IndLine3[l]));
		}
	}
	excludeWhite(neta,lo,A1_ij_l,A1_ijl,A1_i_lj,A1_ilj);
	excludeWhite(neta,lo,A1_iljl,A1_i_lj_l,A1_ilj_l,A1_i_ljl);
	/* coefficient for the right block of matrix A*/
	A2_ij=IxIy.get_mul(data_out);
	for (int l=neta;l<=lo;l++){  
		/*4 horizontal-vertical directions*/
	        A2_ijl[l-neta].fill(0.); A2_ij_l[l-neta].fill(0.);
	        A2_ilj[l-neta].fill(0.);A2_i_lj[l-neta].fill(0.);
	        A2_iljl[l-neta].fill(0.); A2_i_lj_l[l-neta].fill(0.);
		A2_i_ljl[l-neta].fill(0.); A2_ilj_l[l-neta].fill(0.);
		/*4 cross directions */
		bool lcross=(l>=max((int)(neta/sqrt(2)),1))&&(l<=(int)(lo/sqrt(2))+1);
		if (lcross){
		  gamma_Cross =4*(nl-2*l)*(nc-2*l);
		  if (transverse){gamma_Cross*=2.;}
		  /*n(+1,+1) n_t=(1,-1)*/
		  nx=+1/sqrt(2);ny=+1/sqrt(2);
		  A2_ij+=lambda_S2_cross(l)/gamma_Cross*(+1*ny*nx*z_rightDown[l-neta].get_mul(IndCol1[l]*IndLine1[l])
							 +1*ny*nx*z_rightDown[l-neta].get_shift(-l,-l).get_mul(IndCol2[l]*IndLine2[l]));
		  A2_iljl[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny*nx*z_rightDown[l-neta].get_mul(IndCol1[l]*IndLine1[l]));
		  A2_i_lj_l[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny*nx*z_rightDown[l-neta].get_shift(-l,-l).get_mul(IndCol2[l]*IndLine2[l]));
		  nx_t=1/sqrt(2);ny_t=-1/sqrt(2);
		  A2_ij+=lambda_S2_cross(l)/gamma_Cross*(+1*ny_t*nx_t*z_t_rightDown[l-neta].get_mul(IndCol1[l]*IndLine1[l])
							 +1*ny_t*nx_t*z_t_rightDown[l-neta].get_shift(-l,-l).get_mul(IndCol2[l]*IndLine2[l]));
		  A2_iljl[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny_t*nx_t*z_t_rightDown[l-neta].get_mul(IndCol1[l]*IndLine1[l]));
		  A2_i_lj_l[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny_t*nx_t*z_t_rightDown[l-neta].get_shift(-l,-l).get_mul(IndCol2[l]*IndLine2[l]));
		  /* n(-1,-1) n_t=(-1,1)*/
		  nx=-1/sqrt(2);ny=-1/sqrt(2);
		  A2_ij+=lambda_S2_cross(l)/gamma_Cross*(+1*ny*nx*z_rightDown[l-neta].get_shift(-l,-l).get_mul(IndCol1[l]*IndLine1[l])
							 +1*ny*nx*z_rightDown[l-neta].get_mul(IndCol3[l]*IndLine3[l]));
		  A2_i_lj_l[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny*nx*z_rightDown[l-neta].get_shift(-l,-l).get_mul(IndCol1[l]*IndLine1[l]));
		  A2_iljl[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny*nx*z_rightDown[l-neta].get_mul(IndCol3[l]*IndLine3[l]));
		  nx_t=-1/sqrt(2);ny_t=1/sqrt(2);
		  A2_ij+=lambda_S2_cross(l)/gamma_Cross*(+1*ny_t*nx_t*z_t_rightDown[l-neta].get_shift(-l,-l).get_mul(IndCol1[l]*IndLine1[l])
							 +1*ny_t*nx_t*z_t_rightDown[l-neta].get_mul(IndCol3[l]*IndLine3[l]));
		  A2_i_lj_l[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny_t*nx_t*z_t_rightDown[l-neta].get_shift(-l,-l).get_mul(IndCol1[l]*IndLine1[l]));
		  A2_iljl[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny_t*nx_t*z_t_rightDown[l-neta].get_mul(IndCol3[l]*IndLine3[l]));
		  /*n(1,-1) n_t=(-1,-1)*/
		  nx=1/sqrt(2);ny=-1/sqrt(2);
		  A2_ij+=lambda_S2_cross(l)/gamma_Cross*(+1*ny*nx*z_rightUp[l-neta].get_mul(IndCol1[l]*IndLine1[l])
							 +1*ny*nx*z_rightUp[l-neta].get_shift(-l,l).get_mul(IndCol3[l]*IndLine2[l]));
		  A2_i_ljl[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny*nx*z_rightUp[l-neta].get_mul(IndCol1[l]*IndLine1[l]));
		  A2_ilj_l[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny*nx*z_rightUp[l-neta].get_shift(-l,l).get_mul(IndCol3[l]*IndLine2[l]));
		  nx_t=-1/sqrt(2);ny_t=-1/sqrt(2);
		  A2_ij+=lambda_S2_cross(l)/gamma_Cross*(+1*ny_t*nx_t*z_t_rightUp[l-neta].get_mul(IndCol1[l]*IndLine1[l])
							 +1*ny_t*nx_t*z_t_rightUp[l-neta].get_shift(-l,l).get_mul(IndCol3[l]*IndLine2[l]));
		  A2_i_ljl[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny_t*nx_t*z_t_rightUp[l-neta].get_mul(IndCol1[l]*IndLine1[l]));
		  A2_ilj_l[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny_t*nx_t*z_t_rightUp[l-neta].get_shift(-l,l).get_mul(IndCol3[l]*IndLine2[l]));
		  /*n(-1,1) n_t=(1,1)*/
		  nx=-1/sqrt(2);ny=1/sqrt(2);
		  A2_ij+=lambda_S2_cross(l)/gamma_Cross*(+1*ny*nx*z_rightUp[l-neta].get_shift(-l,l).get_mul(IndCol1[l]*IndLine1[l])
							 +1*ny*nx*z_rightUp[l-neta].get_mul(IndCol2[l]*IndLine3[l]));
		  A2_ilj_l[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny*nx*z_rightUp[l-neta].get_shift(-l,l).get_mul(IndCol1[l]*IndLine1[l]));
		  A2_i_ljl[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny*nx*z_rightUp[l-neta].get_mul(IndCol2[l]*IndLine3[l]));
		  nx_t=1/sqrt(2);ny_t=1/sqrt(2);
		  A2_ij+=lambda_S2_cross(l)/gamma_Cross*(+1*ny_t*nx_t*z_t_rightUp[l-neta].get_shift(-l,l).get_mul(IndCol1[l]*IndLine1[l])
							 +1*ny_t*nx_t*z_t_rightUp[l-neta].get_mul(IndCol2[l]*IndLine3[l]));	  
		  A2_ilj_l[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny_t*nx_t*z_t_rightUp[l-neta].get_shift(-l,l).get_mul(IndCol1[l]*IndLine1[l]));
		  A2_i_ljl[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny_t*nx_t*z_t_rightUp[l-neta].get_mul(IndCol2[l]*IndLine3[l]));
		}
	}
	excludeWhite(neta,lo,A2_ij_l,A2_ijl,A2_i_lj,A2_ilj);
	excludeWhite(neta,lo,A2_iljl,A2_i_lj_l,A2_ilj_l,A2_i_ljl);
	/*filling matrix A */
	k=0;
	for (int i=0; i<nl; i++){
	  for (int j=0; j<nc; j++){		
	    for (int l=lo;l>=neta;l--){
	      bool lcross=(l>=max((int)(neta/sqrt(2)),1))&&(l<=(int)(lo/sqrt(2))+1);
	      if(lcross&&A1_i_lj_l[l-neta](j,i)!=notdef){				k++;}		    
	      if(A1_i_lj[l-neta](j,i)!=notdef){						k++;}
	      if(lcross&&A1_i_ljl[l-neta](j,i)!=notdef){				k++;}
	    }
			
	    for (int l=lo;l>=neta;l--){
	      if (A1_ij_l[l-neta](j,i)!=notdef) {					k++;}
	    }
	                                                                                k++;
	    for (int l=neta;l<=lo;l++){
	      if (A1_ijl[l-neta](j,i)!=notdef)  {					k++;} 
	    }
	    for (int l=neta;l<=lo;l++){
	      bool lcross=(l>=max((int)(neta/sqrt(2)),1))&&(l<=(int)(lo/sqrt(2))+1);
	      if(lcross&& A1_ilj_l[l-neta](j,i)!=notdef){				k++;}
	      if(A1_ilj[l-neta](j,i)!=notdef){						k++;}
	      if(lcross&& A1_iljl[l-neta](j,i)!=notdef){				k++;}
	    }
	    
	    for (int l=lo;l>=neta;l--){
	      bool lcross=(l>=max((int)(neta/sqrt(2)),1))&&(l<=(int)(lo/sqrt(2))+1);
	      if(lcross&&A2_i_lj_l[l-neta](j,i)!=notdef){				k++;} 
	      if(A2_i_lj[l-neta](j,i)!=notdef){						k++;}
	      if(lcross&&A2_i_ljl[l-neta](j,i)!=notdef){				k++;}
	    }
	    for (int l=lo;l>=neta;l--){
	      if (A2_ij_l[l-neta](j,i)!=notdef) {					k++;}
	    }
	                                                                                k++;
	    for (int l=neta;l<=lo;l++){
	      if (A2_ijl[l-neta](j,i)!=notdef)  {					k++;} 
	    }
	    for (int l=neta;l<=lo;l++){
	      bool lcross=(l>=max((int)(neta/sqrt(2)),1))&&(l<=(int)(lo/sqrt(2))+1);
	      if(lcross&& A2_ilj_l[l-neta](j,i)!=notdef){				k++;}
	      if(A2_ilj[l-neta](j,i)!=notdef){						k++;}
	      if(lcross&& A2_iljl[l-neta](j,i)!=notdef){				k++;}
	    }
	  }	   
	}
	
	/**** second line of matrix A *****/
	/* coefficient for the  left block of matrix A*/
	A1_ij=IxIy.get_mul(data_out);	
	for (int l=neta;l<=lo;l++){  
		/*4 horizontal-vertical directions*/
	        A1_ijl[l-neta].fill(0.); A1_ij_l[l-neta].fill(0.);
	        A1_ilj[l-neta].fill(0.);A1_i_lj[l-neta].fill(0.);
	        A1_iljl[l-neta].fill(0.); A1_i_lj_l[l-neta].fill(0.);
		A1_i_ljl[l-neta].fill(0.); A1_ilj_l[l-neta].fill(0.);
		/*4 cross directions*/
		bool lcross=(l>=max((int)(neta/sqrt(2)),1))&&(l<=(int)(lo/sqrt(2))+1);
		if (lcross){
		  gamma_Cross =4*(nl-2*l)*(nc-2*l);
		  if (transverse){gamma_Cross*=2.;}
		  /*n(+1,+1) n_t=(1,-1)*/
		  nx=+1/sqrt(2);ny=+1/sqrt(2);
		  A1_ij+=lambda_S2_cross(l)/gamma_Cross*(+1*ny*nx*z_rightDown[l-neta].get_mul(IndCol1[l]*IndLine1[l])
							 +1*ny*nx*z_rightDown[l-neta].get_shift(-l,-l).get_mul(IndCol2[l]*IndLine2[l]));
		  A1_iljl[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny*nx*z_rightDown[l-neta].get_mul(IndCol1[l]*IndLine1[l]));
		  A1_i_lj_l[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny*nx*z_rightDown[l-neta].get_shift(-l,-l).get_mul(IndCol2[l]*IndLine2[l]));
		  nx_t=1/sqrt(2);ny_t=-1/sqrt(2);
		  A1_ij+=lambda_S2_cross(l)/gamma_Cross*(+1*ny_t*nx_t*z_t_rightDown[l-neta].get_mul(IndCol1[l]*IndLine1[l])
							 +1*ny_t*nx_t*z_t_rightDown[l-neta].get_shift(-l,-l).get_mul(IndCol2[l]*IndLine2[l]));
		  A1_iljl[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny_t*nx_t*z_t_rightDown[l-neta].get_mul(IndCol1[l]*IndLine1[l]));
		  A1_i_lj_l[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny_t*nx_t*z_t_rightDown[l-neta].get_shift(-l,-l).get_mul(IndCol2[l]*IndLine2[l]));
		  /* n(-1,-1)  n_t=(-1,1)*/
		  nx=-1/sqrt(2);ny=-1/sqrt(2);
		  A1_ij+=lambda_S2_cross(l)/gamma_Cross*(+1*ny*nx*z_rightDown[l-neta].get_shift(-l,-l).get_mul(IndCol1[l]*IndLine1[l])
							 +1*ny*nx*z_rightDown[l-neta].get_mul(IndCol3[l]*IndLine3[l]));
		  A1_i_lj_l[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny*nx*z_rightDown[l-neta].get_shift(-l,-l).get_mul(IndCol1[l]*IndLine1[l]));
		  A1_iljl[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny*nx*z_rightDown[l-neta].get_mul(IndCol3[l]*IndLine3[l]));
		  nx_t=-1/sqrt(2);ny_t=1/sqrt(2);
		  A1_ij+=lambda_S2_cross(l)/gamma_Cross*(+1*ny_t*nx_t*z_t_rightDown[l-neta].get_shift(-l,-l).get_mul(IndCol1[l]*IndLine1[l])
							 +1*ny_t*nx_t*z_t_rightDown[l-neta].get_mul(IndCol3[l]*IndLine3[l]));
		  A1_i_lj_l[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny_t*nx_t*z_t_rightDown[l-neta].get_shift(-l,-l).get_mul(IndCol1[l]*IndLine1[l]));
		  A1_iljl[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny_t*nx_t*z_t_rightDown[l-neta].get_mul(IndCol3[l]*IndLine3[l]));
		  /*n(1,-1)  n_t=(-1,-1)*/
		  nx=1/sqrt(2);ny=-1/sqrt(2);
		  A1_ij+=lambda_S2_cross(l)/gamma_Cross*(+1*ny*nx*z_rightUp[l-neta].get_mul(IndCol1[l]*IndLine1[l])
							 +1*ny*nx*z_rightUp[l-neta].get_shift(-l,l).get_mul(IndCol3[l]*IndLine2[l]));
		  A1_i_ljl[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny*nx*z_rightUp[l-neta].get_mul(IndCol1[l]*IndLine1[l]));
		  A1_ilj_l[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny*nx*z_rightUp[l-neta].get_shift(-l,l).get_mul(IndCol3[l]*IndLine2[l]));
		  nx_t=-1/sqrt(2);ny_t=-1/sqrt(2);
		  A1_ij+=lambda_S2_cross(l)/gamma_Cross*(+1*ny_t*nx_t*z_t_rightUp[l-neta].get_mul(IndCol1[l]*IndLine1[l])
							 +1*ny_t*nx_t*z_t_rightUp[l-neta].get_shift(-l,l).get_mul(IndCol3[l]*IndLine2[l]));
		  A1_i_ljl[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny_t*nx_t*z_t_rightUp[l-neta].get_mul(IndCol1[l]*IndLine1[l]));
		  A1_ilj_l[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny_t*nx_t*z_t_rightUp[l-neta].get_shift(-l,l).get_mul(IndCol3[l]*IndLine2[l]));
		  /*n(-1,1)  n_t=(1,1)*/
		  nx=-1/sqrt(2);ny=1/sqrt(2);
		  A1_ij+=lambda_S2_cross(l)/gamma_Cross*(+1*ny*nx*z_rightUp[l-neta].get_shift(-l,l).get_mul(IndCol1[l]*IndLine1[l])
							 +1*ny*nx*z_rightUp[l-neta].get_mul(IndCol2[l]*IndLine3[l]));
		  
		  A1_ilj_l[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny*nx*z_rightUp[l-neta].get_shift(-l,l).get_mul(IndCol1[l]*IndLine1[l]));
		  A1_i_ljl[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny*nx*z_rightUp[l-neta].get_mul(IndCol2[l]*IndLine3[l]));
		  nx_t=1/sqrt(2);ny_t=1/sqrt(2);
		  A1_ij+=lambda_S2_cross(l)/gamma_Cross*(+1*ny_t*nx_t*z_t_rightUp[l-neta].get_shift(-l,l).get_mul(IndCol1[l]*IndLine1[l])
							 +1*ny_t*nx_t*z_t_rightUp[l-neta].get_mul(IndCol2[l]*IndLine3[l]));
		  
		  A1_ilj_l[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny_t*nx_t*z_t_rightUp[l-neta].get_shift(-l,l).get_mul(IndCol1[l]*IndLine1[l]));
		  A1_i_ljl[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny_t*nx_t*z_t_rightUp[l-neta].get_mul(IndCol2[l]*IndLine3[l]));
		}
	}
	excludeWhite(neta,lo,A1_ij_l,A1_ijl,A1_i_lj,A1_ilj);
	excludeWhite(neta,lo,A1_iljl,A1_i_lj_l,A1_ilj_l,A1_i_ljl);	  
	/* coefficient for the right block of matrix A*/
	A2_ij=IyIy.get_mul(data_out);
	for (int l=neta;l<=lo;l++){  
	        A2_ijl[l-neta].fill(0.); A2_ij_l[l-neta].fill(0.);
	        A2_ilj[l-neta].fill(0.);A2_i_lj[l-neta].fill(0.);
		A2_iljl[l-neta].fill(0.); A2_i_lj_l[l-neta].fill(0.);
		A2_i_ljl[l-neta].fill(0.); A2_ilj_l[l-neta].fill(0.);
		Ind1_long=colOfOne*IndLine1[l];
		Ind2_long=colOfOne*IndLine2[l];
		Ind3_long=colOfOne*IndLine3[l];
		Ind1_trans=IndCol1[l]*lineOfOne;
		Ind2_trans=IndCol2[l]*lineOfOne;
		Ind3_trans=IndCol3[l]*lineOfOne;
		bool lcross=(l>=max((int)(neta/sqrt(2)),1))&&(l<=(int)(lo/sqrt(2))+1);
		gamma_HV =2*((nl-2*l)*nc+(nc-2*l)*nl);if (transverse){gamma_HV*=2.;}
		/*2 vertical directions*/
		/*n(0,1)*/
		A2_ij+=lambda_S2(l)/gamma_HV*(+1*z_down[l-neta].get_mul(Ind1_trans)+1*z_down[l-neta].get_shift(0,-l).get_mul(Ind2_trans));
		A2_ilj[l-neta]+=lambda_S2(l)/gamma_HV*(-1*z_down[l-neta].get_mul(Ind1_trans));
		A2_i_lj[l-neta]+=lambda_S2(l)/gamma_HV*(-1*z_down[l-neta].get_shift(0,-l).get_mul(Ind2_trans));
		/* n(0,-1)*/
		A2_ij+=lambda_S2(l)/gamma_HV*(+1*z_down[l-neta].get_shift(0,-l).get_mul(Ind1_trans)+1*z_down[l-neta].get_mul(Ind3_trans));
		A2_i_lj[l-neta]+=lambda_S2(l)/gamma_HV*(-1*z_down[l-neta].get_shift(0,-l).get_mul(Ind1_trans));
		A2_ilj[l-neta]+=lambda_S2(l)/gamma_HV*(-1*z_down[l-neta].get_mul(Ind3_trans));
		/*2 horizontal directions*/
		/*n(1,0)*/
		A2_ij+=lambda_S2(l)/gamma_HV*(+1*z_t_right[l-neta].get_mul(Ind1_long)+1*z_t_right[l-neta].get_shift(-l,0).get_mul(Ind2_long));
		A2_ijl[l-neta]+=lambda_S2(l)/gamma_HV*(-1*z_t_right[l-neta].get_mul(Ind1_long));
		A2_ij_l[l-neta]+=lambda_S2(l)/gamma_HV*(-1*z_t_right[l-neta].get_shift(-l,0).get_mul(Ind2_long));
		/* n(-1,0)*/
		A2_ij+=lambda_S2(l)/gamma_HV*(+1*z_t_right[l-neta].get_shift(-l,0).get_mul(Ind1_long)+1*z_t_right[l-neta].get_mul(Ind3_long));
		A2_ij_l[l-neta]+=lambda_S2(l)/gamma_HV*(-1*z_t_right[l-neta].get_shift(-l,0).get_mul(Ind1_long));
		A2_ijl[l-neta]+=lambda_S2(l)/gamma_HV*(-1*z_t_right[l-neta].get_mul(Ind3_long));
		/*4 cross directions*/
		if (lcross){
		  gamma_Cross =4*(nl-2*l)*(nc-2*l);
		  if (transverse){gamma_Cross*=2.;}
		  /*n(+1,+1) n_t=(1,-1)*/
		  nx=+1/sqrt(2);ny=+1/sqrt(2);
		  A2_ij+=lambda_S2_cross(l)/gamma_Cross*(+1*ny*ny*z_rightDown[l-neta].get_mul(IndCol1[l]*IndLine1[l])
							 +1*ny*ny*z_rightDown[l-neta].get_shift(-l,-l).get_mul(IndCol2[l]*IndLine2[l]));
		  A2_iljl[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny*ny*z_rightDown[l-neta].get_mul(IndCol1[l]*IndLine1[l]));
		  A2_i_lj_l[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny*ny*z_rightDown[l-neta].get_shift(-l,-l).get_mul(IndCol2[l]*IndLine2[l]));
		  nx_t=1/sqrt(2);ny_t=-1/sqrt(2);
		  A2_ij+=lambda_S2_cross(l)/gamma_Cross*(+1*ny_t*ny_t*z_t_rightDown[l-neta].get_mul(IndCol1[l]*IndLine1[l])
							 +1*ny_t*ny_t*z_t_rightDown[l-neta].get_shift(-l,-l).get_mul(IndCol2[l]*IndLine2[l]));
		  A2_iljl[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny_t*ny_t*z_t_rightDown[l-neta].get_mul(IndCol1[l]*IndLine1[l]));
		  A2_i_lj_l[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny_t*ny_t*z_t_rightDown[l-neta].get_shift(-l,-l).get_mul(IndCol2[l]*IndLine2[l]));
		  /* n(-1,-1)  n_t=(-1,1)*/
		  nx=-1/sqrt(2);ny=-1/sqrt(2);
		  A2_ij+=lambda_S2_cross(l)/gamma_Cross*(+1*ny*ny*z_rightDown[l-neta].get_shift(-l,-l).get_mul(IndCol1[l]*IndLine1[l])
							 +1*ny*ny*z_rightDown[l-neta].get_mul(IndCol3[l]*IndLine3[l]));
		  A2_i_lj_l[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny*ny*z_rightDown[l-neta].get_shift(-l,-l).get_mul(IndCol1[l]*IndLine1[l]));
		  A2_iljl[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny*ny*z_rightDown[l-neta].get_mul(IndCol3[l]*IndLine3[l]));
		  nx_t=-1/sqrt(2);ny_t=1/sqrt(2);
		  A2_ij+=lambda_S2_cross(l)/gamma_Cross*(+1*ny_t*ny_t*z_t_rightDown[l-neta].get_shift(-l,-l).get_mul(IndCol1[l]*IndLine1[l])
							 +1*ny_t*ny_t*z_t_rightDown[l-neta].get_mul(IndCol3[l]*IndLine3[l]));
		  A2_i_lj_l[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny_t*ny_t*z_t_rightDown[l-neta].get_shift(-l,-l).get_mul(IndCol1[l]*IndLine1[l]));
		  A2_iljl[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny_t*ny_t*z_t_rightDown[l-neta].get_mul(IndCol3[l]*IndLine3[l]));
		  /*n(1,-1)  n_t=(-1,-1)*/
		  nx=1/sqrt(2);ny=-1/sqrt(2);
		  A2_ij+=lambda_S2_cross(l)/gamma_Cross*(+1*ny*ny*z_rightUp[l-neta].get_mul(IndCol1[l]*IndLine1[l])
							 +1*ny*ny*z_rightUp[l-neta].get_shift(-l,l).get_mul(IndCol3[l]*IndLine2[l]));
		  A2_i_ljl[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny*ny*z_rightUp[l-neta].get_mul(IndCol1[l]*IndLine1[l]));
		  A2_ilj_l[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny*ny*z_rightUp[l-neta].get_shift(-l,l).get_mul(IndCol3[l]*IndLine2[l]));
		  nx_t=-1/sqrt(2);ny_t=-1/sqrt(2);
		  A2_ij+=lambda_S2_cross(l)/gamma_Cross*(+1*ny_t*ny_t*z_t_rightUp[l-neta].get_mul(IndCol1[l]*IndLine1[l])
							 +1*ny_t*ny_t*z_t_rightUp[l-neta].get_shift(-l,l).get_mul(IndCol3[l]*IndLine2[l]));
		  A2_i_ljl[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny_t*ny_t*z_t_rightUp[l-neta].get_mul(IndCol1[l]*IndLine1[l]));
		  A2_ilj_l[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny_t*ny_t*z_t_rightUp[l-neta].get_shift(-l,l).get_mul(IndCol3[l]*IndLine2[l]));
		  /*n(-1,1) n_t=(1,1)*/
		  nx=-1/sqrt(2);ny=1/sqrt(2);
		  A2_ij+=lambda_S2_cross(l)/gamma_Cross*(+1*ny*ny*z_rightUp[l-neta].get_shift(-l,l).get_mul(IndCol1[l]*IndLine1[l])
							 +1*ny*ny*z_rightUp[l-neta].get_mul(IndCol2[l]*IndLine3[l]));
		  A2_ilj_l[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny*ny*z_rightUp[l-neta].get_shift(-l,l).get_mul(IndCol1[l]*IndLine1[l]));
		  A2_i_ljl[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny*ny*z_rightUp[l-neta].get_mul(IndCol2[l]*IndLine3[l]));
		  nx_t=1/sqrt(2);ny_t=1/sqrt(2);
		  A2_ij+=lambda_S2_cross(l)/gamma_Cross*(+1*ny_t*ny_t*z_t_rightUp[l-neta].get_shift(-l,l).get_mul(IndCol1[l]*IndLine1[l])
							 +1*ny_t*ny_t*z_t_rightUp[l-neta].get_mul(IndCol2[l]*IndLine3[l]));
		  A2_ilj_l[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny_t*ny_t*z_t_rightUp[l-neta].get_shift(-l,l).get_mul(IndCol1[l]*IndLine1[l]));
		  A2_i_ljl[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny_t*ny_t*z_t_rightUp[l-neta].get_mul(IndCol2[l]*IndLine3[l]));
		}
	}
	excludeWhite(neta,lo,A2_ij_l,A2_ijl,A2_i_lj,A2_ilj);
	excludeWhite(neta,lo,A2_iljl,A2_i_lj_l,A2_ilj_l,A2_i_ljl);
	/*filling  matrix A */
	for (int i=0; i<nl; i++){
	  for (int j=0; j<nc; j++){
	    for (int l=neta;l<=lo;l++){
	      bool lcross=(l>=max((int)(neta/sqrt(2)),1))&&(l<=(int)(lo/sqrt(2))+1);
	      if(lcross && A1_i_lj_l[l-neta](j,i)!=notdef){			k++;}
	      if(A1_i_lj[l-neta](j,i)!=notdef){					k++;}
	      if(lcross && A1_i_ljl[l-neta](j,i)!=notdef){			k++;}
	    }															
	    for (int l=lo;l>=neta;l--){
	      if (A1_ij_l[l-neta](j,i)!=notdef) {				k++;}
	    }
	                                                                        k++;
	    for (int l=neta;l<=lo;l++){
	      if (A1_ijl[l-neta](j,i)!=notdef)  {				k++;} 
	    }
	    for (int l=neta;l<=lo;l++){
	      bool lcross=(l>=max((int)(neta/sqrt(2)),1))&&(l<=(int)(lo/sqrt(2))+1);
	      if(lcross && A1_ilj_l[l-neta](j,i)!=notdef){			k++;}
	      if(A1_ilj[l-neta](j,i)!=notdef){					k++;}
	      if(lcross && A1_iljl[l-neta](j,i)!=notdef){			k++;}
	    }
	    
	    for (int l=lo;l>=neta;l--){
	      bool lcross=(l>=max((int)(neta/sqrt(2)),1))&&(l<=(int)(lo/sqrt(2))+1);
	      if(lcross && A2_i_lj_l[l-neta](j,i)!=notdef){			k++;}
	      if(A2_i_lj[l-neta](j,i)!=notdef){					k++;}
	      if(lcross && A2_i_ljl[l-neta](j,i)!=notdef){			k++;}
	    }
	    
	    for (int l=lo;l>=neta;l--){
	      if (A2_ij_l[l-neta](j,i)!=notdef) {				k++;}
	    }
	         								k++;
	    for (int l=neta;l<=lo;l++){
	      if (A2_ijl[l-neta](j,i)!=notdef)  {				k++;} 
	    }
	    for (int l=neta;l<=lo;l++){
	      bool lcross=(l>=max((int)(neta/sqrt(2)),1))&&(l<=(int)(lo/sqrt(2))+1);
	      if(lcross && A2_ilj_l[l-neta](j,i)!=notdef){			k++;}
	      if(A2_ilj[l-neta](j,i)!=notdef){					k++;}
	      if(lcross && A2_iljl[l-neta](j,i)!=notdef){			k++;}
	    }
	   
	  }
	}


	/*************************************************************************************************************/
	return k;	
}

int NumberNonZeroElementInHessian_Gen_Rob_BruhnAndAl(const CImg<double> &im_x,const CImg<double> &im_y,const CImg<double> data_out, const CImg<double> &lambda_S2, const CImg<double> &lambda_S2_cross,const CImgList <double> &z_right, const CImgList <double> &z_down, const CImgList <double> &z_rightDown, const CImgList <double> &z_rightUp,const CImgList <double> &z_t_right, const CImgList <double> &z_t_down, const CImgList <double> &z_t_rightDown, const CImgList <double> &z_t_rightUp,int scale, int lo){
  int neta=1;
  return NumberNonZeroElementInHessian(im_x,im_y,data_out,lambda_S2,lambda_S2_cross,z_right,z_down,z_rightDown,z_rightUp,z_t_right,z_t_down,z_t_rightDown,z_t_rightUp,scale,neta,lo);
}

int NumberNonZeroElementInHessian_Gen_BruhnAndAl(const CImg<double> &im_x,const CImg<double> &im_y,const CImg<double> data_out, const CImg<double> &lambda_S2, const CImg<double> &lambda_S2_cross,int scale, int lo){
  int neta=1;
  CImgList <double> z_tmp(lo-neta+1,im_x.width(),im_x.height());for (int k=0;k<=lo-neta;k++){z_tmp[k].fill(1.);}
  CImgList <double> z_t_tmp(lo-neta+1,im_x.width(),im_x.height());for (int k=0;k<=lo-neta;k++){z_t_tmp[k].fill(1.);}
  return NumberNonZeroElementInHessian(im_x,im_y,data_out,lambda_S2,lambda_S2_cross,z_tmp,z_tmp,z_tmp,z_tmp,z_t_tmp,z_t_tmp,z_t_tmp,z_t_tmp,scale,neta,lo);
}


	/*************************************************************************************************************/

	/*************************************************************************************************************/
	/********************************Log determinant of sparse Hessian Matrix*************************************/
	/*************************************************************************************************************/

	/*************************************************************************************************************/

double logdetA(const CImg<double> &im_x,const CImg<double> &im_y,const CImg<double> &im_t,const CImg<double> data_out, const CImg<double> &lambda_S2,const CImg<double> &lambda_S2_cross,const CImgList <double> &z_right, const CImgList <double> &z_down, const CImgList <double> &z_rightDown, const CImgList <double> &z_rightUp,const CImgList <double> &z_t_right, const CImgList <double> &z_t_down, const CImgList <double> &z_t_rightDown, const CImgList <double> &z_t_rightUp,int scale, int neta, int lo, int nombre){ 
 	nombre*=1.2; //borne superieur pour eviter de s embeter a calculer precisement les effets de bords deterministe sur le nombre
	//cout<<"number : "<<nombre<<endl;
	double logdetA;
	int k;
	int nc=im_x.width();
	int nl=im_x.height();		
	int ncnl=nc*nl;
	if (lo > (nc/2.) ||lo > (nl/2.)){  
		cout<<"Error : lo must respect lo <= nc/2 and lo <= nl/2"<<endl;
	}	
	/***************************************** Bruhn data term ************************************/
	CImg<double> IxIx(nc,nl);	
	CImg<double> IyIy(nc,nl);	
	CImg<double> IxIy(nc,nl);
	CImg<double> ItIx(nc,nl);
	CImg<double> ItIy(nc,nl);
	IxIx=(im_x.get_mul(im_x));
	IyIy=(im_y.get_mul(im_y));
	IxIy=(im_x.get_mul(im_y));
	ItIx=(im_t.get_mul(im_x));
	ItIy=(im_t.get_mul(im_y));
	if (scale!=1){
	  IxIx=IxIx.get_blur(scale-1,true);
	  IyIy=IyIy.get_blur(scale-1,true);
	  IxIy=IxIy.get_blur(scale-1,true);
	  ItIx=ItIx.get_blur(scale-1,true);
	  ItIy=ItIy.get_blur(scale-1,true);
	}
	/***************************************** Sparse matrix A initialization  ************************************/
	int taille=ncnl*2;
	double *val=new double[nombre];
	int *col_ind=new int[nombre];
	int *row_ptr=new int[taille+1];
	CImg<double> X(nc,nl,2);
	VECTOR_double B(taille,0.0);
	/***************************************** Temporary variable allocation **********************************/
	/*images intermediaires */
	CImg <double> A1_ij(nc,nl); CImg <double> A2_ij(nc,nl);
	CImg <double> A1_i1j(nc,nl); CImg <double> A2_ij1(nc,nl);
	CImg <double> A1_i_1j(nc,nl); CImg <double> A2_ij_1(nc,nl);  
	CImg <double> A1_ij_1(nc,nl);	CImg <double> A2_i_1j(nc,nl);	
	CImg <double> A1_ij1(nc,nl);	CImg <double> A2_i1j(nc,nl);
	CImg <double> A1_ijnc(nc,nl);CImg <double> A1_ij0(nc,nl);CImg <double> A1_inlj(nc,nl);CImg <double> A1_i0j(nc,nl);
	CImg <double> A2_ijnc(nc,nl);CImg <double> A2_ij0(nc,nl);CImg <double> A2_inlj(nc,nl);CImg <double> A2_i0j(nc,nl);
	/*HV long directions*/
	CImgList <double> A1_ijl(lo-neta+1,nc,nl);
	CImgList <double> A1_ij_l(lo-neta+1,nc,nl);	
	CImgList <double> A1_ilj(lo-neta+1,nc,nl);
	CImgList <double> A1_i_lj(lo-neta+1,nc,nl);
	CImgList <double> A2_ilj(lo-neta+1,nc,nl);	
	CImgList <double> A2_i_lj(lo-neta+1,nc,nl);	
	CImgList <double> A2_ijl(lo-neta+1,nc,nl);
	CImgList <double> A2_ij_l(lo-neta+1,nc,nl);
	/*cross long directions*/
	CImgList <double> A1_iljl(lo-neta+1,nc,nl); 
	CImgList <double> A1_i_lj_l(lo-neta+1,nc,nl);
	CImgList <double> A1_ilj_l(lo-neta+1,nc,nl); 
	CImgList <double> A1_i_ljl(lo-neta+1,nc,nl);
	CImgList <double> A2_iljl(lo-neta+1,nc,nl); 
	CImgList <double> A2_i_lj_l(lo-neta+1,nc,nl);
	CImgList <double> A2_ilj_l(lo-neta+1,nc,nl);
	CImgList <double> A2_i_ljl(lo-neta+1,nc,nl);
	/* fonctions indicatrices */
	CImg <double> colOfOne(1,nl);colOfOne.fill(1.);
	CImg <double> lineOfOne(nc,1);lineOfOne.fill(1.);
	CImgList <double> IndLine1(lo+1,nc,1);CImgList <double> IndCol1(lo+1,1,nl);
	CImgList <double> IndLine2(lo+1,nc,1);CImgList <double> IndCol2(lo+1,1,nl);
	CImgList <double> IndLine3(lo+1,nc,1);CImgList <double> IndCol3(lo+1,1,nl);
	CImg <double> Ind1_long(nc,nl);CImg <double> Ind1_trans(nc,nl);
	CImg <double> Ind2_long(nc,nl);CImg <double> Ind2_trans(nc,nl);
	CImg <double> Ind3_long(nc,nl);CImg <double> Ind3_trans(nc,nl);
	
	for (int l=0;l<neta;l++){ 
		IndLine1[l].fill(0.);IndCol1[l].fill(0.);
		IndLine2[l].fill(0.);IndCol2[l].fill(0.);
		IndLine3[l].fill(0.);IndCol3[l].fill(0.);
	}
	for (int l=neta;l<=lo;l++){
		for (int j=0;j<nc;j++){
			if (j>=l && j<(nc-l)){ IndLine1[l](j,0)=1;}else{ IndLine1[l](j,0)=0;}
			if (j>=2*l){ IndLine2[l](j,0)=1; }else{ IndLine2[l](j,0)=0; }
			if (j<nc-2*l){ IndLine3[l](j,0)=1;}else{ IndLine3[l](j,0)=0;}
		}
		for (int i=0;i<nl;i++){
			if (i>=l && i<(nl-l)){ IndCol1[l](0,i)=1;}else{ IndCol1[l](0,i)=0;}
			if (i>=2*l){ IndCol2[l](0,i)=1;}else{ IndCol2[l](0,i)=0;}
			if (i<nl-2*l){ IndCol3[l](0,i)=1;}else{ IndCol3[l](0,i)=0;}
		}
	}
	int gamma_HV=0,gamma_Cross=0;
	bool transverse=true;if (z_t_down[0].sum()==0){transverse=false;}
	double nx,ny,nx_t,ny_t;

	/***************************************** Filling of matrix A to invert  ************************************/
	int ll;
	/**** first line of matrix A *****/			
	/* coefficient for the  left block of matrix A*/
	A1_ij=IxIx.get_mul(data_out);
	for (int l=neta;l<=lo;l++){  
	        A1_ijl[l-neta].fill(0.); A1_ij_l[l-neta].fill(0.);
	        A1_ilj[l-neta].fill(0.);A1_i_lj[l-neta].fill(0.);
		A1_iljl[l-neta].fill(0.); A1_i_lj_l[l-neta].fill(0.);
		A1_i_ljl[l-neta].fill(0.); A1_ilj_l[l-neta].fill(0.);
		Ind1_long=colOfOne*IndLine1[l];
		Ind2_long=colOfOne*IndLine2[l];
		Ind3_long=colOfOne*IndLine3[l];
		Ind1_trans=IndCol1[l]*lineOfOne;
		Ind2_trans=IndCol2[l]*lineOfOne;
		Ind3_trans=IndCol3[l]*lineOfOne;
		bool lcross=(l>=max((int)(neta/sqrt(2)),1))&&(l<=(int)(lo/sqrt(2))+1);
		gamma_HV =2*((nl-2*l)*nc+(nc-2*l)*nl);if (transverse){gamma_HV*=2.;};
		/*2 horizontal directions*/
		/*n(1,0)*/
		A1_ij+=lambda_S2(l)/gamma_HV*(+1*z_right[l-neta].get_mul(Ind1_long)+1*z_right[l-neta].get_shift(-l,0).get_mul(Ind2_long));
		A1_ijl[l-neta]+=lambda_S2(l)/gamma_HV*(-1*z_right[l-neta].get_mul(Ind1_long));
		A1_ij_l[l-neta]+=lambda_S2(l)/gamma_HV*(-1*z_right[l-neta].get_shift(-l,0).get_mul(Ind2_long));
		/* n(-1,0)*/
		A1_ij+=lambda_S2(l)/gamma_HV*(+1*z_right[l-neta].get_shift(-l,0).get_mul(Ind1_long)+1*z_right[l-neta].get_mul(Ind3_long));
		A1_ij_l[l-neta]+=lambda_S2(l)/gamma_HV*(-1*z_right[l-neta].get_shift(-l,0).get_mul(Ind1_long));
		A1_ijl[l-neta]+=lambda_S2(l)/gamma_HV*(-1*z_right[l-neta].get_mul(Ind3_long));
		/*2 vertical directions*/
		/*n(0,1)*/
		A1_ij+=lambda_S2(l)/gamma_HV*(+1*z_t_down[l-neta].get_mul(Ind1_trans)+1*z_t_down[l-neta].get_shift(0,-l).get_mul(Ind2_trans));
		A1_ilj[l-neta]+=lambda_S2(l)/gamma_HV*(-1*z_t_down[l-neta].get_mul(Ind1_trans));
		A1_i_lj[l-neta]+=lambda_S2(l)/gamma_HV*(-1*z_t_down[l-neta].get_shift(0,-l).get_mul(Ind2_trans));
		/* n(0,-1)*/
		A1_ij+=lambda_S2(l)/gamma_HV*(+1*z_t_down[l-neta].get_shift(0,-l).get_mul(Ind1_trans)+1*z_t_down[l-neta].get_mul(Ind3_trans));
		A1_i_lj[l-neta]+=lambda_S2(l)/gamma_HV*(-1*z_t_down[l-neta].get_shift(0,-l).get_mul(Ind1_trans));
		A1_ilj[l-neta]+=lambda_S2(l)/gamma_HV*(-1*z_t_down[l-neta].get_mul(Ind3_trans));
		/*4 cross directions */
		if (lcross){
		  gamma_Cross =4*(nl-2*l)*(nc-2*l);
		  if (transverse){gamma_Cross*=2.;}
		  /*n(+1,+1) n_t=(1,-1)*/
		  nx=+1/sqrt(2);ny=+1/sqrt(2);
		  A1_ij+=lambda_S2_cross(l)/gamma_Cross*(+1*nx*nx*z_rightDown[l-neta].get_mul(IndCol1[l]*IndLine1[l])
							 +1*nx*nx*z_rightDown[l-neta].get_shift(-l,-l).get_mul(IndCol2[l]*IndLine2[l]));
		  A1_iljl[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*nx*nx*z_rightDown[l-neta].get_mul(IndCol1[l]*IndLine1[l]));
		  A1_i_lj_l[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*nx*nx*z_rightDown[l-neta].get_shift(-l,-l).get_mul(IndCol2[l]*IndLine2[l]));
		  nx_t=1/sqrt(2);ny_t=-1/sqrt(2);
		  A1_ij+=lambda_S2_cross(l)/gamma_Cross*(+1*nx_t*nx_t*z_t_rightDown[l-neta].get_mul(IndCol1[l]*IndLine1[l])
							 +1*nx_t*nx_t*z_t_rightDown[l-neta].get_shift(-l,-l).get_mul(IndCol2[l]*IndLine2[l]));
		  A1_iljl[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*nx_t*nx_t*z_t_rightDown[l-neta].get_mul(IndCol1[l]*IndLine1[l]));
		  A1_i_lj_l[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*nx_t*nx_t*z_t_rightDown[l-neta].get_shift(-l,-l).get_mul(IndCol2[l]*IndLine2[l]));
		  /* n(-1,-1) n_t=(-1,1)*/
		  nx=-1/sqrt(2);ny=-1/sqrt(2);
		  A1_ij+=lambda_S2_cross(l)/gamma_Cross*(+1*nx*nx*z_rightDown[l-neta].get_shift(-l,-l).get_mul(IndCol1[l]*IndLine1[l])
							 +1*nx*nx*z_rightDown[l-neta].get_mul(IndCol3[l]*IndLine3[l]));
		  A1_i_lj_l[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*nx*nx*z_rightDown[l-neta].get_shift(-l,-l).get_mul(IndCol1[l]*IndLine1[l]));
		  A1_iljl[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*nx*nx*z_rightDown[l-neta].get_mul(IndCol3[l]*IndLine3[l]));
		  nx_t=-1/sqrt(2);ny_t=1/sqrt(2);
		  A1_ij+=lambda_S2_cross(l)/gamma_Cross*(+1*nx_t*nx_t*z_t_rightDown[l-neta].get_shift(-l,-l).get_mul(IndCol1[l]*IndLine1[l])
							 +1*nx_t*nx_t*z_t_rightDown[l-neta].get_mul(IndCol3[l]*IndLine3[l]));
		  A1_i_lj_l[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*nx_t*nx_t*z_t_rightDown[l-neta].get_shift(-l,-l).get_mul(IndCol1[l]*IndLine1[l]));
		  A1_iljl[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*nx_t*nx_t*z_t_rightDown[l-neta].get_mul(IndCol3[l]*IndLine3[l]));
		  /*n(1,-1) n_t=(-1,-1)*/
		  nx=1/sqrt(2);ny=-1/sqrt(2);
		  A1_ij+=lambda_S2_cross(l)/gamma_Cross*(+1*nx*nx*z_rightUp[l-neta].get_mul(IndCol1[l]*IndLine1[l])
							 +1*nx*nx*z_rightUp[l-neta].get_shift(-l,l).get_mul(IndCol3[l]*IndLine2[l]));
		  A1_i_ljl[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*nx*nx*z_rightUp[l-neta].get_mul(IndCol1[l]*IndLine1[l]));
		  A1_ilj_l[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*nx*nx*z_rightUp[l-neta].get_shift(-l,l).get_mul(IndCol3[l]*IndLine2[l]));
		  nx_t=-1/sqrt(2);ny_t=-1/sqrt(2);
		  A1_ij+=lambda_S2_cross(l)/gamma_Cross*(+1*nx_t*nx_t*z_t_rightUp[l-neta].get_mul(IndCol1[l]*IndLine1[l])
							 +1*nx_t*nx_t*z_t_rightUp[l-neta].get_shift(-l,l).get_mul(IndCol3[l]*IndLine2[l]));
		  A1_i_ljl[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*nx_t*nx_t*z_t_rightUp[l-neta].get_mul(IndCol1[l]*IndLine1[l]));
		  A1_ilj_l[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*nx_t*nx_t*z_t_rightUp[l-neta].get_shift(-l,l).get_mul(IndCol3[l]*IndLine2[l]));
		  /*n(-1,1) n_t=(1,1)*/
		  nx=-1/sqrt(2);ny=1/sqrt(2);
		  A1_ij+=lambda_S2_cross(l)/gamma_Cross*(+1*nx*nx*z_rightUp[l-neta].get_shift(-l,l).get_mul(IndCol1[l]*IndLine1[l])
							 +1*nx*nx*z_rightUp[l-neta].get_mul(IndCol2[l]*IndLine3[l]));
		  A1_ilj_l[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*nx*nx*z_rightUp[l-neta].get_shift(-l,l).get_mul(IndCol1[l]*IndLine1[l]));
		  A1_i_ljl[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*nx*nx*z_rightUp[l-neta].get_mul(IndCol2[l]*IndLine3[l]));
		  nx_t=1/sqrt(2);ny_t=1/sqrt(2);
		  A1_ij+=lambda_S2_cross(l)/gamma_Cross*(+1*nx_t*nx_t*z_t_rightUp[l-neta].get_shift(-l,l).get_mul(IndCol1[l]*IndLine1[l])
							 +1*nx_t*nx_t*z_t_rightUp[l-neta].get_mul(IndCol2[l]*IndLine3[l]));
		  A1_ilj_l[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*nx_t*nx_t*z_t_rightUp[l-neta].get_shift(-l,l).get_mul(IndCol1[l]*IndLine1[l]));
		  A1_i_ljl[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*nx_t*nx_t*z_t_rightUp[l-neta].get_mul(IndCol2[l]*IndLine3[l]));
		}
	}
	excludeWhite(neta,lo,A1_ij_l,A1_ijl,A1_i_lj,A1_ilj);
	excludeWhite(neta,lo,A1_iljl,A1_i_lj_l,A1_ilj_l,A1_i_ljl);
	/* coefficient for the right block of matrix A*/
	A2_ij=IxIy.get_mul(data_out);
	for (int l=neta;l<=lo;l++){  
	        A2_ijl[l-neta].fill(0.); A2_ij_l[l-neta].fill(0.);
	        A2_ilj[l-neta].fill(0.);A2_i_lj[l-neta].fill(0.);
	        A2_iljl[l-neta].fill(0.); A2_i_lj_l[l-neta].fill(0.);
		A2_i_ljl[l-neta].fill(0.); A2_ilj_l[l-neta].fill(0.);
		/*4 horizontal-vertical directions*/
	        A2_ijl[l-neta].fill(0.); A2_ij_l[l-neta].fill(0.);
	        A2_ilj[l-neta].fill(0.);A2_i_lj[l-neta].fill(0.);
	        A2_iljl[l-neta].fill(0.); A2_i_lj_l[l-neta].fill(0.);
		A2_i_ljl[l-neta].fill(0.); A2_ilj_l[l-neta].fill(0.);
		/*4 cross directions */
		bool lcross=(l>=max((int)(neta/sqrt(2)),1))&&(l<=(int)(lo/sqrt(2))+1);
		if (lcross){
		  gamma_Cross =4*(nl-2*l)*(nc-2*l);
		  if (transverse){gamma_Cross*=2.;}
		  /*n(+1,+1) n_t=(1,-1)*/
		  nx=+1/sqrt(2);ny=+1/sqrt(2);
		  A2_ij+=lambda_S2_cross(l)/gamma_Cross*(+1*ny*nx*z_rightDown[l-neta].get_mul(IndCol1[l]*IndLine1[l])
							 +1*ny*nx*z_rightDown[l-neta].get_shift(-l,-l).get_mul(IndCol2[l]*IndLine2[l]));
		  A2_iljl[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny*nx*z_rightDown[l-neta].get_mul(IndCol1[l]*IndLine1[l]));
		  A2_i_lj_l[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny*nx*z_rightDown[l-neta].get_shift(-l,-l).get_mul(IndCol2[l]*IndLine2[l]));
		  nx_t=1/sqrt(2);ny_t=-1/sqrt(2);
		  A2_ij+=lambda_S2_cross(l)/gamma_Cross*(+1*ny_t*nx_t*z_t_rightDown[l-neta].get_mul(IndCol1[l]*IndLine1[l])
							 +1*ny_t*nx_t*z_t_rightDown[l-neta].get_shift(-l,-l).get_mul(IndCol2[l]*IndLine2[l]));
		  A2_iljl[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny_t*nx_t*z_t_rightDown[l-neta].get_mul(IndCol1[l]*IndLine1[l]));
		  A2_i_lj_l[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny_t*nx_t*z_t_rightDown[l-neta].get_shift(-l,-l).get_mul(IndCol2[l]*IndLine2[l]));
		  /* n(-1,-1) n_t=(-1,1)*/
		  nx=-1/sqrt(2);ny=-1/sqrt(2);
		  A2_ij+=lambda_S2_cross(l)/gamma_Cross*(+1*ny*nx*z_rightDown[l-neta].get_shift(-l,-l).get_mul(IndCol1[l]*IndLine1[l])
							 +1*ny*nx*z_rightDown[l-neta].get_mul(IndCol3[l]*IndLine3[l]));
		  A2_i_lj_l[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny*nx*z_rightDown[l-neta].get_shift(-l,-l).get_mul(IndCol1[l]*IndLine1[l]));
		  A2_iljl[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny*nx*z_rightDown[l-neta].get_mul(IndCol3[l]*IndLine3[l]));
		  nx_t=-1/sqrt(2);ny_t=1/sqrt(2);
		  A2_ij+=lambda_S2_cross(l)/gamma_Cross*(+1*ny_t*nx_t*z_t_rightDown[l-neta].get_shift(-l,-l).get_mul(IndCol1[l]*IndLine1[l])
							 +1*ny_t*nx_t*z_t_rightDown[l-neta].get_mul(IndCol3[l]*IndLine3[l]));
		  A2_i_lj_l[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny_t*nx_t*z_t_rightDown[l-neta].get_shift(-l,-l).get_mul(IndCol1[l]*IndLine1[l]));
		  A2_iljl[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny_t*nx_t*z_t_rightDown[l-neta].get_mul(IndCol3[l]*IndLine3[l]));
		  /*n(1,-1) n_t=(-1,-1)*/
		  nx=1/sqrt(2);ny=-1/sqrt(2);
		  A2_ij+=lambda_S2_cross(l)/gamma_Cross*(+1*ny*nx*z_rightUp[l-neta].get_mul(IndCol1[l]*IndLine1[l])
							 +1*ny*nx*z_rightUp[l-neta].get_shift(-l,l).get_mul(IndCol3[l]*IndLine2[l]));
		  A2_i_ljl[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny*nx*z_rightUp[l-neta].get_mul(IndCol1[l]*IndLine1[l]));
		  A2_ilj_l[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny*nx*z_rightUp[l-neta].get_shift(-l,l).get_mul(IndCol3[l]*IndLine2[l]));
		  nx_t=-1/sqrt(2);ny_t=-1/sqrt(2);
		  A2_ij+=lambda_S2_cross(l)/gamma_Cross*(+1*ny_t*nx_t*z_t_rightUp[l-neta].get_mul(IndCol1[l]*IndLine1[l])
							 +1*ny_t*nx_t*z_t_rightUp[l-neta].get_shift(-l,l).get_mul(IndCol3[l]*IndLine2[l]));
		  A2_i_ljl[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny_t*nx_t*z_t_rightUp[l-neta].get_mul(IndCol1[l]*IndLine1[l]));
		  A2_ilj_l[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny_t*nx_t*z_t_rightUp[l-neta].get_shift(-l,l).get_mul(IndCol3[l]*IndLine2[l]));
		  /*n(-1,1) n_t=(1,1)*/
		  nx=-1/sqrt(2);ny=1/sqrt(2);
		  A2_ij+=lambda_S2_cross(l)/gamma_Cross*(+1*ny*nx*z_rightUp[l-neta].get_shift(-l,l).get_mul(IndCol1[l]*IndLine1[l])
							 +1*ny*nx*z_rightUp[l-neta].get_mul(IndCol2[l]*IndLine3[l]));
		  
		  A2_ilj_l[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny*nx*z_rightUp[l-neta].get_shift(-l,l).get_mul(IndCol1[l]*IndLine1[l]));
		  A2_i_ljl[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny*nx*z_rightUp[l-neta].get_mul(IndCol2[l]*IndLine3[l]));
		  nx_t=1/sqrt(2);ny_t=1/sqrt(2);
		  A2_ij+=lambda_S2_cross(l)/gamma_Cross*(+1*ny_t*nx_t*z_t_rightUp[l-neta].get_shift(-l,l).get_mul(IndCol1[l]*IndLine1[l])
							 +1*ny_t*nx_t*z_t_rightUp[l-neta].get_mul(IndCol2[l]*IndLine3[l]));
		  
		  A2_ilj_l[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny_t*nx_t*z_t_rightUp[l-neta].get_shift(-l,l).get_mul(IndCol1[l]*IndLine1[l]));
		  A2_i_ljl[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny_t*nx_t*z_t_rightUp[l-neta].get_mul(IndCol2[l]*IndLine3[l]));
		}
	}
	excludeWhite(neta,lo,A2_ij_l,A2_ijl,A2_i_lj,A2_ilj);
	excludeWhite(neta,lo,A2_iljl,A2_i_lj_l,A2_ilj_l,A2_i_ljl);
	fixDirichletConditions(nc,nl,A1_i_1j,A1_ij,A1_i1j,A1_ij_1,A1_ij1);
	fixDirichletConditions(nc,nl,A1_i_lj,A1_ij_l,A1_ijl,A1_ilj,neta,lo);
	fixDirichletConditions_cross(nc,nl,A1_i_lj_l,A1_i_ljl,A1_ilj_l,A1_iljl,neta,lo);
	fixDirichletConditions(nc,nl,A2_i_1j,A2_ij,A2_i1j,A2_ij_1,A2_ij1);
	fixDirichletConditions(nc,nl,A2_i_lj,A2_ij_l,A2_ijl,A2_ilj,neta,lo);
	fixDirichletConditions_cross(nc,nl,A2_ij,A2_i_lj_l,A2_i_ljl,A2_ilj_l,A2_iljl,neta,lo);
	/*filling matrix A */
	row_ptr[0]=0;
	ll=1;
	k=0;
	for (int i=0; i<nl; i++){
	  for (int j=0; j<nc; j++){		
	    for (int l=lo;l>=neta;l--){
	      bool lcross=(l>=max((int)(neta/sqrt(2)),1))&&(l<=(int)(lo/sqrt(2))+1);
	      if(lcross&&A1_i_lj_l[l-neta](j,i)!=notdef){				val[k]=A1_i_lj_l[l-neta](j,i);	        col_ind[k]=(i-l)*nc+(j-l);	k++;}			
	      if(A1_i_lj[l-neta](j,i)!=notdef){						val[k]=A1_i_lj[l-neta](j,i);		col_ind[k]=(i-l)*nc+j;	        k++;}
	      if(lcross&&A1_i_ljl[l-neta](j,i)!=notdef){				val[k]=A1_i_ljl[l-neta](j,i);		col_ind[k]=(i-l)*nc+(j+l);	k++;}
	    }
			
	    for (int l=lo;l>=neta;l--){
	      if (A1_ij_l[l-neta](j,i)!=notdef) {					val[k]=A1_ij_l[l-neta](j,i);		col_ind[k]=i*nc+j-l;	        k++;}
	    }
	                                                                                val[k]=A1_ij(j,i);			col_ind[k]=i*nc+j;		k++;
	    for (int l=neta;l<=lo;l++){
	      if (A1_ijl[l-neta](j,i)!=notdef)  {					val[k]=A1_ijl[l-neta](j,i);		col_ind[k]=i*nc+j+l;            k++;} 
	    }
	    for (int l=neta;l<=lo;l++){
	      bool lcross=(l>=max((int)(neta/sqrt(2)),1))&&(l<=(int)(lo/sqrt(2))+1);
	      if(lcross&& A1_ilj_l[l-neta](j,i)!=notdef){				val[k]=A1_ilj_l[l-neta](j,i);		col_ind[k]=(i+l)*nc+(j-l);	k++;}
	      if(A1_ilj[l-neta](j,i)!=notdef){						val[k]=A1_ilj[l-neta](j,i);		col_ind[k]=(i+l)*nc+j;		k++;}
	      if(lcross&& A1_iljl[l-neta](j,i)!=notdef){				val[k]=A1_iljl[l-neta](j,i);		col_ind[k]=(i+l)*nc+(j+l);	k++;}
	    }
	    
	    for (int l=lo;l>=neta;l--){
	      bool lcross=(l>=max((int)(neta/sqrt(2)),1))&&(l<=(int)(lo/sqrt(2))+1);
	      if(lcross&&A2_i_lj_l[l-neta](j,i)!=notdef){				val[k]=A2_i_lj_l[l-neta](j,i);	        col_ind[k]=ncnl+(i-l)*nc+(j-l);	k++;} 
	      if(A2_i_lj[l-neta](j,i)!=notdef){						val[k]=A2_i_lj[l-neta](j,i);		col_ind[k]=ncnl+(i-l)*nc+j;	k++;}
	      if(lcross&&A2_i_ljl[l-neta](j,i)!=notdef){				val[k]=A2_i_ljl[l-neta](j,i);		col_ind[k]=ncnl+(i-l)*nc+(j+l);	k++;}
	    }
	    for (int l=lo;l>=neta;l--){
	      if (A2_ij_l[l-neta](j,i)!=notdef) {					val[k]=A2_ij_l[l-neta](j,i);		col_ind[k]=ncnl+i*nc+j-l;       k++;}
	    }
	                                                                                val[k]=A2_ij(j,i);			col_ind[k]=ncnl+i*nc+j;		k++;
	    for (int l=neta;l<=lo;l++){
	      if (A2_ijl[l-neta](j,i)!=notdef)  {					val[k]=A2_ijl[l-neta](j,i);		col_ind[k]=ncnl+i*nc+j+l;       k++;} 
	    }
	    for (int l=neta;l<=lo;l++){
	      bool lcross=(l>=max((int)(neta/sqrt(2)),1))&&(l<=(int)(lo/sqrt(2))+1);
	      if(lcross&& A2_ilj_l[l-neta](j,i)!=notdef){				val[k]=A2_ilj_l[l-neta](j,i);		col_ind[k]=ncnl+(i+l)*nc+(j-l);	k++;}
	      if(A2_ilj[l-neta](j,i)!=notdef){						val[k]=A2_ilj[l-neta](j,i);		col_ind[k]=ncnl+(i+l)*nc+j;    	k++;}
	      if(lcross&& A2_iljl[l-neta](j,i)!=notdef){				val[k]=A2_iljl[l-neta](j,i);		col_ind[k]=ncnl+(i+l)*nc+(j+l);	k++;}
	    }
	    
	    row_ptr[ll]=k;
	    ll++;
	  }	   
	}
	
	
	/**** second line of matrix A *****/
	/* coefficient for the  left block of matrix A*/
	A1_ij=IxIy.get_mul(data_out);	
	for (int l=neta;l<=lo;l++){  
	        A1_iljl[l-neta].fill(0.); A1_i_lj_l[l-neta].fill(0.);
		A1_i_ljl[l-neta].fill(0.); A1_ilj_l[l-neta].fill(0.);
		/*4 horizontal-vertical directions*/
	        A1_ijl[l-neta].fill(0.); A1_ij_l[l-neta].fill(0.);
	        A1_ilj[l-neta].fill(0.);A1_i_lj[l-neta].fill(0.);
	        A1_iljl[l-neta].fill(0.); A1_i_lj_l[l-neta].fill(0.);
		A1_i_ljl[l-neta].fill(0.); A1_ilj_l[l-neta].fill(0.);
		/*4 cross directions*/
		bool lcross=(l>=max((int)(neta/sqrt(2)),1))&&(l<=(int)(lo/sqrt(2))+1);
		if (lcross){
		  gamma_Cross =4*(nl-2*l)*(nc-2*l);
		  if (transverse){gamma_Cross*=2.;}
		  /*n(+1,+1) n_t=(1,-1)*/
		  nx=+1/sqrt(2);ny=+1/sqrt(2);
		  A1_ij+=lambda_S2_cross(l)/gamma_Cross*(+1*ny*nx*z_rightDown[l-neta].get_mul(IndCol1[l]*IndLine1[l])
							 +1*ny*nx*z_rightDown[l-neta].get_shift(-l,-l).get_mul(IndCol2[l]*IndLine2[l]));
		  A1_iljl[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny*nx*z_rightDown[l-neta].get_mul(IndCol1[l]*IndLine1[l]));
		  A1_i_lj_l[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny*nx*z_rightDown[l-neta].get_shift(-l,-l).get_mul(IndCol2[l]*IndLine2[l]));
		  nx_t=1/sqrt(2);ny_t=-1/sqrt(2);
		  A1_ij+=lambda_S2_cross(l)/gamma_Cross*(+1*ny_t*nx_t*z_t_rightDown[l-neta].get_mul(IndCol1[l]*IndLine1[l])
							 +1*ny_t*nx_t*z_t_rightDown[l-neta].get_shift(-l,-l).get_mul(IndCol2[l]*IndLine2[l]));
		  A1_iljl[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny_t*nx_t*z_t_rightDown[l-neta].get_mul(IndCol1[l]*IndLine1[l]));
		  A1_i_lj_l[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny_t*nx_t*z_t_rightDown[l-neta].get_shift(-l,-l).get_mul(IndCol2[l]*IndLine2[l]));
		  /* n(-1,-1)  n_t=(-1,1)*/
		  nx=-1/sqrt(2);ny=-1/sqrt(2);
		  A1_ij+=lambda_S2_cross(l)/gamma_Cross*(+1*ny*nx*z_rightDown[l-neta].get_shift(-l,-l).get_mul(IndCol1[l]*IndLine1[l])
							 +1*ny*nx*z_rightDown[l-neta].get_mul(IndCol3[l]*IndLine3[l]));
		  A1_i_lj_l[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny*nx*z_rightDown[l-neta].get_shift(-l,-l).get_mul(IndCol1[l]*IndLine1[l]));
		  A1_iljl[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny*nx*z_rightDown[l-neta].get_mul(IndCol3[l]*IndLine3[l]));
		  nx_t=-1/sqrt(2);ny_t=1/sqrt(2);
		  A1_ij+=lambda_S2_cross(l)/gamma_Cross*(+1*ny_t*nx_t*z_t_rightDown[l-neta].get_shift(-l,-l).get_mul(IndCol1[l]*IndLine1[l])
							 +1*ny_t*nx_t*z_t_rightDown[l-neta].get_mul(IndCol3[l]*IndLine3[l]));
		  A1_i_lj_l[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny_t*nx_t*z_t_rightDown[l-neta].get_shift(-l,-l).get_mul(IndCol1[l]*IndLine1[l]));
		  A1_iljl[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny_t*nx_t*z_t_rightDown[l-neta].get_mul(IndCol3[l]*IndLine3[l]));
		  /*n(1,-1)  n_t=(-1,-1)*/
		  nx=1/sqrt(2);ny=-1/sqrt(2);
		  A1_ij+=lambda_S2_cross(l)/gamma_Cross*(+1*ny*nx*z_rightUp[l-neta].get_mul(IndCol1[l]*IndLine1[l])
							 +1*ny*nx*z_rightUp[l-neta].get_shift(-l,l).get_mul(IndCol3[l]*IndLine2[l]));
		  A1_i_ljl[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny*nx*z_rightUp[l-neta].get_mul(IndCol1[l]*IndLine1[l]));
		  A1_ilj_l[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny*nx*z_rightUp[l-neta].get_shift(-l,l).get_mul(IndCol3[l]*IndLine2[l]));
		  nx_t=-1/sqrt(2);ny_t=-1/sqrt(2);
		  A1_ij+=lambda_S2_cross(l)/gamma_Cross*(+1*ny_t*nx_t*z_t_rightUp[l-neta].get_mul(IndCol1[l]*IndLine1[l])
							 +1*ny_t*nx_t*z_t_rightUp[l-neta].get_shift(-l,l).get_mul(IndCol3[l]*IndLine2[l]));
		  A1_i_ljl[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny_t*nx_t*z_t_rightUp[l-neta].get_mul(IndCol1[l]*IndLine1[l]));
		  A1_ilj_l[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny_t*nx_t*z_t_rightUp[l-neta].get_shift(-l,l).get_mul(IndCol3[l]*IndLine2[l]));
		  /*n(-1,1)  n_t=(1,1)*/
		  nx=-1/sqrt(2);ny=1/sqrt(2);
		  A1_ij+=lambda_S2_cross(l)/gamma_Cross*(+1*ny*nx*z_rightUp[l-neta].get_shift(-l,l).get_mul(IndCol1[l]*IndLine1[l])
							 +1*ny*nx*z_rightUp[l-neta].get_mul(IndCol2[l]*IndLine3[l]));
		  
		  A1_ilj_l[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny*nx*z_rightUp[l-neta].get_shift(-l,l).get_mul(IndCol1[l]*IndLine1[l]));
		  A1_i_ljl[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny*nx*z_rightUp[l-neta].get_mul(IndCol2[l]*IndLine3[l]));
		  nx_t=1/sqrt(2);ny_t=1/sqrt(2);
		  A1_ij+=lambda_S2_cross(l)/gamma_Cross*(+1*ny_t*nx_t*z_t_rightUp[l-neta].get_shift(-l,l).get_mul(IndCol1[l]*IndLine1[l])
							 +1*ny_t*nx_t*z_t_rightUp[l-neta].get_mul(IndCol2[l]*IndLine3[l]));
		  
		  A1_ilj_l[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny_t*nx_t*z_t_rightUp[l-neta].get_shift(-l,l).get_mul(IndCol1[l]*IndLine1[l]));
		  A1_i_ljl[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny_t*nx_t*z_t_rightUp[l-neta].get_mul(IndCol2[l]*IndLine3[l]));
		}
	}
	excludeWhite(neta,lo,A1_ij_l,A1_ijl,A1_i_lj,A1_ilj);
	excludeWhite(neta,lo,A1_iljl,A1_i_lj_l,A1_ilj_l,A1_i_ljl);	  
	/* coefficient for the right block of matrix A*/
	A2_ij=IyIy.get_mul(data_out);
	for (int l=neta;l<=lo;l++){  
	        A2_ijl[l-neta].fill(0.); A2_ij_l[l-neta].fill(0.);
	        A2_ilj[l-neta].fill(0.);A2_i_lj[l-neta].fill(0.);
		A2_iljl[l-neta].fill(0.); A2_i_lj_l[l-neta].fill(0.);
		A2_i_ljl[l-neta].fill(0.); A2_ilj_l[l-neta].fill(0.);
		Ind1_long=colOfOne*IndLine1[l];
		Ind2_long=colOfOne*IndLine2[l];
		Ind3_long=colOfOne*IndLine3[l];
		Ind1_trans=IndCol1[l]*lineOfOne;
		Ind2_trans=IndCol2[l]*lineOfOne;
		Ind3_trans=IndCol3[l]*lineOfOne;
		bool lcross=(l>=max((int)(neta/sqrt(2)),1))&&(l<=(int)(lo/sqrt(2))+1);
		gamma_HV =2*((nl-2*l)*nc+(nc-2*l)*nl);if (transverse){gamma_HV*=2.;};
		/*2 vertical directions*/
		/*n(0,1)*/
		A2_ij+=lambda_S2(l)/gamma_HV*(+1*z_down[l-neta].get_mul(Ind1_trans)+1*z_down[l-neta].get_shift(0,-l).get_mul(Ind2_trans));
		A2_ilj[l-neta]+=lambda_S2(l)/gamma_HV*(-1*z_down[l-neta].get_mul(Ind1_trans));
		A2_i_lj[l-neta]+=lambda_S2(l)/gamma_HV*(-1*z_down[l-neta].get_shift(0,-l).get_mul(Ind2_trans));
		/* n(0,-1)*/
		A2_ij+=lambda_S2(l)/gamma_HV*(+1*z_down[l-neta].get_shift(0,-l).get_mul(Ind1_trans)+1*z_down[l-neta].get_mul(Ind3_trans));
		A2_i_lj[l-neta]+=lambda_S2(l)/gamma_HV*(-1*z_down[l-neta].get_shift(0,-l).get_mul(Ind1_trans));
		A2_ilj[l-neta]+=lambda_S2(l)/gamma_HV*(-1*z_down[l-neta].get_mul(Ind3_trans));
		/*2 horizontal directions*/
		/*n(1,0)*/
		A2_ij+=lambda_S2(l)/gamma_HV*(+1*z_t_right[l-neta].get_mul(Ind1_long)+1*z_t_right[l-neta].get_shift(-l,0).get_mul(Ind2_long));
		A2_ijl[l-neta]+=lambda_S2(l)/gamma_HV*(-1*z_t_right[l-neta].get_mul(Ind1_long));
		A2_ij_l[l-neta]+=lambda_S2(l)/gamma_HV*(-1*z_t_right[l-neta].get_shift(-l,0).get_mul(Ind2_long));
		/* n(-1,0)*/
		A2_ij+=lambda_S2(l)/gamma_HV*(+1*z_t_right[l-neta].get_shift(-l,0).get_mul(Ind1_long)+1*z_t_right[l-neta].get_mul(Ind3_long));
		A2_ij_l[l-neta]+=lambda_S2(l)/gamma_HV*(-1*z_t_right[l-neta].get_shift(-l,0).get_mul(Ind1_long));
		A2_ijl[l-neta]+=lambda_S2(l)/gamma_HV*(-1*z_t_right[l-neta].get_mul(Ind3_long));
		/*4 cross directions*/
		if (lcross){
		  gamma_Cross =4*(nl-2*l)*(nc-2*l);
		  if (transverse){gamma_Cross*=2.;}
		  /*n(+1,+1) n_t=(1,-1)*/
		  nx=+1/sqrt(2);ny=+1/sqrt(2);
		  A2_ij+=lambda_S2_cross(l)/gamma_Cross*(+1*ny*ny*z_rightDown[l-neta].get_mul(IndCol1[l]*IndLine1[l])
							 +1*ny*ny*z_rightDown[l-neta].get_shift(-l,-l).get_mul(IndCol2[l]*IndLine2[l]));
		  A2_iljl[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny*ny*z_rightDown[l-neta].get_mul(IndCol1[l]*IndLine1[l]));
		  A2_i_lj_l[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny*ny*z_rightDown[l-neta].get_shift(-l,-l).get_mul(IndCol2[l]*IndLine2[l]));
		  nx_t=1/sqrt(2);ny_t=-1/sqrt(2);
		  A2_ij+=lambda_S2_cross(l)/gamma_Cross*(+1*ny_t*ny_t*z_t_rightDown[l-neta].get_mul(IndCol1[l]*IndLine1[l])
							 +1*ny_t*ny_t*z_t_rightDown[l-neta].get_shift(-l,-l).get_mul(IndCol2[l]*IndLine2[l]));
		  A2_iljl[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny_t*ny_t*z_t_rightDown[l-neta].get_mul(IndCol1[l]*IndLine1[l]));
		  A2_i_lj_l[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny_t*ny_t*z_t_rightDown[l-neta].get_shift(-l,-l).get_mul(IndCol2[l]*IndLine2[l]));
		  /* n(-1,-1)  n_t=(-1,1)*/
		  nx=-1/sqrt(2);ny=-1/sqrt(2);
		  A2_ij+=lambda_S2_cross(l)/gamma_Cross*(+1*ny*ny*z_rightDown[l-neta].get_shift(-l,-l).get_mul(IndCol1[l]*IndLine1[l])
							 +1*ny*ny*z_rightDown[l-neta].get_mul(IndCol3[l]*IndLine3[l]));
		  A2_i_lj_l[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny*ny*z_rightDown[l-neta].get_shift(-l,-l).get_mul(IndCol1[l]*IndLine1[l]));
		  A2_iljl[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny*ny*z_rightDown[l-neta].get_mul(IndCol3[l]*IndLine3[l]));
		  nx_t=-1/sqrt(2);ny_t=1/sqrt(2);
		  A2_ij+=lambda_S2_cross(l)/gamma_Cross*(+1*ny_t*ny_t*z_t_rightDown[l-neta].get_shift(-l,-l).get_mul(IndCol1[l]*IndLine1[l])
							 +1*ny_t*ny_t*z_t_rightDown[l-neta].get_mul(IndCol3[l]*IndLine3[l]));
		  A2_i_lj_l[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny_t*ny_t*z_t_rightDown[l-neta].get_shift(-l,-l).get_mul(IndCol1[l]*IndLine1[l]));
		  A2_iljl[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny_t*ny_t*z_t_rightDown[l-neta].get_mul(IndCol3[l]*IndLine3[l]));
		  /*n(1,-1)  n_t=(-1,-1)*/
		  nx=1/sqrt(2);ny=-1/sqrt(2);
		  A2_ij+=lambda_S2_cross(l)/gamma_Cross*(+1*ny*ny*z_rightUp[l-neta].get_mul(IndCol1[l]*IndLine1[l])
							 +1*ny*ny*z_rightUp[l-neta].get_shift(-l,l).get_mul(IndCol3[l]*IndLine2[l]));
		  A2_i_ljl[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny*ny*z_rightUp[l-neta].get_mul(IndCol1[l]*IndLine1[l]));
		  A2_ilj_l[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny*ny*z_rightUp[l-neta].get_shift(-l,l).get_mul(IndCol3[l]*IndLine2[l]));
		  nx_t=-1/sqrt(2);ny_t=-1/sqrt(2);
		  A2_ij+=lambda_S2_cross(l)/gamma_Cross*(+1*ny_t*ny_t*z_t_rightUp[l-neta].get_mul(IndCol1[l]*IndLine1[l])
							 +1*ny_t*ny_t*z_t_rightUp[l-neta].get_shift(-l,l).get_mul(IndCol3[l]*IndLine2[l]));
		  A2_i_ljl[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny_t*ny_t*z_t_rightUp[l-neta].get_mul(IndCol1[l]*IndLine1[l]));
		  A2_ilj_l[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny_t*ny_t*z_t_rightUp[l-neta].get_shift(-l,l).get_mul(IndCol3[l]*IndLine2[l]));
		  /*n(-1,1) n_t=(1,1)*/
		  nx=-1/sqrt(2);ny=1/sqrt(2);
		  A2_ij+=lambda_S2_cross(l)/gamma_Cross*(+1*ny*ny*z_rightUp[l-neta].get_shift(-l,l).get_mul(IndCol1[l]*IndLine1[l])
							 +1*ny*ny*z_rightUp[l-neta].get_mul(IndCol2[l]*IndLine3[l]));
		  A2_ilj_l[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny*ny*z_rightUp[l-neta].get_shift(-l,l).get_mul(IndCol1[l]*IndLine1[l]));
		  A2_i_ljl[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny*ny*z_rightUp[l-neta].get_mul(IndCol2[l]*IndLine3[l]));
		  nx_t=1/sqrt(2);ny_t=1/sqrt(2);
		  A2_ij+=lambda_S2_cross(l)/gamma_Cross*(+1*ny_t*ny_t*z_t_rightUp[l-neta].get_shift(-l,l).get_mul(IndCol1[l]*IndLine1[l])
							 +1*ny_t*ny_t*z_t_rightUp[l-neta].get_mul(IndCol2[l]*IndLine3[l]));
		  A2_ilj_l[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny_t*ny_t*z_t_rightUp[l-neta].get_shift(-l,l).get_mul(IndCol1[l]*IndLine1[l]));
		  A2_i_ljl[l-neta]+=lambda_S2_cross(l)/gamma_Cross*(-1*ny_t*ny_t*z_t_rightUp[l-neta].get_mul(IndCol2[l]*IndLine3[l]));
		}
	}
	excludeWhite(neta,lo,A2_ij_l,A2_ijl,A2_i_lj,A2_ilj);
	excludeWhite(neta,lo,A2_iljl,A2_i_lj_l,A2_ilj_l,A2_i_ljl);
	fixDirichletConditions(nc,nl,A1_i_1j,A1_ij,A1_i1j,A1_ij_1,A1_ij1);
	fixDirichletConditions(nc,nl,A1_i_lj,A1_ij_l,A1_ijl,A1_ilj,neta,lo);
	fixDirichletConditions_cross(nc,nl,A1_ij,A1_i_lj_l,A1_i_ljl,A1_ilj_l,A1_iljl,neta,lo);
	fixDirichletConditions(nc,nl,A2_i_1j,A2_ij,A2_i1j,A2_ij_1,A2_ij1);
	fixDirichletConditions(nc,nl,A2_i_lj,A2_ij_l,A2_ijl,A2_ilj,neta,lo);
	fixDirichletConditions_cross(nc,nl,A2_i_lj_l,A2_i_ljl,A2_ilj_l,A2_iljl,neta,lo);
	/*filling  matrix A */
	for (int i=0; i<nl; i++){
	  for (int j=0; j<nc; j++){
	    for (int l=neta;l<=lo;l++){
	      bool lcross=(l>=max((int)(neta/sqrt(2)),1))&&(l<=(int)(lo/sqrt(2))+1);
	      if(lcross && A1_i_lj_l[l-neta](j,i)!=notdef){			val[k]=A1_i_lj_l[l-neta](j,i);		col_ind[k]=(i-l)*nc+(j-l);	k++;}
	      if(A1_i_lj[l-neta](j,i)!=notdef){					val[k]=A1_i_lj[l-neta](j,i);		col_ind[k]=(i-l)*nc+j;	        k++;}
	      if(lcross && A1_i_ljl[l-neta](j,i)!=notdef){			val[k]=A1_i_ljl[l-neta](j,i);		col_ind[k]=(i-l)*nc+(j+l);	k++;}
	    }															
	    for (int l=lo;l>=neta;l--){
	      if (A1_ij_l[l-neta](j,i)!=notdef) {				val[k]=A1_ij_l[l-neta](j,i);		col_ind[k]=i*nc+j-l;	        k++;}
	    }
	                                                                        val[k]=A1_ij(j,i);			col_ind[k]=i*nc+j;		k++;
	    for (int l=neta;l<=lo;l++){
	      if (A1_ijl[l-neta](j,i)!=notdef)  {				val[k]=A1_ijl[l-neta](j,i);		col_ind[k]=i*nc+j+l;	        k++;} 
	    }
	    for (int l=neta;l<=lo;l++){
	      bool lcross=(l>=max((int)(neta/sqrt(2)),1))&&(l<=(int)(lo/sqrt(2))+1);
	      if(lcross && A1_ilj_l[l-neta](j,i)!=notdef){			val[k]=A1_ilj_l[l-neta](j,i);		col_ind[k]=(i+l)*nc+(j-l);	k++;}
	      if(A1_ilj[l-neta](j,i)!=notdef){					val[k]=A1_ilj[l-neta](j,i);		col_ind[k]=(i+l)*nc+j;	        k++;}
	      if(lcross && A1_iljl[l-neta](j,i)!=notdef){			val[k]=A1_iljl[l-neta](j,i);		col_ind[k]=(i+l)*nc+(j+l);	k++;}
	    }
	    
	    for (int l=lo;l>=neta;l--){
	      bool lcross=(l>=max((int)(neta/sqrt(2)),1))&&(l<=(int)(lo/sqrt(2))+1);
	      if(lcross && A2_i_lj_l[l-neta](j,i)!=notdef){			val[k]=A2_i_lj_l[l-neta](j,i);		col_ind[k]=ncnl+(i-l)*nc+(j-l);	k++;}
	      if(A2_i_lj[l-neta](j,i)!=notdef){					val[k]=A2_i_lj[l-neta](j,i);		col_ind[k]=ncnl+(i-l)*nc+j;	k++;}
	      if(lcross && A2_i_ljl[l-neta](j,i)!=notdef){			val[k]=A2_i_ljl[l-neta](j,i);		col_ind[k]=ncnl+(i-l)*nc+(j+l);	k++;}
	    }
	    
	    for (int l=lo;l>=neta;l--){
	      if (A2_ij_l[l-neta](j,i)!=notdef) {				val[k]=A2_ij_l[l-neta](j,i);		col_ind[k]=ncnl+i*nc+j-l;	k++;}
	    }
	         								val[k]=A2_ij(j,i);			col_ind[k]=ncnl+i*nc+j;		k++;
	    for (int l=neta;l<=lo;l++){
	      if (A2_ijl[l-neta](j,i)!=notdef)  {				val[k]=A2_ijl[l-neta](j,i);		col_ind[k]=ncnl+i*nc+j+l;	k++;} 
	    }
	    for (int l=neta;l<=lo;l++){
	      bool lcross=(l>=max((int)(neta/sqrt(2)),1))&&(l<=(int)(lo/sqrt(2))+1);
	      if(lcross && A2_ilj_l[l-neta](j,i)!=notdef){			val[k]=A2_ilj_l[l-neta](j,i);		col_ind[k]=ncnl+(i+l)*nc+(j-l);	k++;}
	      if(A2_ilj[l-neta](j,i)!=notdef){					val[k]=A2_ilj[l-neta](j,i);		col_ind[k]=ncnl+(i+l)*nc+j;	k++;}
	      if(lcross && A2_iljl[l-neta](j,i)!=notdef){			val[k]=A2_iljl[l-neta](j,i);		col_ind[k]=ncnl+(i+l)*nc+(j+l);	k++;}
	    }
	    
	    row_ptr[ll]=k; 
	    ll++;
	  }
	}
	//if (row_ptr[ll-1]!=nombre){cout<<"ERROR : number non zero elements not identical to prevision"<<endl;}
 	if (row_ptr[ll-1]>nombre){cout<<"ERROR : number non zero elements in Hessian matrix with Dirichlet conditions !!! "<<row_ptr[ll-1]<<endl;;}


/*	CImg <double> test(taille,taille);    
	 test.fill(0); 
	 for (int i=0; i<taille; i++){ 
	 for (int l=row_ptr[i];l<row_ptr[i+1];l++){    
	 test(col_ind[l],i)=val[l];
     } 
	 } 
	 test.display("A"); 
	 (test-test.get_transpose()).display("At-A");
	 
	 CImg <double> valEigen(taille);
	 CImg <double> vecEigen(taille,taille);
	 test.symmetric_eigen(valEigen,vecEigen);
	 valEigen.display(); 
	 double pippo=0;
	 for (int i=0;i<taille;i++){pippo+=log(valEigen[i]);if (valEigen[i]*valEigen[i]<1E-6){cout<<"singular matrix det A =0 "<<endl;}}
	 cout<<"nombre de conditionnement "<<abs(valEigen[0]/valEigen[taille-1])<<endl;
	 cout<<"log det A (eigen)   "<<pippo<<endl;
	 
	*/
	/***************************************** determinant by incomplete LU factorization   ************************/
	logdetA=ILU_logDetA(taille,nombre,val,row_ptr,col_ind);
	
	
	/*************************************************************************************************************/
	delete [] val;delete [] col_ind;delete [] row_ptr;
	return logdetA;
	
}

double logdetA_Gen_Rob_BruhnAndAl(const CImg<double> &im_x,const CImg<double> &im_y,const CImg<double> &im_t,const CImg<double> data_out, const CImg<double> &lambda_S2, const CImg<double> &lambda_S2_cross,const CImgList <double> &z_right, const CImgList <double> &z_down, const CImgList <double> &z_rightDown, const CImgList <double> &z_rightUp,const CImgList <double> &z_t_right, const CImgList <double> &z_t_down, const CImgList <double> &z_t_rightDown, const CImgList <double> &z_t_rightUp,int scale, int lo, int nombre){
  int neta=1;
  return logdetA(im_x,im_y,im_t,data_out,lambda_S2,lambda_S2_cross,z_right,z_down,z_rightDown,z_rightUp,z_t_right,z_t_down,z_t_rightDown,z_t_rightUp,scale,neta,lo,nombre);
}

double logdetA_Gen_BruhnAndAl(const CImg<double> &im_x,const CImg<double> &im_y,const CImg<double> &im_t,const CImg<double> data_out, const CImg<double> &lambda_S2, const CImg<double> &lambda_S2_cross,int scale, int lo,int nombre){
  int neta=1;
  CImgList <double> z_tmp(lo-neta+1,im_x.width(),im_x.height());for (int k=0;k<=lo-neta;k++){z_tmp[k].fill(1.);} 
  CImgList <double> z_t_tmp(lo-neta+1,im_x.width(),im_x.height());for (int k=0;k<=lo-neta;k++){z_t_tmp[k].fill(1.);} 
  return logdetA(im_x,im_y,im_t,data_out,lambda_S2,lambda_S2_cross,z_tmp,z_tmp,z_tmp,z_tmp,z_t_tmp,z_t_tmp,z_t_tmp,z_t_tmp,scale,neta,lo,nombre);
}


	 
	/*************************************************************************************************************/

	/*************************************************************************************************************/
	/****************************Max evidence of Horn and Schunck beta and alpha parameters    *******************/
	/*************************************************************************************************************/

	/*************************************************************************************************************/


double evidence_betaHS(const CImg<double> &UVinc,const CImg<double> &im_x,const CImg<double> &im_y,const CImg<double> &im_t,const CImg<double> &data_out,const CImgList<double> &reg_out,double alpha,int nbIt,double tol,double s, bool periodic){
  double epsilon=0;	
  int nc=UVinc.width(); 
  int nl=UVinc.height();  
  int ncnl=nc*nl;
  int taille=ncnl*2;
  int nombre_cst=nc*nl;
  int nombre_lap;
  if (!periodic){nombre_lap=(int) (5*(nl-2)*(nc-2)+8*(nc-2)+8*(nl-2)+12);}
  else{nombre_lap=(int) 5*nl*nc;}
  int nombre=(int)(2*nombre_lap+2*nombre_cst);
  double *val=new double[nombre];
  int *col_ind=new int[nombre]; 
  int *row_ptr=new int[taille+1];
  double dataEnergy=DataEnergy(UVinc.get_slice(0),UVinc.get_slice(1),im_x.get_mul(im_x),im_y.get_mul(im_y),im_x.get_mul(im_y),
			       im_t.get_mul(im_x),im_t.get_mul(im_y),im_t.get_mul(im_t),data_out);
  fillingSparseHessian_A_HS(val,col_ind,row_ptr,im_x,im_y,data_out,reg_out,alpha,nombre, periodic);
  double trace=CGS_randomB_traceInvAA0(taille,nombre,val,row_ptr,col_ind,im_x.get_mul(im_x),im_x.get_mul(im_y),im_y.get_mul(im_y),data_out,nbIt,tol);
  double nominateur=(binarize(data_out,epsilon).sum()-trace);
  if (nominateur<0){cout<<"Error : negative beta variance ("<<binarize(data_out,epsilon).sum()<<" - "<<trace<<" < 0)"<<endl;}
  double denominateur=dataEnergy*2*s;
   delete [] val;delete [] col_ind;delete [] row_ptr;
   return nominateur/denominateur; 

}
double evidence_alphaHS(const CImg<double> &UV,const CImg<double> &im_x,const CImg<double> &im_y,const CImg<double> &im_t,const CImg<double> &data_out,const CImgList<double> &reg_out,double gamma,double beta,int nbIt,double tol,double s, bool periodic){

  int nc=UV.width();
  int nl=UV.height();
  int ncnl=nc*nl;
  int taille=ncnl*2;	 
  int nombre_cst=nc*nl;
  int nombre_lap;
  if (!periodic){nombre_lap=(int) (5*(nl-2)*(nc-2)+8*(nc-2)+8*(nl-2)+12);}
  else{nombre_lap=(int) 5*nl*nc;}
  int nombre=(int)(2*nombre_lap+2*nombre_cst);
  double *val=new double[nombre];
  int *col_ind=new int[nombre]; 
  int *row_ptr=new int[taille+1];
  fillingSparseHessian_A_HS(val,col_ind,row_ptr,im_x,im_y,data_out,reg_out,gamma,nombre, periodic);
  double priorEnergy=PriorEnergyHS_powK_2nd(UV.get_slice(0),UV.get_slice(1),reg_out,2., periodic);
  double trace=CGS_randomB_traceInvAAr(taille,nombre,nc,nl,val,row_ptr,col_ind,reg_out,nbIt,tol,periodic);
   double gamma_ML;
   //gamma_ML=gamma+0.5*(taille-gamma*(trace+s*2*beta*priorEnergy))/(trace+s*2*beta*priorEnergy); // newton raphson
   gamma_ML=(taille-gamma*trace)/(s*2*beta*priorEnergy);
  if (gamma_ML<0){gamma_ML=gamma;cout<<"ERROR : negative gamma !"<<endl;}
  return gamma_ML;

  }



double * evidence_alphaBetaAndTauHS_normalized(const CImg<double> &UVinc,const CImg<double> &UVtil,const CImg<double> &im_x,const CImg<double> &im_y,const CImg<double> &im_t,const CImg<double> &data_out,const CImgList<double> &reg_out,double alpha,double beta,int nbIt,double tol, double tau, bool periodic){
   double * estimateML =new double[3];
 double epsilon=0;	
  int nc=UVinc.width();
  int nl=UVinc.height();
  int ncnl=nc*nl;
  int taille=ncnl*2; 
  int nombre_cst=nc*nl;
  int nombre_lap;
  if (!periodic){nombre_lap=(int) (5*(nl-2)*(nc-2)+8*(nc-2)+8*(nl-2)+12);}
  else{nombre_lap=(int) 5*nl*nc;} 
  int nombre=(int)(2*nombre_lap+2*nombre_cst);
  double *val=new double[nombre];
  int *col_ind=new int[nombre];
  int *row_ptr=new int[taille+1];
  double dataEnergy=DataEnergy(UVinc.get_slice(0),UVinc.get_slice(1),im_x.get_mul(im_x),im_y.get_mul(im_y),im_x.get_mul(im_y),
			       im_t.get_mul(im_x),im_t.get_mul(im_y),im_t.get_mul(im_t),data_out);
  fillingSparseHessian_A_HS(val,col_ind,row_ptr,im_x,im_y,data_out,reg_out,alpha,nombre, periodic);
  CImg<double> x2(nc,nl);
  x2=im_x.get_mul(UVinc.get_slice(0))+im_y.get_mul(UVinc.get_slice(1))+im_t;x2=x2.get_mul(x2);
  double *trace=new double[4]; 
  trace=CGS_randomB_traceInvAA0Fx(taille,nombre,val,row_ptr,col_ind,im_x.get_mul(im_x),im_x.get_mul(im_y),im_y.get_mul(im_y),data_out,reg_out,x2,nbIt,tol,periodic);
 
  //beta
  double nominateur=(binarize(data_out,epsilon).sum()-trace[1]);
  double denominateur=dataEnergy*2;  
  estimateML[1]=nominateur/denominateur;
  if (nominateur<0){cout<<"Error : negative beta variance ("<<binarize(data_out,epsilon).sum()<<" - "<<trace[1]<<" < 0)"<<endl;estimateML[1]=beta;}

   //alpha 
  double priorEnergy=PriorEnergyHS_powK_2nd((UVinc+UVtil).get_slice(0),(UVinc+UVtil).get_slice(1), reg_out,2.,periodic);
   estimateML[0]=(taille-alpha*trace[0])/(2*estimateML[1]*priorEnergy);
   if (taille-alpha*trace[0]<0){cout<<"Error : negative gamma estimate ("<<taille-alpha*trace[0]<<" < 0)"<<endl;estimateML[0]=alpha;}
 
  //sigma
  double fTau, DfTau, aux=tau;
  fTau=-1*((estimateML[1]*x2.get_mul(x2).get_mul(data_out)).sum()+trace[2]-(binarize(data_out,epsilon).get_mul(x2)).sum());
  cout<<fTau<<" ";
  DfTau=(estimateML[1]*x2.get_mul(x2.get_mul(x2)).get_mul(data_out)).sum()+trace[3];
  aux-=0.25*fTau/DfTau;
  if (aux>=0){estimateML[2]=aux;}else{estimateML[2]=tau;cout<<"Error : negative sigma variance ("<<aux<<" < 0)"<<endl; }
  

   delete [] trace ;
   delete [] val;delete [] col_ind;delete [] row_ptr;
  return estimateML; 

}



double * evidence_alphaBetaAndTauHS_normalized_QuasiTV(const CImg<double> &UVinc,const CImg<double> &UVtil,const CImg<double> &im_x,const CImg<double> &im_y,const CImg<double> &im_t,const CImg<double> &data_out,const CImgList<double> &reg_out,double alpha,double beta,int nbIt,double tol, double tau, bool periodic){
   double * estimateML =new double[3];
 double epsilon=0;	
  int nc=UVinc.width();
  int nl=UVinc.height();
  int ncnl=nc*nl;
  int taille=ncnl*2; 
  int nombre_cst=nc*nl;
  int nombre_lap;
  if (!periodic){nombre_lap=(int) (5*(nl-2)*(nc-2)+8*(nc-2)+8*(nl-2)+12);}
  else{nombre_lap=(int) 5*nl*nc;} 
  int nombre=(int)(2*nombre_lap+2*nombre_cst);
  double *val=new double[nombre];
  int *col_ind=new int[nombre];
  int *row_ptr=new int[taille+1];
  double dataEnergy=DataEnergy(UVinc.get_slice(0),UVinc.get_slice(1),im_x.get_mul(im_x),im_y.get_mul(im_y),im_x.get_mul(im_y),
			       im_t.get_mul(im_x),im_t.get_mul(im_y),im_t.get_mul(im_t),data_out);
  fillingSparseHessian_A_HS(val,col_ind,row_ptr,im_x,im_y,data_out,reg_out,alpha,nombre, periodic);
  CImg<double> x2(nc,nl);
  CImg<double> a(nc,nl);
  CImg<double> b(nc,nl);
  CImg<double> a2(nc,nl);
  x2=im_x.get_mul(UVinc.get_slice(0))+im_y.get_mul(UVinc.get_slice(1))+im_t;x2=x2.get_mul(x2);
  a=(-4.*x2*tau).get_div(1.+4.*tau*tau*x2);
  a2=a.get_mul(a);
  b=(4.*x2.get_mul(4.*x2*tau*tau)-1.).get_div((1.+4.*tau*tau*x2).get_pow(1.5));
  double *trace=new double[4]; 
  trace=CGS_randomB_traceInvAA0Fx_QuasiTV(taille,nombre,val,row_ptr,col_ind,im_x.get_mul(im_x),im_x.get_mul(im_y),im_y.get_mul(im_y),data_out,reg_out,x2,tau,nbIt,tol,periodic);
 
  //beta
  double nominateur=(binarize(data_out,epsilon).sum()-trace[1]);
  double denominateur=dataEnergy*2;  
  estimateML[1]=nominateur/denominateur;
  if (nominateur<0){cout<<"Error : negative beta variance ("<<binarize(data_out,epsilon).sum()<<" - "<<trace[1]<<" < 0)"<<endl;estimateML[1]=beta;}

   //alpha 
  double priorEnergy=PriorEnergyHS_powK_2nd((UVinc+UVtil).get_slice(0),(UVinc+UVtil).get_slice(1), reg_out,2.,periodic);
   estimateML[0]=(taille-alpha*trace[0])/(2*estimateML[1]*priorEnergy);
   if (taille-alpha*trace[0]<0){cout<<"Error : negative gamma estimate ("<<taille-alpha*trace[0]<<" < 0)"<<endl;estimateML[0]=alpha;}
 
  //sigma
   double fTau, DfTau, aux=tau;
   fTau=(estimateML[1]*x2.get_mul(data_out).get_mul(a)).sum()-(binarize(data_out,epsilon).get_mul(a)).sum()+trace[2];
   DfTau=(estimateML[1]*x2.get_mul(data_out).get_mul(b.get_mul(data_out)+a2)).sum()-(binarize(data_out,epsilon).get_mul(data_out).get_mul(b)).sum()+trace[3];
   cout<<fTau<<" "<<-1*fTau/DfTau;
   aux-=0.25*fTau/DfTau;
   if (aux>=0){estimateML[2]=aux;}else{estimateML[2]=tau;cout<<"Error : negative sigma variance ("<<aux<<" < 0)"<<endl; }
  

   delete [] trace ;
   delete [] val;delete [] col_ind;delete [] row_ptr;
  return estimateML; 

}

double * evidence_alphaBetaAndTauDataAndRegHS_normalized(const CImg<double> &UVinc,const CImg<double> &UVtil,const CImg<double> &im_x,const CImg<double> &im_y,const CImg<double> &im_t,const CImg<double> &data_out,const CImgList<double> &reg_out,double alpha,double beta,int nbIt,double tol, double tau_d,double tau_r, bool periodic){
  double * estimateML =new double[4];
  double epsilon=0;	
  int nc=UVinc.width();
  int nl=UVinc.height();
  int ncnl=nc*nl;
  int taille=ncnl*2; 
  int nombre_cst=nc*nl;
  int nombre_lap;
  if (!periodic){nombre_lap=(int) (5*(nl-2)*(nc-2)+8*(nc-2)+8*(nl-2)+12);}
  else{nombre_lap=(int) 5*nl*nc;} 
  int nombre=(int)(2*nombre_lap+2*nombre_cst);
  double *val=new double[nombre];
  int *col_ind=new int[nombre];
  int *row_ptr=new int[taille+1];
  double dataEnergy=DataEnergy(UVinc.get_slice(0),UVinc.get_slice(1),im_x.get_mul(im_x),im_y.get_mul(im_y),im_x.get_mul(im_y),
			       im_t.get_mul(im_x),im_t.get_mul(im_y),im_t.get_mul(im_t),data_out);
  fillingSparseHessian_A_HS(val,col_ind,row_ptr,im_x,im_y,data_out,reg_out,alpha,nombre, periodic);
  CImg<double> x2(nc,nl);
  x2=im_x.get_mul(UVinc.get_slice(0))+im_y.get_mul(UVinc.get_slice(1))+im_t;x2=x2.get_mul(x2);
  double *trace=new double[6]; 
  trace=CGS_randomB_traceInvAA0ArFx(taille,nombre,val,row_ptr,col_ind,im_x.get_mul(im_x),im_x.get_mul(im_y),im_y.get_mul(im_y),data_out,reg_out,x2,UVinc+UVtil,nbIt,tol,periodic); 
 
  //beta
  double nominateur=(binarize(data_out,epsilon).sum()-trace[1]);
  double denominateur=dataEnergy*2;  
  estimateML[1]=nominateur/denominateur;
  if (nominateur<0){cout<<"Error : negative beta variance ("<<binarize(data_out,epsilon).sum()<<" - "<<trace[1]<<" < 0)"<<endl;estimateML[1]=beta;}

   //alpha 
  double priorEnergy=PriorEnergyHS_powK_2nd((UVinc+UVtil).get_slice(0),(UVinc+UVtil).get_slice(1), reg_out,2.,periodic);
  //estimateML[0]=alpha+0.5*(taille-alpha*(trace[0]+2*estimateML[1]*priorEnergy))/(trace[0]+2*estimateML[1]*priorEnergy); // newton raphson
  estimateML[0]=(taille-alpha*trace[0])/(2*estimateML[1]*priorEnergy);
  if (taille-alpha*trace[0]<0){cout<<"Error : negative gamma estimate ("<<taille-alpha*trace[0]<<" < 0)"<<endl;estimateML[0]=alpha;}
 
  //sigma_d
  double fTau, DfTau, aux=tau_d;
  fTau=-1*((estimateML[1]*x2.get_mul(x2).get_mul(data_out)).sum()+trace[2]-(binarize(data_out,epsilon).get_mul(x2)).sum());
  cout<<"grad_tau_d, dtau_d: "<<fTau<<" ";
  DfTau=(estimateML[1]*x2.get_mul(x2.get_mul(x2)).get_mul(data_out)).sum()+trace[3];
  cout<<-fTau/DfTau<<", ";
  aux-=0.25*fTau/DfTau;
   if (aux>=0){estimateML[2]=aux;}else{estimateML[2]=tau_d;cout<<"Error : negative sigma_d variance ("<<aux<<" < 0)"<<endl; }
  
  //sigma_r
  aux=tau_r;
  double priorEnergy_2=PriorEnergyHS_powK_1st((UVinc+UVtil).get_slice(0),(UVinc+UVtil).get_slice(1),2.,periodic);
  double priorEnergy_4=PriorEnergyHS_powK_1st((UVinc+UVtil).get_slice(0),(UVinc+UVtil).get_slice(1), reg_out,4,periodic);
  double priorEnergy_6=PriorEnergyHS_powK_1st((UVinc+UVtil).get_slice(0),(UVinc+UVtil).get_slice(1), reg_out,6,periodic);
  fTau=-1*estimateML[1]*estimateML[0]*priorEnergy_4+priorEnergy_2-estimateML[0]*trace[4];
  cout<<"grad_tau_r, dtau_r: "<<fTau<<" ";
  DfTau=estimateML[1]*estimateML[0]*priorEnergy_6+estimateML[0]*trace[5];
  cout<<-fTau/DfTau<<" "<<endl;;//<<-1*estimateML[1]*estimateML[0]*priorEnergy_4<<" +  "<<priorEnergy_2<<" +  "<<-1*estimateML[0]*trace[4]<<", ";
  //aux-=fTau/DfTau;
  aux-=0.25*fTau/DfTau;
   if (aux>=0){estimateML[3]=aux;}else{estimateML[3]=tau_r;cout<<"Error : negative sigma_r variance ("<<aux<<" < 0)"<<endl; }

   delete [] trace ;
   delete [] val;delete [] col_ind;delete [] row_ptr;
  return estimateML; 

}

double evidence_modelHS_Mackay(const CImg<double> &UVinc,const CImg<double> &UVtil,const CImg<double> &im_x,const CImg<double> &im_y,const CImg<double> &im_t,const CImg<double> &data_out,const CImgList<double> &reg_out,double beta,double gamma, double Avirer, bool periodic,int order){

	int nc=im_x.width();
	int nl=im_x.height();
	int ncnl=nc*nl;
	int taille=ncnl*2;
	int nombre_cst;	
	int nombre_lap;
	nombre_cst=nc*nl;
	if (!periodic){nombre_lap=(int) (5*(nl-2)*(nc-2)+8*(nc-2)+8*(nl-2)+12);}
	else{nombre_lap=(int) 5*nl*nc;}
	int nombre=(int)(2*nombre_lap+2*nombre_cst);
	double *val=new double[nombre];
	int *col_ind=new int[nombre];
	int *row_ptr=new int[taille+1];

	VECTOR_double B(taille,0.0);
	VECTOR_double X(taille,0.0);
	VECTOR_double AX(taille,0.0);
 
	CImg<double> IxIx(nc,nl);	
	CImg<double> IyIy(nc,nl);	
	CImg<double> IxIy(nc,nl);
	CImg<double> ItIx(nc,nl);
	CImg<double> ItIy(nc,nl);
	CImg<double> ItIt(nc,nl);
	IxIx=(im_x.get_mul(im_x));
	IyIy=(im_y.get_mul(im_y));
	IxIy=(im_x.get_mul(im_y));
	ItIx=(im_t.get_mul(im_x));
	ItIy=(im_t.get_mul(im_y));
	ItIt=(im_t.get_mul(im_t));	

	double minusLogEvidence;
	double dataEnergy,priorEnergy,logdetPost,minusLogOccam,minusLogOccam_part0,minusLogOccam_part1,minusLogOccam_part2,minusLogOccam_part3,minusLogOccam_part4;

 
	dataEnergy=beta*DataEnergy(UVinc.get_slice(0),UVinc.get_slice(1),IxIx,IyIy,IxIy,ItIx,ItIy,ItIt,data_out);

	if (order==1){priorEnergy=beta*gamma*PriorEnergyHS_powK_1st((UVinc+UVtil).get_slice(0),(UVinc+UVtil).get_slice(1),reg_out, 2.,periodic);}
	else {priorEnergy=beta*gamma*PriorEnergyHS_powK_2nd((UVinc+UVtil).get_slice(0),(UVinc+UVtil).get_slice(1),reg_out, 2.,periodic);}
	
	minusLogOccam_part0=-1*taille*log(gamma);

	fillingSparseHessian_A_HS(val,col_ind,row_ptr,im_x,im_y,data_out,reg_out,gamma,nombre,periodic);
	logdetPost=ILU_logDetA(taille,nombre,val,row_ptr,col_ind);
	//cout<<"log det  post="<<logdetPost<<endl;
	
	minusLogOccam_part1=binarize(data_out,0).sum()*(log(2*M_PI)-log(beta));
	minusLogOccam_part1+=-1*(treshold_minmax(data_out,0,1E30,1).get_log()).sum();
	
	minusLogOccam_part2=log(2*dataEnergy);

	minusLogOccam_part3=log(2*priorEnergy);
	
	minusLogOccam_part4=-1*((reg_out[0].get_log()).sum()+(reg_out[1].get_log()).sum());//cout<<"(part4="<<minusLogOccam_part4<<")"<<endl;

	minusLogOccam=2*priorEnergy+logdetPost+minusLogOccam_part0+minusLogOccam_part1+minusLogOccam_part2+minusLogOccam_part3+minusLogOccam_part4;
	minusLogEvidence=0.5*(2*dataEnergy+minusLogOccam); 
	cout<<"-log evidence = data energy + -log occam = "<<dataEnergy<<" + "<<0.5*minusLogOccam<<" = "<<minusLogEvidence<<endl;
	delete [] val;delete [] col_ind;delete [] row_ptr;
 	return minusLogEvidence;
}
 

